          CHANGELOG FOR EMULE
        http://emule-project.net
        ========================

eMule 0.50a
-----------------------
- Apr, 5. 2010        -
-----------------------
.: Added preferences.ini-only option "ExtraPreviewWithMenu" (eMule section) which makes eMule put the "Preview with" command into the root context menu rather than into the preview menu (only applies to extended controls with multiple preview programs set)
.: Added "Open preferences.ini" button to the extended options. Remember that you have to close eMule _before_ saving any changes if you want to edit any not preferences.ini-only settings
.: AICH hashs work properly in all collection types now

-----------------------
- Apr, 2. 2010        -
-----------------------
.: Added new ed2k link type: "ed2k://|search|[searchterm]|/" makes eMule start a search for the specified searchterm. Plugin for webbrowsers which make use of this will follow later
.: Fixed some minor bugs in the Kad graph
.: Fixed a possible bug with AICH recovery when downloading a searchresult which includes the AICH hash

eMule 0.50a BETA3
-----------------------
- Mar, 28. 2010       -
-----------------------
.: Keyboard shortcuts to switch the dialog work again in the transfer dialog
.: Fixed a small visual glitch in the tooltips of the webinterface
.: Fixed a issue regarding eMule deceiding if to trust an AICH hash on files which have no verified AICH has [tHeWiZaRdOfDoS]
.: Fixed minor issues with the exit commandline command and the multiple instances option [tHeWiZaRdOfDoS, leuk_he]

-----------------------
- Mar, 23. 2010       -
-----------------------
.: Fixed ed2k links not containing the AICH hash on several locations (ctrl+c, webserver, etc)
.: Fixed further bugs leading to crashes or glitches in the new toolbar
.: Fixed a possible crash problem with the new Win7 features
.: The Beta versioncheck will now point to a seperate website instead the standard versioncheck (which doesn't works for betas)

eMule 0.50a BETA2
-----------------------
- Mar, 19. 2010       -
-----------------------
.: Update MiniUPnPlib to the latest version
.: The download commands toolbar now handles closing by pressing the X while in floating mode properly
.: The icons of the download commands toolbar are now properly drawn gray if disabled on WinXP and older Windows versions

-----------------------
- Mar, 17. 2010       -
-----------------------
.: The new Windows7 taskbar features will no longer vanish when minimizing eMule to the system tray
.: Updated libpng to the latest version
.: The lables of the download commands toolbar are now properly adjusted immediately when switching to another language
.: The archive preview tab has now a context menu to update the contents as replacement for the "Update" button
.: Fixed a bug in handling part.met files which could cause corrupted parts if eMule paused the file due to insufficient diskspace
.: Fixed a small visual glitch when resizing the shared files list while the new tabs were hidden
.: fixed minor memleak in kad keyword storing [tHeWiZaRdOfDoS]

-----------------------
- Mar, 14. 2010       -
-----------------------
.: Fixed the background color of the new Kad graph if custom themes/colors are enabled
.: eMule now selects the default color of the system icon tray speedbar depending on the color of your taskbar icon area, to avoid show a dark/bright bar on a dark/bright background
.: Fixed a crashbug in the new download commands toolbar (this bug was responsible for nearly all crashes you might have seen in Beta1).
.: Active searches are now automatically shown in the new Kad graph by default and eMule remembers the setting (can be siwtched in the contextmenu of the graph)
.: Fixed a small bug with itemdeletion when closing eMule [JvA]
.: Fixed a small bug regarding Kad search tolerance [Famerlor]

eMule 0.50a BETA1
-----------------------
- Mar, 8. 2010        -
-----------------------
.: Fixed a bug which caused the "Add files to download in paused mode" otpion to not work properly in all cases
.: Fixed a visual glitch on taksbar notifiers when using the Aero theme [gureedo]

-----------------------
- Mar, 3. 2010        -
-----------------------
.: Added Windows 7 taskbar goodies:
   - global progress bar in the eMule taskbar button, progress colors: green when downloading, red when a download is errorous, yellow otherwise
   - Taskbar Buttons: when hovering over the eMule taskbar button (connect/disconnect/throttle/unthrottle/open preferences)
   - Overlay icon:    Overlay icon on the eMule taskbar button indicating active up- and downloads (disabled by default, enable by ini entry "ShowUpDownIconInTaskbar=1").

-----------------------
- Mar, 1. 2010        -
-----------------------
.: Tweaked uploadcode to significantly increase the possible uploadspeed per slot especially on LANs, making eMule more suitable for those
.: The number of maximal open upload slots has been decreased to 100
.: Fixed a bug which caused the "Add files to download in paused mode" otpion to not work properly in all cases

-----------------------
- Feb, 28. 2010       -
-----------------------
.: Fixed a problem with the sharedfiles list when deleting a shared files [dolphinX]
.: Fixed minor possible memory/ressource leak in the archive recovery and ipfilter [dolphinX]
.: Fixed possible problem when wrong incoming directory due to categories in certain cases [dolphinX]

-----------------------
- Feb, 19. 2010       -
-----------------------
.: Fixed a bug in Kad which would not enforce the search tolerance in certain cases
.: Changed Kad to work better in small LANs. If Kad detects it is running on a LAN (only LAN IPs in the routing table), it will assume beeing open and not behind a NAT/Router without trying to verfiy (which would fail in a small LAN),
        and also doesn't enforces several security features like flood detection for LAN IPs. Now even a small Kad LAN of 2 nodes works well without any setup issues
(To create such a Kad LAN, make sure all clients have Options->Extended->"Filter server and client LAN IPS" disabled, delete the existing nodes.dat if necessary, go to the Kad dialog and enter the IP+Port of one other client (which is either connected or in connecting mode for Kad) to the bootstrap box - done)

-----------------------
- Jan, 25. 2010       -
-----------------------
.: The connection wizzard is no longer shown after finishing the first start wizzard (it's deprecated)
.: The first start wizzard is only shown on first starts and no longer after updates

-----------------------
- Jan, 21. 2010       -
-----------------------
.: Added a new graph to the Kad window, which lets you watch each Kad lookup in detail. For non-Devs this is just for fun, you don't need to worry about anything shown there. A detailed explanation of the graph can be found in the onlinehelp.
.: Added "Automatically show active searches" option to the context menu of the new graph which lets it switch to active lookups automatically (instead having to select it in the list). Now you can watch Kad working for hours without a click! :)

-----------------------
- Jan, 12. 2010       -
-----------------------
.: Added a new dockable toolbar to the transfer dialog. The buttons resemble the context menu options, but making them accessible easier and faster. The toolbar can be removed by right clicking on it and shown again by selecting context menue option of the downloadlist

-----------------------
- Jan, 10. 2010       -
-----------------------
.: The context menu in of the downloadlist allows now directly assign a file to a new category (instead of having to create it separately first)
.: The "Unassign" category context menu entry is now only available if a file actually has a category

-----------------------
- Dec, 7. 2009        -
-----------------------
.: Fixed missing setting saving after automatic adapting incoming folders of categories due to changed main incoming folder
.: Fixed a bug with overwriting the nodes.dat on times we actually don't want to write it [Nissenice]
.: Added a quick intermediate fix to make certain Kad lookups more reliable, improving the (search/source-) results in some cases [based on research from http://www-users.cs.umn.edu/~hopper/kad.pdf]

-----------------------
- Nov, 28. 2009       -
-----------------------
.: Switched the eMule fileidentifiers from ED2k-Hash + Size to ED2k-Hash + AICH-Hash + Size. This means eMule is now using two hashing algorithms combined (based on MD4 and SHA1) to verify if a received part (and eventually the comlete files) is not corrupt
   This change is necessary due to weaknesses in the MD4 algorithm and enables eMule to make sure to never complete a corrupt files for the next decade
   All changes are backwards compatible, so no clients or files will be exluded from the network
.: AICH part hashsets are build out of existing AICH recovery hashsets, no rehashing is done
.: AICH verification is enabled when using an ed2k link with included AICH hash, or when searching and downloading a file from Kad when certain requirements are met (this will only start to work once the majority of nodes update)
.: The AICH hash can be seen in the search results list for kad searches if available
.: ed2k links can no longer be created without the AICH Hash, except if it is not available. ed2k links without AICH hash are considered deprecated, but are still accepted by eMule for now

-----------------------
- Nov, 15. 2009       -
-----------------------
.: The shared files list now shows files in root directories properly [dolphinX]
.: Fixed a bug with determining if the filesystem can handle large files when using categories [dolphinX]
.: Added preferences.ini-only option "KeepUnavailableFixedSharedDirs" ("eMule"-Section) which lets eMule keep shared directories on fixed drives even if they are not found anymore
.: Fixed minor memleak on kad searches [tHeWiZaRdOfDoS]
-----------------------
- Oct, 13. 2009       -
-----------------------
.: Added preferences.ini-only option "ForceSpeedsToKB" ("eMule"-Section), which will make eMule display all speed values in KB/s (instead of B/s to TB/s depending on the speed)

-----------------------
- Aug, 7. 2009        -
-----------------------
.: The shared files dialog has now a tab selector, letting you choose to view the statistics,(reduced versions of) the content, ed2k-link or metadata info for the selected file(s)
.: The statistics page on in the shared files dialog also has the following new entries: Popularity rank (ranking all your shared files based on Requests), On Queue (clients on queue for the selected file) and Uploading (current bandwidth used to upload the selected file)
.: The new tabs in the shared files dialog can be closed or restored by an arrow button on the right side

-----------------------
- Aug, 3. 2009        -
-----------------------
.: Fixed possible resource leaks in ZIP file decompression [tHeWiZaRdOfDoS]
.: Fixed sorting bug in Shared Files window [moloko+]

-----------------------
- Aug, 2. 2009        -
-----------------------
.: Fixed bug with downloading files via the built-in webserver [Stulle]
.: Fixed double/single click behaviour in search results window [tHeWiZaRdOfDoS]
.: Fixed bug in user hash validation [ilmira]
.: Fixed bug with space characters in ED2K URLs [moloko+]

-----------------------
- Jul, 25. 2009       -
-----------------------
.: Fixed a bug which made search tabs in certain cases invisible after you closed one

-----------------------
- Jul, 20. 2009       -
-----------------------
.: Cleand up options dialog a bit:
   The following settings have been removed and are now preferences.ini-only: "BeepOnError", "DontRecreateStatGraphsOnResize", "UpdateQueueListPref", "MessageFromValidSourcesOnly" (Section "eMule") and "EnabledDeprecated" (section "PeerCache")
.: The exit conformation messagebox has now a "Don't ask me again" option
.: Added "Pause on when preview possible" option to the downloadlist context menu. Only visible when "advanced mode controls" is enabled

-----------------------
- Jul, 09. 2009       -
-----------------------
.: Improved storing AICH hashsets after a download has finished - should be much faster now if you share many files
.: Sparse files are available on Windows7 again, Vista stays the only version were they are disabled

-----------------------
- Jun, 12. 2009       -
-----------------------
.: Added basic checks and user warnings for wrong operator usage (like using OR on the first keyword) in Kad. Earlier version just delivered wrong/incomplete results in such cases.

-----------------------
- Jun, 10. 2009       -
-----------------------
.: Fixed a bug in Kad with setting the proper searchkeywords when searching for exact phrases with quotes
.: Fixed a bug with rearranging quoted keywords on kad searches

-----------------------
- Jun, 2. 2009        -
-----------------------
.: Kad1 is no longer supported and we will no longer answer or request any packets from Kad1 nodes (the last eMule Kad1 version was release about 4 years ago)

-----------------------
- Mar - May 2009      -
-----------------------
.: eMule Summer of Non-Code :)

eMule 0.49c
-----------------------
- Feb, 18. 2009       -
-----------------------
.: Fixed a minor GUI drawing issue in the transfer window [dolphinX]
.: Added GUI name references to some more Kad queries [tHeWiZaRdOfDoS]
.: Added sanity check for rare issue seen in crashdumps concerning SourceExchange responses
.: Increased the UDP-Socket buffer to avoid packetloss

-----------------------
- Feb, 15. 2009       -
-----------------------
.: Fixed the following BETA bugs:
- Popups on the shared files list were not working
- The shared files count in the GUI wasn't always accurate
- Resolved shell links had some issues, preventing them from getting shared
- The GUI wasn't always properly updated when deleting a file in the shared files window

eMule 0.49c BETA2
-----------------------
- Feb, 11. 2009       -
-----------------------
.: Fixed a BETA bug in the new part.met recovery function

-----------------------
- Feb, 10. 2009       -
-----------------------
.: Resolve shared shell links has now its own option in the extend dialog instead beeing a preferences.ini only option
.: Added the preferences.ini only option "FileBufferTimeLimit" ("eMule" section) which lets you set the maximum seconds before flushing the buffer of downloading files (default 60)

-----------------------
- Feb, 9. 2009        -
-----------------------
.: When another client requests to view your shared files and directories (and you allow it), eMule will now attach only the directory names (or relative paths if it is a shared subdir) instead the full path for privacy reasons
.: Fixed a BETA bug which caused eMule to not send single shared files when answering view shared files requests

-----------------------
- Feb, 8. 2009        -
-----------------------
.: On a fresh eMule installation, several less important list columns are now hidden by default to avoid overloading the interface
.: Fixed some BETA bugs with creating collections
.: Slightly increased the max. button size of the maintoolbar
.: You can no longer share single files within unshareable directories (like your temp dir)

-----------------------
- Feb, 7. 2009        -
-----------------------
.: Fixed a BETA bug which made eMule ignore the longest keyword on server searches
.: Added sanity checks for some problems seen in crashdumps when sending responses
.: Added sanity range check for preferences.ini only option: tcp obfuscation padding length

eMule 0.49c BETA1
-----------------------
- Feb, 4. 2009        -
-----------------------
.: Dates shown in the download list have their own time format setting ("DateTimeFormat4Lists" in preferences.ini) which is by default more compact than the old one
.: Added a column to the download list which shows the date when the download was started

-----------------------
- Feb, 2. 2009        -
-----------------------
.: Kad routing query contacts are checked against the routing table
.: Kad no longer allows more than 2 IPs from the same subnet within one routing query reply (except on LANs)
.: Fixed small bug in the uploadthrottler [tHeWiZaRdOfDoS]

-----------------------
- Jan, 27. 2009       -
-----------------------
.: The Kad UDP firewalltest now asks several clients for its external port, avoiding to get a wrong "Open" state on NATs which change the source port on each request but behave like a Full-Cone otherwise
.: Kad now rechecks incoming search results against the filters used for a search and drops all results which fail (which should only happen for buggy clients and spam results)

-----------------------
- Jan, 25. 2009       -
-----------------------
.: When corrupted part.met files are detected, eMule now automatically tries to use the part.met.bak files instead
.: Some data (like the AICH hashset, statistics, metadata etc) from known/downloaded files which were not shared within the last month now gets purged to save ressources and avoid an unlimited growth of the known.met files
   (the first purge will be done one month after upgrading, if you have "Remember downloaded files" disabled all unshared files are completely deleted right away so this change would have no further effect)
.: If you want to avoid this purging for some reason you can put "PartiallyPurgeOldKnownFiles=0" in the "eMule" section of your preferences.ini

-----------------------
- Jan, 20. 2009       -
-----------------------
.: When sorting lists for file types, eMule now further sorts by extension when the filetype is the equal

-----------------------
- Jan, 11. 2009       -
-----------------------
: On simple search queries Kad now rearrenges the used keywords itself and uses the longest keyword to determine which node to ask. This reduces the search load on common used keyword nodes like "and", makes such keyword a less viable target to attackers and allows users to do a search which begina with a short keyword like "An eMule"
.: You can deactivate this by putting "RearrangeKadSearchKeywords=0" into the "eMule" section of the preferences.in (there isn't much reason to do so for normal users however)

-----------------------
- Jan, 10. 2009       -
-----------------------
.: You can now also share single file and directories by Drag&Drop - simply drag them from (for example) the Windows Explorer into your Shared Files list
.: You can now share and unshare single files in the shared files window by chking/unchecking the files in the "All directories" tree. Downloading files and files in the incoming directory cannot be unshared
   (first one is required for the network  the second one is for consistency as the incoming dir is not handled as optional shared dir, therefore not marked in the tree as shared which again would make it pretty hard to find it to reshare any excluded files)
.: Kad file/source search answers now try to avoid using fragmented packets, making it more compatible to zealous firewalls routers which block those (effect increases as more nodes update to this version)

-----------------------
- Jan, 5. 2009       -
-----------------------
.: Fixed a possible crash in the (minilib) UPnP implementation
.: The Webinterface port can now also be forwarded by UPnP (Options->Webinterface)
.: The UPnP mappings are checked and refreshed if needed before Kad firewallchecks, after waking up from suspend and on smart lowid detection when connecting to servers

-----------------------
- Jan, 3. 2009       -
-----------------------
.: The allowed comment size has been increased to 128 characters
.: Fixed a bug which made the download list use the wrong text color in some cases, mostly noticed on special windows themes

-----------------------
- Dec, 22. 2008       -
-----------------------
.: Added support for Windows 'Heap Corruption Detection' security feature (Windows Vista)
.: Added support for Windows 'Address Space Layout Randomization' security feature (Windows Vista)

-----------------------
- Dec, 21. 2008       -
-----------------------
.: Added support for preview the content of ISO files. (file details->content)
   Reads the content of ISO9660 and Joliet images. (no UDF support)
.: Made sure a received Kad routing answer doesn't contain more contacts than requested [Xin Sun]

-----------------------
- Dec, 19. 2008       -
-----------------------
.: Added support for Windows 'Data Execution Prevention' security feature (Windows XP SP2 / Windows Vista)
.: Added support for Windows 'Exception Handling Protection' security feature (Windows XP SP2 / Windows Vista)

-----------------------
- Oct, 22. 2008       -
-----------------------
.: Added: Crash dump files are created in the 'config' directory. [thx tHeWiZaRdOfDoS]
.: Fixed a flaw which caused too few randomness when generating a new ed2k userhash [godlaugh2007]

-----------------------
- Oct, 21. 2008       -
-----------------------
.: Added showing of watermark images to listviews (see "LvBkImg" entries in "Template.eMuleSkin.ini")

-----------------------
- Oct, 18. 2008       -
-----------------------
.: Unified drawing of multiple selected items in all listviews.
.: Several optimizations in listview drawing.
.: Added drag image for files in Transfers window (used when dragging selected items onto a category tab).
.: Fixed showing of tooltips for multiple selected items in Server and Search window.

-----------------------
- Oct, 11. 2008       -
-----------------------
.: Added auto-sizezing of column widths to all list views (double clicking on column divider will size the column width appropriatly)
.: Added label tips for partially visible sub items in all list views.
.: Added default sort orders to list views in Transfers window.
.: Added list view search functions for sub items.
.: Fixed sorting bug in File Name dialog.

-----------------------
- Sep, 27. 2008       -
-----------------------
.: Added support for DVR-MS files to "Content" page of File Details dialog and published meta data.
.: Minor change in auto-sizing controls of Search Parameters pane.
.: Added reading of meta data for WAV files to "Content" page of File Details dialog.
.: Added publishing of ED2K specific meta data for WAV and WMA files.
.: Added columns for ED2K meta data to Shared Files window.

-----------------------
- Sep, 23. 2008       -
-----------------------
.: Added Options->Extended->Resolve shell links which lets eMule share 'linked' files (Windows Explorer shortcuts). This way one can also share single files within unshared directories.
.: Added reading of meta data for Windows Media files to "Content" page of File Details dialog.

-----------------------
- Sep, 14. 2008       -
-----------------------
.: Added yet another method to determine whether the MediaInfo library is installed.
.: Added support for multi-user configurations for Win9X/WinME/WinNT (requires at least IE5).
.: Added support for previewing self extracting RAR archives.
.: Fixed broken ED2K link and eMule Collection file registry functions for Win98/WinME/WinNT.

-----------------------
- Sep, 13. 2008       -
-----------------------
.: Fixed a resizing bug with the main toolbar under Win98.
.: Fixed message box contents for downloading a proper version of DBGHELP.DLL for Win9x/WinME/Win2000.
.: Fixed a crash with deleting completed or shared files under Win98.
.: Added: Downloaded files are marked in the same way as by 'Internet Explorer' which leads to showing a warning message from 'Windows' when opening potential malicious files (for Windows XP SP2 or later).
.: Added: Opening DRM protected files shows a warning message to prevent accidental opening of a web browser and navigating to malicious sites.

-----------------------
- Sep, 11. 2008       -
-----------------------
.: Fixed bug with missing update for filter text on changing the language [JvA]
.: (Win98) Fixed bug with default search file type setting

-----------------------
- Sep,  4. 2008       -
-----------------------
.: Added new browse file/directory buttons to property pages in Options dialog.

-----------------------
- Sep,  2. 2008       -
-----------------------
.: Fixed some redrawing/resizing problems and reduced flickering in several main eMule windows.

-----------------------
- Sep,  1. 2008       -
-----------------------
.: Fixed bugs with file tooltips for Win98/Win2000.
.: Fixed a problem with corrupt stored search results [George1]

-----------------------
- Aug, 30. 2008       -
-----------------------
.: Fixed: It was possible to add eMule installation folder(s) to the shared files list when using the directory tree control in the Shared Files window.
.: Fixed a bug with disk space statistics for newly added downloads [fox88]
.: Fixed some potential compatibility problems with Windows NT 4.0.
.: Fixed problem with some missing icons under Win98.

-----------------------
- Aug, 24. 2008       -
-----------------------
.: Fixed: Some Unicode strings where not stored correctly in meta data for part files.
.: Fixed some possible Unicode issues in Kad search expressions.
.: Removed the "Search with Unicode" search option - searches are always with Unicode.
.: Removed support for *.met file backward compatibility with non-Unicode eMule versions.
.: Removed support for the "SetSystemACP" setting in preferences.ini.
.: Added support for detecting if the MediaInfo library (http://mediainfo.sourceforge.net/) is installed on the system and automatically using it within the "Content" page for part/shared files.
.: Updated Kad Unicode mapping table for supporting current Unicode standard used by Vista.

-----------------------
- Aug, 16. 2008       -
-----------------------
.: Fixed: Some Unicode strings where not stored correctly in search spam filter.

-----------------------
- Aug, 15. 2008       -
-----------------------
.: Added a NT-volume info cache to speed up handling of shared directories on non-fixed drives.
.: Fixed: With certain code pages some Unicode characters where not stored correctly in *.met files [Borschtsch]
.: Fixed: Some Unicode strings where not stored correctly in meta data for shared files.

-----------------------
- Aug, 11. 2008       -
-----------------------
.: Changed location for "downloads.txt" to eMule-config folder.

-----------------------
- Aug, 10. 2008       -
-----------------------
.: Added sorting of entries in "Shared Directories" and "Incoming Files" section of "Shared Files" tree view.
.: Added showing of the parent folder for entries in "Shared Directories" and "Incoming Files" section of "Shared Files" tree view.
.: Added showing of 'not connected' shared directories to "Shared Directories" and "Incoming Files" section of "Shared Files" tree view.
.: Added keeping of shared directories which are 'not connected' when starting eMule.
.: Added populating of a warning icon overlay to "Shared Directories" and "Incoming Files" section of "Shared Files" tree view to indicate that there is at least one directory in that folder which is 'not connected'.
.: Added verifying of the 'connected' state for all shared directories when updating the "Shared Files" tree view by using the 'Reload' button.

-----------------------
- Aug, 9. 2008        -
-----------------------
.: Fixed enablement of Start/Cancel button in Search Window for closed Kad searches.
.: Fixed invisible gripper control in Transfer Window.
.: Fixed standard Windows Property Sheet shortcuts in Options dialog.
.: Fixed several unlikely to happen but theoretically though possibles crashes.
.: Removed restrictions for sharing drives 'A:' and 'B:'.

eMule 0.49b
-----------------------
- Jul, 31. 2008       -
-----------------------
.: Fixed some rare possible crashes

eMule 0.49b BETA2
-----------------------
- Jul, 28. 2008       -
-----------------------
.: Added deleting of single entries from AutoComplete drop down lists by pressing the DEL key.
.: Added a new search method option "Automatic" which lets eMule choose which search method to use. eMule will select either Servers (Local) or Kad, based on which network we are connected to and some other indicators if connected to both networks.
.: Removed a general exception handler for the Beta version. This means eMule crashes instead of ignoring unexpected errors, which however is needed so we actually can find such bugs (if any exist) in the crashdumps.

-----------------------
- Jul, 26. 2008       -
-----------------------
.: Implemented a special nodes.dat version, which is more suited for mass distribution without causing significant additional traffic for the included nodes. This hopefully allows us to add a nodes.dat to the installer, so that new user can connect to Kad without having to connect to servers or downloading a nodes.dat themself

-----------------------
- Jul, 19. 2008       -
-----------------------
.: Implemented an alternate method to estimate the total user count in the Kad network, which is not based on our local routing table. Its experimental and only shown in the network dialog (double click the world icon in the status bar)
.: Adjusted the displaying of the user count by not showing numbers for a network we are not connected to

-----------------------
- Jul, 14. 2008       -
-----------------------
.: Fixed a minor bug with kad obfuscation when answering unbofuscated hello-requests
.: Made sure that only one challenge to verify a contact is sent at a time to the same IP

eMule 0.49b BETA1
-----------------------
- Jul, 11. 2008       -
-----------------------
.: Added MiniUPnPLib as additional UPnP implementation, the current Windows service based implementation is used as fallback. This will hopefully make eMule's UPnP compatible to most available routers. [miniupnplib by Thomas Bernard, Test & Suggestion: leuk_he]
.: A specific UPnP implementation can be disabled by adding "DisableMiniUPNPLibImpl=1" or "DisableWinServImpl=1" into the "UPnP" section of the preferences.ini

-----------------------
- Jul, 5. 2008       -
-----------------------
.: When reading a nodes.dat without any verified contacts (possible an old file version), eMule will assume all contacts to be verified to avoid slowing down the connecting process
.: Project files for VS2005 and VS2008 have been added, however the official eMule is still developed and compiled on VS2003

-----------------------
- Jun, 27. 2008       -
-----------------------
.: Several changes were made to Kad in order to defy routing attacks researched by University of Minnesota guys [Peng Wang, James Tyra, Eric Chan-Tin, Tyson Malchow, Denis Foo Kune, Nicholas Hopper, Yongdae Kim], in particular:
.: Kad contacts will only be able to update themself in others routing tables if they provide the proper key (supported by 0.49a+ nodes) in order to make it impossible to hijack them
.: Kad uses now a three-way-handshake (or for older version a similar check) for new contacts, making sure they do not use a spoofed IP
.: Unverified contacts are not used for routing tasks and a marked with a special icon in the GUI

-----------------------
- Jun, 22. 2008       -
-----------------------
.: Fixed: Shared Files window splitter did not properly save/restore position.
.: Did first small step in dropping Kad1 support by not probing unknown Kad contacts for Kad1 anymore to save overhead. Kad1 clients will nevertheless still be work for now.
.: Fixed a bug which let Kad sometimes assume a Kad2 contact to be Kad1 after probing for both versions

-----------------------
- Jun, 18. 2008       -
-----------------------
.: Fixed: Memory leak in context menus.
.: Added: Vista styles for context menus.

-----------------------
- Jun, 12. 2008       -
-----------------------
.: Fixed: Pressing ESC in Shared Files window filter destroyed the entire window.

-----------------------
- Jun, 10. 2008        -
-----------------------
.: Added additional sanitize checks to make sure eMule never writes downloaded data into an already completed part
.: Optimized the Kad packettracking code to only tack packets which we check later, to save ressources

-----------------------
- Jun, 9. 2008        -
-----------------------
.: Fixed 100% CPU usage bug with tooltips in Statistics Graphs.
.: Added: Tooltip in Statistics Graphs show the Y-value.
.: Kad no longer tries to add UDP firewalled (and therefore mostly unreachable) nodes into its routing table, reducing overhead and increasing reliability [Idea: Netfinity]
.: Kad tries to determine the overall ration of firewalled clients in the Kad network and shows them in the statistics tree. This will only work if you are not firewalled yourself and know enough 0.49b+ nodes
.: When calculating the total user count, Kad now uses (if available) the real number of firewalled clients for the calculation instead a fixed value. This will take more effect when 0.49+ nodes become common
         
-----------------------
- Jun, 5. 2008        -
-----------------------
.: The "Handle eD2k-Links" button now also works properly with Vista's UAC enabled

-----------------------
- May, 31. 2008       -
-----------------------
.: Added: Unshare context menu entries for directories within the virtual "Shared Directories" folder.

-----------------------
- May, 28. 2008       -
-----------------------
.: Added: Vista themes for all owner drawn tab controls.
.: Added: Vista themes for category selector controls.
        
-----------------------
- May, 25. 2008       -
-----------------------
.: Fixed main toolbar redrawing problems under Vista.
.: Reworked connecting code, fixing some minor and some major bugs, including a possible loop in unreachable DirectCallback sources
        
-----------------------
- May, 19. 2008       -
-----------------------
.: Added new close icons for closeable tab controls.
.: Kad now ignores multiple IDs pointing to one IP in routing request answers 

-----------------------
- May, 18. 2008       -
-----------------------
.: Fixed: Tab controls were not sized correctly on certain text contents.        

-----------------------
- May, 17. 2008       -
-----------------------
.: Fixed: Category tabs in Transfers window did not show correct default text color.
.: Fixed: Category properties dialog did not always show the correct (default) category color.
.: Added: Hot tracking effects for Vista themes for all (owner drawn) tab controls.

-----------------------
- May, 12. 2008       -
-----------------------
.: Fixed: Tooltips did not show correctly with Vista Aero theme.


0.49a
-----------------------
- May, 8. 2008        -
-----------------------
.: If extended controls are enabled (and if available) Kad search results show the amount of known unique publishers for a file in parentheses in the availability column (this isn't equal to sources, but it is a bit more trustworthy indicator how common a file is).
.: Updated CxImage lib to the latest version (6.0), fixes some image processing vulnability (low risk for eMule) [reported: Steve Manzuik/Juniper Networks]
.: Fixed Unicode issue in stored and loading searches
.: DirectCallback sources are now properly added to and checked against the deadsource list 

0.49a BETA3
-----------------------
- May, 5. 2008        -
-----------------------
.: Made sure to always use the intern UDP port if both (intern and extern) ports succeed in the firewall test
.: Control chars are now filtered out of ed2k-links / received filenames [eklmn]
.: Fixed a small bug with handling removed category directories on startup [tHeWiZaRdOfDoS]
.: Changed installer to set the currently used shared usage setting as default if available

-----------------------
- May, 3. 2008        -
-----------------------
.: Fixed another bug in the new UDP firewalltest, causing it to fail for results on the extern UDP port and for unreachable clients
.: Captchas can consist of numbers now too (except 0)
.: Fixed a smaller issue with finding and connecting to a buddy
.: Buddy search interval has been reduced, to increase the chance to find a buddy without waiting too long

-----------------------
- May, 1. 2008        -
-----------------------
.: Changed the Crypt functions a bit for faster processing [netfinity]

0.49a BETA2
-----------------------
- Apr, 29. 2008       -
-----------------------
.: Fixed some rare bug which could cause rerequesting already transferred (buffered) data [tHeWiZaRdOfDoS]
.: Tweaked UPnP a bit to support some more routers [leuk_he]
.: Updated libpng to the most current version 1.2.27

-----------------------
- Apr, 27. 2008       -
-----------------------
.: Changed the kad tcp firewalltest protocol to make it possible to archive the tcp open state if the UDP port is firewalled 
.: Each dialog (kad, server, etc) has now its own "doorway" helptopic which eMule shows when pressing F1 or the Helpbutton, instead of only calling the helpindex

-----------------------
- Apr, 23. 2008       -
-----------------------
.: Fixed two bugs in the new kad firewalltesting which may lead to wrong results [tHeWiZaRdOfDoS]
.: eMule now supports ed2k-links for downloading the nodes.dat from an URL. A link to a nodes.dat should look this way: ed2k://|nodeslist|http://domain/nodes.dat|/
.: Fixed two minor display bugs realted to the waiting queue and the requests statistics for files [tHeWiZaRdOfDoS]

-----------------------
- Apr, 20. 2008       -
-----------------------
.: Loading stored kad keywords and sources has been moved into a seperate thread to avoid interface lockups, while the data is loading
.: Kad (tcp)firewalltest and buddy tcp connection now properly support protocol obfuscation too, on require obfuscation setting those connections (and therefore its functionality) didn't worked before

-----------------------
- Apr, 15. 2008       -
-----------------------
.: Ctrl+W now closes the active searchtab in the search dialog

0.49a BETA1        
-----------------------
- Apr, 12. 2008      -
-----------------------
.: Beta versions now create a small test text file which is shared by eMule to help us debugging protocol changes (esp Kad). On exit this file is deleted
.: Fixed a bug with the "Open Directory" menuitem in the shared files window [Stulle]

-----------------------
- Apr, 11. 2008       -
-----------------------
.: Added the obfuscation setting to the First Time wizard and removed the full chunk upload setting instead
.: Disabled peercache downloads by default (deprecated)
.: Added a Beta nagging dialog

-----------------------
- Apr, 6. 2008       -
-----------------------
.: Fixed several bugs in the new Kad firewall testing, obfuscation and direct callback functions

-----------------------
- Mar, 30. 2008       -
-----------------------
.: eMule is now aware of windows standby modes and reconnects after waking up [MorphXt]

-----------------------
- Mar, 18. 2008       -
-----------------------
.: Fixed: File tooltips used wrong font sizes when using customized Windows metrics.
.: Added: Support for using Windows default fonts for listview and treeview controls in eMule's main windows. This way one can specify larger fonts for almost all eMule lists via the Windows System Metrics. Specify "UseSystemFontForMainControls=1" in "preferences.ini" to enable.
.: Fixed: Shared directory treeview control lost icons after Windows System settings were changed.
.: Fixed: Wrong font mapping for some GUI elements in non-Western locales.

-----------------------
- Mar, 17. 2008       -
-----------------------
.: Fixed: Shared Files list did not show focus rectangle for listview items.

-----------------------
- Mar, 16. 2008       -
-----------------------
.: Fixed: "Search related Files" context menu entry in search results pane was not properly enabled/disabled [Tuxman]
.: Fixed: Memory corruption for column properties in WebServer [tHeWiZaRdOfDoS]
.: Fixed: Normalized search labels in WebServer [ducho]
.: Fixed: Some search results where still shown after invoking 'Close All Search Results' [bengarchy]
.: Fixed: Enabling/Disabling the "Queued Clients" and "Known Clients" lists did not always fill/clear the list views [Xman]
.: Fixed: Toolbars in Transfere window were not showing tooltips after enabling/disabling "Queued Clients" and/or "Known Clients".

-----------------------
- Mar, 15. 2008       -
-----------------------
.: Fixed some GDI resouce leaks. [Rapid_Mule]
.: Fxied a minor possible bug in creating random numbers [leuk_he]
.: Fxied a bug in the new store searches function [netfinity]

-----------------------
- Feb, 26. 2008       -
-----------------------
.: When deleting more than 50 files the first 50 names are shown in the confirmation dialog [tHeWiZaRdOfDoS]
.: Fixed a bug in finding the senders of corrupt data which may lead to false positives [DavidXanatos]

-----------------------
- Feb, 10. 2008       -
-----------------------
.: Kad will now enforce certain limits when adding new contacts to the routing table: No more than 1 KadNode per IP, 2 similar KadNodes (same bin) from a /24 network and max 10 different KadNodes from a /24 network are allowed. This is supposed to make routing attacks against kad more difficult / resource-intensive
You can still run more than one kad client from a single IP without any problems, they just don't become part of the internal kad routing but still work without any limitations.

-----------------------
- Feb, 3. 2008        -
-----------------------
.: The download comments dialog has now a direct possibility to edit the comment spam filter, changes are instantly applied to all existing comments
.: Clients which sent comments which get filtered by the comment spam filter are now treated like message spammers (banned)
.: The ed2k: in ed2k-links is no longer case sensitive
.: When connecting to Ed2K eMule starts with a random server instead using first on in the server.met. Any sorting, priority, etc. is not affected by this

-----------------------
- Feb, 1. 2008        -
-----------------------
.: Several changes have been made to improve kads resistance against malicious keyword publishing:
.:  Kad now keeps track which filenames were published by different sources for the same file and uses the most common name (instead the last published one) when responding search requests
.:  Same hashs (files) which have different filesizes are now properly stored seperatly instead overwriting eachother
.:  Kad calculates a rating based on how many different sources publish a file and how many files publishes a source. When responding to a search request, files with a rating below a set limit will be sent last in order to avoid that spammed files push out valid ones.
.: The Kad rating for published files is also sent in search results to be used in the future version as indicator

-----------------------
- Jan, 16. 2008       -
-----------------------
.: Added a general anti-flood-protection to kad. If Kad receives more request of a specific type from one IP than it would expect, it starts ignoring those requests and envetually banning the source. This is supposed to avoid or slow down several attack scenarios.
.: Fixed a problem with injection of DNS servers into the routing tables which were able to stay because of a porotcol mixup between kad and dns. Old sources with port 53 as kad port are ignored, new clients (0.49a+) can use port 53 as kad port again but it is not recommended [found by netfinity]
.: Fixed a bug in kad2 with publishing >4GB files [netfinity]

-----------------------
- Jan, 11. 2008       -
-----------------------
.: If you select a non-default incoming directory which already contains files, eMule notices you that those files are automatically shared by eMule

-----------------------
- Jan, 8. 2008        -
-----------------------
.: Added a filter box (like in the search results) for on-the-fly filtering of shared files into the shared files tab. This filter is supposed to help finding specific shared files, it has no effect on which files are actually published
.: Rearranged the symbols in the shared files directory tree a bit

-----------------------
- Dec, 15. 2007       -
-----------------------
.: The onlinehelp for the options dialog is now topic sensitive for all languages instead only for english (well actually it is not, but this is serverside work which will be done step by step till the release). More areas to get topic sensitive to come in the future
.: Open searches are now stored if you close eMule and restored on restart. This way you don't have to research your favourite words in case you didn't get to finish looking at the results. Can be disabled in Options->Display

-----------------------
- Dec, 2. 2007        -
-----------------------
.: Reworked Kads Firewall handling and testing:
The kad firewall state is now split into TCP and UDP. The TCP state is basically the old state, which tests if your TCP port is reachable. The UDP state is new and checks if your UDP port is reachable. For example on Full Cone NAT Routers, without portforwarding you will get TCP firewalled (as before) but UDP open (new). If you have the UDP open state, eMule doesn't needs a buddy any longer and will fully participate in the KAD network and therefore take away the overhead they caused in earlier versions (you still cannot connect to other TCP firewalled clients if you are TCP firewalled yourself).
.: The new UDP state is shown in the MyInfo field in the Server Tab. As long as the UDP firewalltest is unfinished "(unverified)" is appended
.: Clients which have the Kad UDP open state, now support direct callbacks (invoked by an UDP packet) to connect to not firewalled clients. These callbacks are faster, more reliable and use less ressources than buddy or server callbacks.
.: The new firewall test also fixes a bug / design flaw which caused eMule to always use the use the clients source UDP port, instead testing if the internal set UDP port might be the propper choice instead. This was especially a problem on Restricted Cone Routers with PAT (Port Address Translation) 

-----------------------
- Nov, 29. 2007       -
-----------------------
.: Fixed bug with possible wrong local IP address in case the "BindAddr" option is used.
.: Fixed bug with missing update of details of a selected friend in friends list.

-----------------------
- Nov, 24. 2007       -
-----------------------
.: Fixed bug in tooltips which were showing certain list items partially in bold.

-----------------------
- Nov, 19. 2007       -
-----------------------
.: Added missing Unicode support for 'Static Servers' feature.

-----------------------
- Nov, 12. 2007       -
-----------------------
.: Fixed several of our listcontrols to show Windows' context menu of scrollbars
.: Added an option (Options->General) to prevent Windows from going into standby mode while eMule is running (and doing something)

-----------------------
- Nov, 11. 2007       -
-----------------------
.: Fixed bug in IRC window with channel windows opening in reverse order.
.: Fixed bug with dead servers occasionally not deleted from GUI [fox88].
.: Fixed bug with disabled E-Mail notifications on particular Windows systems [Lewpy]
.: Added showing of IRC-warning and error messages to the active channel window.
.: Added auto-activating of private IRC channel windows when self-initiating the conversation.
.: Fixed bug with extra large icons in file tooltips.
.: Fixed bug with HTTP downloads which could create a crash in case the HD is full.
.: Fixed a memory leak with failed gzip'd HTTP downloads.

-----------------------
- Nov, 07. 2007       -
-----------------------
.: Fixed garbled display of HTTP download status information

-----------------------
- October, 31. 2007   -
-----------------------
.: The messagesystem is now able to find your friends even if their IP changed if you and they are in Kad and not firewalled. This will help to stay in contact with friends longer than one session (Only works for new added/new seen friends which have Kad enabled).
.: When messaging a friend, eMule now makes sure that the userhash still matches after connecting and SecureIdent (if enabled) is passed in order to ensure that its really your friend.

-----------------------
- October, 28. 2007   -
-----------------------
.: You can now bootstrap to kad from an URL which points to a nodes.dat file (in the Kad tab)

-----------------------
- October, 22. 2007   -
-----------------------
.: In order to reduce spam messages and by this make the messagesystem more useable again, eMule now supports Captcha authentification:
If enabled, someone who messages you has first to solve a cpatcha (an image which shows letters) before the message is shown to you. Older clients who do not support captchas will be unable to message you and receive a notice about this.

-----------------------
- Jule, 11. 2007      -
-----------------------
.: Added obfuscation to the Kad UDP protocol. Kad obfuscation is part of the protocol and is unrelated to the Ed2K-Obfuscation settings

-----------------------
- June, 5. 2007       -
-----------------------
.: Fixed a bug which let Kad try to load its preferences from the old config directory location

-----------------------
- May, 16. 2007       -
-----------------------
.: Added Uyghur translation [translated by Abduqadir]




0.48a
-----------------------
- May, 13. 2007     -
-----------------------
.: Happy Birthday eMule :)

-----------------------
- May, 12. 2007     -
-----------------------
.: Fixed some bugs in UPnP and changed the behavior for ADSL devices a bit
.: Fixed a bug concerning double adding friends
.: If Vista is running with Aero, eMule will enable Minimize to Tray on Minimize by default (can be changed in the display options)

0.48a BETA2
-----------------------
- May, 08. 2007     -
-----------------------
Ornis: Changed to wizard to set file proper file permission on installed config files
.: Fixed another Bug in the SourceExchange, which caused eMule to not response to requests in certain cases [Xman1]
.: Sorting for cumulative stats in the sharedfiles list is now properly remembered when restarting eMule
.: The "Disable UDP" and Enable "Kad" options now exclude eachother [leuk_he]
.: Fixed a bug in UPnP when the UDP port has been disabled by the user [leuk_he]
.: IRC optional serverports should work properly now
.: Fixed a bug in IRC when receiving ed2k links from other users
.: Added a excess flood protection for eMule IRC responses

-----------------------
- May, 05. 2007     -
-----------------------
.: The Spam indicator icon has been replaced [icon by Daan]
.: The first time wizzard is now using the proper ports when testing UPnP in case a user has changed the ports in the wizzard
.: Fixed eMule (error-)handling for files whose paths exceed the operation system pathlength limit
.: If eMule started the Windows UPnP Service but failed to forward ports via UPnP it will shutdown the service afterwards
.: Added an option to disable smileys
.: Fixed a small memleak in the smileyselector window


0.48a BETA1
-----------------------
- April, 29. 2007     -
-----------------------
.: The "official" development environment for eMule has switched to VS2003 SP1. VS2002 is no longer supported (but should still compile fine) 

-----------------------
- April, 28. 2007     -
-----------------------
.: Sorting in the ipfilter dialog has been fixed on Vista
.: Tooltips now have the proper size on Vista
.: All file related tooltips should look a bit nicer now (on all systems)
.: Added tooltips to the shared files list

-----------------------
- April, 21. 2007     -
-----------------------
.: Sparse files have been disabled on Vista, due to a faulty / limited Vista implementation of them, which cannot be worked arround by eMule

-----------------------
- April, 15. 2007     -
-----------------------
.: Added a spamfilter for search results. It mainly works by remembering files a user has marked as spam and marking files
   which seems to be very similar as spam too.
.: Spam results are drawn gray and always put to the end of the list
.: Spam results count max. 5 sources towards the 100 sources global search limit

-----------------------
- April, 9. 2007     -
-----------------------
.: The default paddingsize for obfuscated TCP connections has been increased to 128 bytes (from 16) in order to be harder detectable by size pattern matchings
.: The paddinglength can be changed manually by adding "CryptTCPPaddingLength=[1-256]" into the eMule section in the preferences.ini

-----------------------
- March, 12. 2007     -
-----------------------
.: eMule now supports multi-user installations, which especially is supposed to fix the folder permission problems on Vista
   In short: for Windows Versions before vista, nothing will change by default, on Vista eMule will use the current userspecific folders by default
   Please consult the onlinehelp for a detailed explanation. The setting can be changed at the extended options.
   
-----------------------
- March, 11. 2007     -
-----------------------
.: On Vista the half-open connection limit is now properly set to 9 by default (instead of 50)

-----------------------
- Feb, 20. 2007       -
-----------------------
.: When using autoconnect on startup or pressing the Connect button while UPnP is still busy, eMule will wait for it to finish
   or timeout. You can enforce on isntant connect by clicking the button again

-----------------------
- Feb, 18. 2007       -
-----------------------
.: Added UPnP support [merged from Shareaza]
.: Added UPnP test button into the first time wizzard

-----------------------
- Feb, 09. 2007       -
-----------------------
Ornis: added Farsi translation [translated by Mory Abdi & Ali Mojarad]
.: The calculation of credits given for the first 9MB (less than one part) has been changed slightly to decrease the reward for clients who upload less than one part 

-----------------------
- Jan, 20. 2007       -
-----------------------
.: Fixed a obfuscation related bug in the sourceexchange
.: Changed the sourceexchange protocol to avoid backwards compatibility problems and bugs in the future
.: Added support for multi-related files searches [serverside implementation by lugdunum]

-----------------------
- Jan, 14. 2007       -
-----------------------
.: Fixed crash in Statistics window.
Ornis: added Valencian translation [translated by "Valencian"]
Ornis: major update of Slovenian translation [Gusar]
Ornis: label of category tabs are now displayed in category color
Ornis: return of the context menu on message tabs (Details, Add/Remove Friend, Close)

-----------------------
- Jan, 5. 2007       -
-----------------------
.: Prepared Kad for support of obfuscated packets. This is only passive in this version yet.

-----------------------
- Dec, 13. 2006       -
-----------------------
.: Fixed memory leak in list controls [eklmn]

-----------------------
- Dec, 12. 2006       -
-----------------------
.: Fixed performance problem with too large eD2K links and enabled 'Monitor Clipboard' option.

-----------------------
- Dec, 9. 2006        -
-----------------------
.: Several changes to make eMule work better under 640x480 resolutions.

-----------------------
- Dec, 6. 2006        -
-----------------------
.: Fixed saving/restoring of size/position in collections dialogs.
.: Win98: Fixed missing volume labels and shell icons in directories property page's directory tree control.
.: Win98: Fixed not supported multiline tooltip in tray bar.
.: Win98/WinME: Fixed not supported toolbar customization.
.: Win98/WinME/Win2000: Fixed toolbar chevron.
.: Win98/WinME: Fixed vertical axis labels in statistics graphs.
.: Win98/WinME: Fixed saving/restoring of expanded sub trees in statistics tree.
.: Win98/WinME/Win2000: Fixed invisible buttons in transfers window.
.: Win98: Fixed bug with "ShowActiveDownloadsBold=1" setting in Transfers window.

-----------------------
- Nov, 22. 2006       -
-----------------------
.: Reduced long time memory usage for GUI.
.: eMule stores now hashs of filehashs in the cancelled.met for privacy reasons

-----------------------
- Nov, 21. 2006       -
-----------------------
.: Both windows in Transfere window are showing a toolbar to select the window contents.

-----------------------
- Nov, 18. 2006       -
-----------------------
.: Edit controls for Message and IRC window are using slightly larger fonts.

-----------------------
- Nov, 17. 2006       -
-----------------------
.: Fixed bug in IRC window with nick change messages which were not always shown.
.: Fixed bug in IRC window with URL detection with special chars at end of URLs.

-----------------------
- Nov, 15. 2006       -
-----------------------
.: Minor visual improvements for IRC window and Message window text format buttons.
.: Multiline messages in Message and IRC chat windows are intended for improved readability.
.: Some visual improvements in Collection dialogs.

-----------------------
- Nov, 12. 2006       -
-----------------------
.: IRC channel filtering is performed on IRC server to reduce network load, the filter string now supports the wildcard character '*'. (e.g. "#emule-*" to match all channel names which start with "#emule-")
.: IRC window: Activity is now also shown for the 'Channels' window to give some response when user explicitly invoked the "/LIST" command.
.: IRC window: Nick list shows joined modes and names.

-----------------------
- Nov, 11. 2006       -
-----------------------
.: Fixed a bug with single clicking on emule tray bar icon.
.: Fixed bug with requesting eMule friendship via IRC.
.: Changed: By default the IRC channel list will contain only eMule-Help channels.
.: Added: IRC server can optionally contain a port (seperated by ':' character)
.: Fixed bug with background color not reset in IRC colored messages.
.: Added title window for IRC channels.

-----------------------
- Nov, 9. 2006        -
-----------------------
.: Added smiley selector window to Message and IRC window.

-----------------------
- Nov, 7. 2006        -
-----------------------
.: Fixed bug with not outputed IRC notice messages.
.: Fixed Message window splitter.

-----------------------
- Nov, 6. 2006        -
-----------------------
.: Fixed IRC window splitter.

-----------------------
- Nov, 5. 2006        -
-----------------------
.: Fixed bug with reversed sort orders for fresh emule installations.
.: Fixed bug with already used IRC nick when connecting.
.: Fixed bug with changing font size in IRC windows.

-----------------------
- Nov, 1. 2006        -
-----------------------
.: Added showing of smileys to Chat and IRC windows [Smileys by Daan]
.: Reworked AutoScroll feature in all log and chat windows to automatically disable AutoScroll while viewing content not at the end of the window.
.: Fixed right click problem in IRC and chat windows.
.: Fixed some bugs in IRC color code handling.
.: Fixed bugs with black background color in IRC windows.
.: Skins: Fixed problems with foreground skin color in RichEdit controls.
.: Skins: All icons can be read from all file formats which are supported by GDI+ (GIF, PNG, ...)

-----------------------
- Oct, 26. 2006       -
-----------------------
.: Fixed: "exit" command line option no longer starts eMule if it was not already running [DreamWalker]
.: Fixed edk2-URL handling for better support of copying URLs from webpages.
.: Fixed bug in file disk space statistics for pre-allocated files. [AnPapaSeiBua]
.: Fixed bugs in Comment dialog with copy to clipboard functions.
.: Fixed bug with "ed2k::<hash>" search expressions when combined with other search attributes. Note: "ed2k::<hash>" can still only be used in ED2K searches, not in Kad.
.: Fixed bug in local search result filter with changing column.
.: Fixed bug with Unicode strings in category properties.
.: Added optional drawing of filled graphs in Statistics window.
.: Several performance improvments and minor bug fixes in IRC module.

-----------------------
- Sep, 23. 2006       -
-----------------------
.: Fixed a potential crash when shutting down eMule [DavidXanatos]

-----------------------
- Sep, 21. 2006       -
-----------------------
.: Added support for RealMedia files to 'Content' dialog (any optional available MediaInfoLib will no longer be used for RealMedia files).
.: Added support for publishing meta data for RealMedia files.
.: Added several Kad optimizations to reduce overhead as well as memory usage:
 - Redundant meta data will no longer get published.
 - File format meta data is no longer published explicitly and handled special in search expressions.
 - Removed (currently not used) data from Hello packet.

-----------------------
- Sep, 16. 2006       -
-----------------------
.: Fixed bug with invisible text in search filter control for high contrast color scheme.
.: Taskbar Notifier: Added support for alpha channel background images.
.: Taskbar Notifier: Changes made to "notifier.ini" file while eMule is running are read automatically without needing to do a restart.
.: Added Unicode support for id3lib (Content dialog and metadata stored in Kad).


v0.47c Hotfix
-----------------------
- Sep, 14. 2006       -
-----------------------
.: Fixed some major bugs in Kad 2.0 source/keyword publishing

-----------------------
- Sep, 13. 2006       -
-----------------------
.: Fixed Kad bug with processing Kad1.0-Packets which is believed to be remotely exploitable and therefore a potential risk if Kad is enabled [found by tHeWiZaRdOfDoS]
.: Fixed bug with lost setting for disabled UDP port.
.: Fixed bug in First Runtime Wizard with previously disabled UDP port.
.: Added more sanitizing for Kad packages to ignore all unrequested packets

-----------------------
- Sep, 11. 2006       -
-----------------------
.: Fixed some Kad memory leaks in exception handlers [tHeWiZaRdOfDoS]
.: Tweaked reading of "addresses.dat" and "shareddir.dat" files to skip spaces and empty lines.
.: Fixed bug with wrong file type mismatch warning for multiple selected part files.

v0.47b
-----------------------
- Sep, 7. 2006        -
-----------------------
Ornis: Added progressbar during archive scanning for live archive preview

-----------------------
- Sep, 5. 2006        -
-----------------------
.: eMule will take care that the random choosen ports are not used already
.: Added a fix for a possible problem when search Kad-Buddies [DavidXanatos]
.: Fixed a small bug in a kad response sanitycheck [WiZardofDoS]

-----------------------
- Sep, 1. 2006        -
-----------------------
.: Some optimizations for IP-filtering in Kad.
.: Fixed a bug where wrong Kad 1.0 Notes packets were sent.
.: Fixed bug with MiniMule which failed to open when eMule was installed in folders with special characters.


0.47b BETA1
-----------------------
- Aug, 31. 2006       -
-----------------------
.: Bugfix: When trying to connect to a selected server which times out, eMule will no longer try to conenct to other servers instead
.: Added a fix for receiving ED2K UDP packets when the remote client is behind a UDP portmapping router  
Ornis: Added vietnamese translation, by Paul Tran HQ Loc
.: Fixed a small rounding error on the filerateing icon 

-----------------------
- Aug, 26. 2006       -
-----------------------
Ornis: Added filetype display to Filedetail Dialog. For most common filestypes, the downloaded header is checked to match the file extention. A warning icon is shown if its file extention matches a different file type.
Ornis: Fixed a bug in the webserver with banning IPs after too many logintries[DreamWalker]

-----------------------
- Aug, 24. 2006       -
-----------------------
.: When doing a search for comments on Kad, an icon (in the place of the rateing icon) will indicate that a search is in progress
   The button to search for comments on Kad will be disabled while a search is in progress.

-----------------------
- Aug, 21. 2006       -
-----------------------
.: Several minor possible memleaks have been corrected [WiZardofDoS]
.: On a fresh installation eMule will now select random ports instead the default port 4662 and 4672. The ports won't be changed on existing installations and stay the same after restarts. The helpfiles will be updated to reflect this.

-----------------------
- Aug, 20. 2006       -
-----------------------
.: Fixed missing IPFilter checks for outgoing UDP packets from KAD / Kad Nodes [leuk he]
.: Incoming ED2K and some Kad UDP response packets are now ignored if they were not requested.
.: An option to enable or disable MiniMule has been added to the General options dialog
.: (extrem rare) possible integer overflow causing problems when downloading large files has been fixed [avi-3k]

-----------------------
- Aug, 17. 2006       -
-----------------------
.: A possible premature send bug on TryToConnect has been fixed [eklm]
.: Servers added from other clients or servers will now get low priority by default

-----------------------
- Aug, 15. 2006       -
-----------------------
.: Reworked file comment dialogs: added rating icons, network info and sortable comment list

-----------------------
- Aug, 12. 2006       -
-----------------------
Ornis: 2 fixes for statistic dialog when moving vertical splitter to minimum or maximum position [BlueSonicBoy]
Ornis: Fixed bug in webserver to deal with filenames with apostrophes in transfer list (missing javascript controlled popupmenue)

-----------------------
- Aug, 5. 2006        -
-----------------------
Ornis: Added live archive preview for ZIP,RAR and ACE. The Content-tab of the file detail dialog (partfiles and completed files) will list content of the archive (file name & path, size, CRC,...) and information like existing password protection, archive atttributes,...
       Completeness of the list depends on download status. Downloaded parts are scanned, ZIP central directory is read if fileend was downloaded.
Ornis: Added archive recovery for ACE archives. (As for ZIP & RAR already present: create a version of the downloading archive containing the files that are already available.)
       Some minor fixes in archive recovery, including remove tempfile when recovery failed.
Ornis: Fix for better handling of pasted links in the ed2k-link dialog to process empty lines and whitespaces [zoom]

-----------------------
- Jul, 26. 2006        -
-----------------------
.: Added Obfuscation Layer for ED2K/Kad TCP, ED2K UDP, Server TCP and Server UDP connections. Kad UDP is not obuscatable yet. For a detailed explanation of this feature, please check this topic of our onlinehelp: http://www.emule-project.net/home/perl/help.cgi?l=2&rm=show_topic&topic_id=848
.: The security options page has been split and now contains also obfuscation settings. Comments and message related setting have now there own page.

-----------------------
- Jun, 24. 2006       -
-----------------------
zz: Improved chunk chooser: major improvements for very rare files (less than 5 sources), but also includes tweaks for common files and for preview chunks

-----------------------
- Jun, 21. 2006       -
-----------------------
.: Added support for MediaInfoLib v0.7.1+

-----------------------
- Jun, 7. 2006        -
-----------------------
.: Fixed bug with default preview function which did not open default application for certain file types.
.: Added option to specify preview command line.

-----------------------
- Jun, 6. 2006        -
-----------------------
.: Fixed bug with renameing files in shared files window [SiRoB]

-----------------------
- Jun, 4. 2006        -
-----------------------
.: Fixed problem with possible file corruption when eMule is run as 'secure user' and system logoff/reboot.

-----------------------
- May, 31. 2006       -
-----------------------
.: Fixed bug in connection management.

-----------------------
- May, 29. 2006       -
-----------------------
.: Reworked Media Info dialog's additional information window.

-----------------------
- May, 26. 2006       -
-----------------------
.: Media Info dialog shows hint about files which are protected with DRM.
.: Fixed bug in Media Info dialog with getting AVI properties for some part files.
.: Added workaround to Media Info dialog to show more reliable play length for MPEG files when used with MediaInfoLib.

-----------------------
- May, 21. 2006       -
-----------------------
.: Added search results specific menu (look closely to the label above the search results list) for some minor important functions:
- specify the format of file size numbers for search results (KB = shows sizes in KByte with same format as used by Windows Explorer, MB = shows sizes in MByte, Default = free style)
- reset search results filter

-----------------------
- May, 17. 2006       -
-----------------------
.: Fixed bug with 'Find' function in search results list when used for non-filename fields.

-----------------------
- May, 16. 2006       -
-----------------------
.: Added simple on-the-fly filter for search results to filter already received results. The
filter will be invoked automatically after you stopped typing in the filter control.
Generally all specified strings (separated by space) are ANDed. Strings which do not
start with a '-' character (positive filter) must be found in the filename of the
search results while strings which are starting with '-' characters (negative filter)
must not be found in the filename of the search results.

Example: -xyz -abc cool file
This will show only search entries where the filename contains the words "cool" and
"file" and which are not containing the strings "xyz" nor "abc".


-----------------------
- May, 13. 2006       -
-----------------------
.: Search results pane tab context menu offers function to restore all used search parameters for that particular search.

-----------------------
- May, 12. 2006       -
-----------------------
.: Server Info pane shows time stamped "connected" messages before now server info messages.
.: Fixed bug in server UDP socket with ignoring received servers stats from dynIP-servers.
.: Fixed bugs in server UDP socket with race conditions of DNS queries and outgoing UDP packets (for dynIP-servers).
.: Servers can get cutted with Ctrl+X

-----------------------
- May, 11. 2006       -
-----------------------
.: IP-Filter: dynIP-servers are no longer rejected when enableing "Filter servers too" and get eventually IP-filtered after the DN was resolved.
.: IP-Filter: Non-dynIP-servers and dynIP-servers with an already known IP are filtered whenever the IP-filter list or a related IP-filter option was changed.
.: Fixed bug in Webinterface with server sorting and dynIP servers.
.: Fixed bug with ed2k-server URLs and dynIP servers.
.: Fixed bug in auto server connecting which could lead to not connecting to any server at all.
.: Fixed several bugs related to duplicate dynIP-server entries in server list.

-----------------------
- May, 8. 2006        -
-----------------------
.: Fixed some Unicode error message bugs [Xman1]
.: Fixed bug with not completing files due to invalid filename prefixes.

-----------------------
- Apr, 27. 2006       -
-----------------------
Unk: Corrected Kad crash bug. (Pointed out by Ani)

-----------------------
- Apr, 10. 2006       -
-----------------------
.: Fixed GUI glitch in download client progressbar [SiRoB]

-----------------------
- Apr, 1st 2006      :->
-----------------------
.: Fixed bug with re-downloaded and re-shared files.
.: Fixed bug with "Summary Not Updated After Deleting Shared File" [raccoon.i]
.: Added preferences.ini setting "UserSortedServerList=1". When enabled this will use the same server list sorting as shown in GUI when trying to connect to a server.
        
-----------------------
- Mar, 26. 2006       -
-----------------------
.: Fixed bug with eMule getting focus on received chat message when minimized [raccoon.i]
.: Fixed Win2K specific GUI glitches in search results.

-----------------------
- Mar, 25. 2006       -
-----------------------
.: Fixed some icon resource leaks.
.: Fixed bugs with changing Windows color schemes on-the-fly and for Windows "High Contrast" color schemes.
.: Fixed bug with exchanged rating strings [Aenarion[ITA]]
.: Fixed missing entries in connection wizard dialog [FrankyFive]
.: Fixed bug in webserver for files >4GB [zAxel]
.: Fixed bug in webserver related to HTTP error reply.

-----------------------
- Mar, 9. 2006        -
-----------------------
Unk: Keyword search for Kad2.0 with Kad1.0 integration working.
Unk: Fixed possible mem leak in Kad..

-----------------------
- Mar, 4. 2006        -
-----------------------
Unk: Keyword store Note search for Kad2.0 with Kad1.0 integration working. Kad2.0/1.0 integration completed.

-----------------------
- Feb, 4. 2006        -
-----------------------
Unk: SMIRC now supports color. (BlueSonicBoy-TK4)
Unk: Fixed GetClosestTo not return the number of results wanted.. (tatikiran)
.: Fixed potential crash with MiniMule.
.: Ported sources code to VS2005.
.: Several runtime performance optimizations for 64-bit arithmetics.
.: Fixed a minor bug with large file search results.

-----------------------
- Jan, 29. 2006       -
-----------------------
Unk: Starting to use Kad2.0 with Kad1.0 integration... Hello Packets, Node Lookups, BootStraps, Source Store/Search, Note Store working.

0.47a
-----------------------
- Jan, 25. 2006       -
-----------------------
Unk: Fixed a Kad bug when looking for a Buddy.. (leuk_he)
.: Fixed a problem with corrupting known2_64.met if "Remember downloaded files" is disabled


-----------------------
- Jan, 24. 2006       -
-----------------------
.: Fixed banned client statistics [Xman1]
.: Fixed cumulative part file data statistics [TimDzang]
.: Fixed download list transferred data shown in completed column, if transferred column is hidden.
.: Fixed stalling during part file allocation.
.: Fixed rejected connections (ip filter) stats.


0.47a BETA2
-----------------------
- Jan, 23. 2006       -
-----------------------
.: Clients which send filtered messages will now also be identified as spammers
.: Fixed a bug with HTTP/Peercache sources (SiRob)
.: Fixed a problem with converting known2.met - it should not rehash files anymore when updating from a prior version

-----------------------
- Jan, 21. 2006       -
-----------------------
Unk: Continued work with Kad2.0. Only host side funcational still
Unk: More tweaks to Kad1.0.
Unk: Correction to "Change in LPhant version display (Famerlor)"
Unk: Make sure Kad config files are not read by older clients as they may contain tags they cannot read.

-----------------------
- Jan, 20. 2006       -
-----------------------
.: Fixed a bug which could cause problems when loading part.met files of large files (SiRob)
.: Changed the protocol to check the hash+filesize instead only the hash on requested files
 

0.47a BETA1
-----------------------
- Jan, 15. 2006       -
-----------------------
Unk: Began work on Kad2.0.. The idea is to improve the protocol and add some features.. This client will only host the new protocol, the next version will have the option to switch between Kad and Kad2.0..
.: Completed files can now be deleted from the download window
.: Updated MobileMule protocol for large files

-----------------------
- Jan, 14. 2006       -
-----------------------
.: Clients which were identified as spammers will now be banned instead of only ignoring their messages

-----------------------
- Jan, 11. 2006       -
-----------------------
Unk: It appears there is a rare possibility that a keyword to a known file that is not shared can attempt to be published, a check is in place to avoid it.

-----------------------
- Jan, 8. 2006       -
-----------------------
.: Added support for large files. The new file size limit which eMule can handle is 256GB (the old one was 4GB)
.: The following compatibility issues for large files apply:
        - Large files can be found, downloaded and uploaded only by clients which support it (right now eMule 0.47a and above)
        - Collections which contain any large files can no longer be read by clients which don't support large files
        - part.met files from large files can not be used with old eMule versions / ed2k tools
        - If any large file is shared/known the known.met file will no longer be backward compatible to older eMule versions
        - Known2.met will be converted to Known2_64.met which can not be read by old eMule versions
Unk: Updated Kad to handle large files..
    - Older clients cannot index large file keywords. This will mean getting keyword results on large files will not 
      work well until the majority of the network updates..

-----------------------
- Dec, 30. 2005       -
-----------------------
.: Added "Minimize to system tray" command to system menu.

-----------------------
- Dec, 26. 2005       -
-----------------------
.: Fixed bug with wrong 'Download Time' reported for some paused files.

-----------------------
- Dec, 24. 2005       -
-----------------------
.: Fixed bug with setting the priority of a static server which was lost after a restart.
.: Added cycling through main eMule windows with Ctrl+Tab and Shift+Ctrl+Tab respectively.

-----------------------
- Dec, 17. 2005       -
-----------------------
.: Fixed problem with shared files which have invalid file date [thx Kro/MorphXT]

-----------------------
- Dec, 3. 2005        -
-----------------------
.: Proxy support: Couple of optimizations for proxy support.
.: Proxy support: The "Proxy/ShowErrors" preferences.ini setting has no meaning any longer because all proxy errors are now shown as part of the regular connection error messages for servers and clients.
.: Proxy support: Fixed bug in SOCKS 5 authentication.
.: Proxy support: Added support for HTTP/1.0 proxies which saves proxy overhead. Hint: If you have to use a HTTP proxy, HTTP/1.0 is recommended unless you must use HTTP/1.1.
The precedence of the proxy protocol performance is as follows.
1. SOCKS 4a (highest performance because of least overhead)
2. SOCKS 4
3. SOCKS 5
4. HTTP/1.0
5. HTTP/1.1 (lowest performance because of most overhead)
.: Speed up for large IP-filter list loading.

-----------------------
- Nov, 30. 2005       -
-----------------------
zz: Option to make eMule use highres scheduling (better precision for sleeps and some timers). Currently the upload throttler takes advantage of it if enabled, which may give smoother upload performance and smoother pings while using eMule. Try it at your own risk. :) Use this preferences.ini setting in [eMule] section to activate: HighresTimer=1

-----------------------
- Nov, 26. 2005       -
-----------------------
.: Changed search function in IP-Filter Dialog: When searching for an IP in the "Start" column, the "range" where the specified IP is within is searched. Hint: This way one can check if a particular IP is blocked in the loaded IP filter list.
Ornis: Importer added for incomplete (ed2k)Shareaza tempfiles [by David Xanatos]

-----------------------
- Nov, 24. 2005       -
-----------------------
.: Added "BindAddr=<IP>" setting to preferences.ini to bind eD2K/Kad+WebServer sockets to specified IP address.
.: Fixed bug with "Start Minimized" and "Minimize to Systemtray".
.: Main window can be restored from MiniMule window by double clicking on MiniMule's title bar.
.: Enter-key can be used in listviews to invoke the default action for selected items (like "Connect to server", "Download search result", "Open completed file", ...)

-----------------------
- Nov, 20. 2005       -
-----------------------
Unk: Attempted to clean up all SMIRC Code.
1) Reformatted code so all has the same format.
2) Almost a complete rewrite in the core code which should correct the following issues.
. A change in the default preferences caused SMIRC to not display a popup for the user to change their nick.
. Some users could not see what they were typing..
. Channel Modes were not handled correctly in many cases.
. Sending new channel modes from the tab menu didn't send correct modes in most cases.
. Sorting nicks within a channel didn't sort correctly.
. Notices were not process correctly in some cases..
. Ping/Pong between users didn't work.
. Server filter option in prefs was unable to be cleared.

-----------------------
- Nov, 14. 2005       -
-----------------------
Unk: Attemped to clean up all Kad Code.
1) Reformatted code so all has the same format.
2) Removed some unused method params and vars.
3) Tried to optimize some code.
4) Fixed a possible issue that if you found your target on first try, you wouldn't send a request/store.
5) Began adding comments to code for better understanding. (This will be done slowly if ever finished.)
6) Put back keyword results sanity check.
7) Fixed issue with Zones not being merged when contacts get low. (Help with Kry)
8) Changed how contacts are kept alive to keep contact list fresher with less CPU
9) Adjusted where Jumpstart is called to reduce CPU.
10) Adjusted user count to account for firewalled users.

-----------------------
- Nov, 13. 2005       -
-----------------------
.: Code cleanups and performance optimizations regarding 16-bit integer usage.
.: E-Mail notifications are disabled for non-XP-SP2 systems when built with ATL 7.1.
.: Added "Find" command to all list views (shortcuts Ctrl+F=New search, F3=Search next, Shift+F3=Search prev.).

-----------------------
- Nov, 5. 2005        -
-----------------------
.: Added support for RARed IP filter files. Download UNRAR.DLL from http://www.rarlab.com and copy to emule installation folder.
.: Added support for RARed eMule skin profiles. (As with ZIPed skin profiles, you can install downloaded RARed skin profiles right from Shared Files window by right clicking and invoking "Install eMule Skin" command.)
Unk: Lower CPU load within Kad's Routing. (Kry, idea by lupz)

-----------------------
- Oct, 30. 2005       -
-----------------------
.: Fixed bug with IP Filter URL dropdown control in Security Dialog which was loosing all entries.
.: Added verification of downloaded IP Filter files to detect files without any IP filters (e.g. dead URLs).
.: A ZIPped IP filter file must contain one file (which holds the IP filter list) with the name "guarding.p2p" or "ipfilter.dat". All other files possible available in a ZIP file are ignored.

-----------------------
- Oct, 15. 2005       -
-----------------------
Ornis: option for full filesize preallocation (extended settings)
Ornis: systray flashes with message icon on incoming new message (message, not IRC (yet)) when enabled in preferences.ini (Section "eMule" set "IconflashOnNewMessage=1")

-----------------------
- Oct, 8. 2005        -
-----------------------
.: Media Info File Dialog shows information about additional audio/video/subtitle streams. (Use MediaInfo DLL (http://mediainfo.sourceforge.net/) to get this support for non-AVI files).
.: MP3 files with variable bitrates and Xing-VBR frame are report and published with the average VBR bitrate.

-----------------------
- September, 30. 2005 -
-----------------------
.: Added more safety to tag parsing in hello packets [thx Kry]

-----------------------
- September, 29. 2005 -
-----------------------
.: File detail dialog shows accumulated remaining size of multiple selected files.

-----------------------
- September, 26. 2005 -
-----------------------
.: Fixed bug with 'Ext' command in 'PreviewApps.dat' file.

-----------------------
- September, 25. 2005 -
-----------------------
.: Added file rating support for ED2K-server search results. Received ratings are shown with additional icon like in Transfers window and in 'Meta Data' details dialog.
.: Fixed bug with double clicking on rating icon in Transfere window not always opening comment dialog page.
.: Fixed bugs with property pages not restored correctly when using file details dialog in different main windows.

-----------------------
- September, 24. 2005 -
-----------------------
.: The meaning of the 'Cancel' search button was modified slightly. The 'Cancel' button now cancels any 
active search only if the according search result list is active. This means that active Kad searches 
can be canceled without closing the search result list window. So, to cancel any active search (regardless
of the search type) without deleting the search results, activate the according search result list and click 'Cancel'.

-----------------------
- September, 20. 2005 -
-----------------------
.: Added optional floating point number support to search attributes in GUI and meta data search attributes in parser. (e.g. @size<1.23g)
.: Size-, Availability-, Complete Sources-, Bitrate- and Length-search attributes can be specified in GUI in same way as in parser (see there).

-----------------------
- September, 19. 2005 -
-----------------------
.: Added new method for extracting meta data from AVI/WAV files without using DirectShow filters.

-----------------------
- September, 15. 2005 -
-----------------------
.: Added value checks for 'type' search tag: @type="audio"|"video"|"image"|"img"|"document"|"program"|"archive"|"iso"|"cd"
   All type-values can be abbreviated with the first 3 characters (e.g. @type=doc is the same as @type=document)
.: Added parsing of value for @length seach tag: 'length' can be specied as HH:MM:SS or MM:SS or as 'seconds' 
   followed by a modifier (s=seconds(default), m=minutes, h=hours; e.g. "2m" is 2 minutes and is equal to "2:00")
.: Added abbreviations for search tags: all search tags can be abbreviated by their first 3 characters.
   (e.g. "@siz" is equal to "@size")

-----------------------
- September, 13. 2005 -
-----------------------
.: Added "exact string" search for Kad searches (quoted strings will be sent to nodes unchanged).
   Note: Only newer Kad nodes will be able to process them correctly, older Kad nodes will not return a result.
Ornis: Webinterface: fixed information popup for upload items
 
-----------------------
- September, 12. 2005 -
-----------------------
.: Added '-' as NOT shortcut to search expression (Google-style).
   - Terms prefixed with '-' get interpreted as NOT operator (e.g. "file -avi" is equal to "file NOT avi"; also "file -@codec=wmv3" is equal to "file NOT @codec=wmv3")
   - Strings can still contain the '-' character within the string (e.g "cool-file")
.: Breaking changes in search expression parser:
        - the characters '<', '>' and '=' (and also partially '@') are treated special. If they are to be used in search terms, they have to be quoted.
        - several meta-data IDs starting with '@' or when written all in uppercase are treated special. If they are to be used in search terms, they have to be quoted.
        - the Kad comparison operators '<', '>', '>=' and '<=' are now equal to ED2K operators. 
          You should not see much difference in practice. If though (e.g. when searching for bitrate), specify the value decreased by one or increased by one (depending on the comparions operator).
          This will vanish after more eMule clients have upgraded.
    - all meta-data IDs used in search expressions are sent as integer tags for saving bandwidth and CPU load (for ED2K and Kad)
    - precedence of AND and OR operator changed to get a Google-like interpretation:
      "a b OR c d" (or "a AND b OR c AND d" respectively) does no longer evaluate to "(a AND b) OR (c AND d)" but to "a AND (b OR c) AND d" (Google-style)
      You still can use paranthesis to force the precedence of evaluation to suite your needs.
    - The '-' character is interpretated as NOT when seen 'outside' of a string.

-----------------------
- September, 11. 2005 -
-----------------------
.: Optimized search expression trees for putting less CPU load on servers and Kad nodes when evaluating the trees (less recursions).

----------------------
- September, 9. 2005 -
----------------------
.: Fixed problem with active Kad search indicator which was disabled too early.
.: Added "exact string" search for ED2K searches (quoted strings will be sent to servers unchanged)
.: Added meta-data searching to search expression parser.
.: Reworked boolean search expression parser: implicit ANDs do no longer need to be specified (e.g. "a AND (b OR c)" can be specified as "a (b OR c)")

----------------------
- September, 4. 2005 -
----------------------
.: Removed sending of string file format meta tags to eserver and emule clients for saving bandwidth [thx lugdunum]
.: Added sending of new integer file type meta tags to eserver for saving bandwidth [thx lugdunum]
.: Available 'Complete' info is shown correctly in search results when viewing shared files of other clients.
.: Available 'Complete' info for files with less then 9280000 bytes is shown correctly in search results for Kad searches.
.: Added "Search Related Files" menu item to Download List context menu.
.: Fixed, amount of transferred data for a source is no longer shown in Completed but in Transferred column in Download List.

----------------------
- August, 30. 2005   -
----------------------
Unk: Removed an unused tag in the loginrequest packet. (Avi-3k & Lug)
Unk: When a very large popular server come online, it experienced ping storms every 4 hours.. Fixed (Lug)
Unk: Store file rating to servers. (Lug) 
Unk: We not longer send FT_FILEFORMAT tags to servers.. (Lug)
Unk: Fixed a couple malformed strings in MIRC. (Avi-3k)

----------------------
- August, 18. 2005   -
----------------------
Ornis: added Maltese translation by Reuben
Ornis: fixed graphical issues (Log-Reset button on language change, avoid minimizable log/chat windows)

----------------------
- August, 8. 2005    -
----------------------
Ornis: fixed a crash on systray clicking (happened on very certain click behaviour or heavily busy systems)

----------------------
- August, 1. 2005    -
----------------------
Ornis: added Ukrainian translation [translated by Kex]

----------------------
- July, 29. 2005     -
----------------------
Unk: Fix shared "Open Folder" (Avi-3k)
Unk: Fix ClientCredit debug mode (Avi-3k)
Unk: Fix DownloadList sort bug (Avi-3k)
Unk: Fix bug in Ppgfiles (eMulefan83)
Unk: Fix cursor bug (Slugfiller)
Unk: Change in Preference localize easier add/remove preference windows (CiccioBastardo)
Unk: Change in LPhant version display (Famerlor)


v0.46c
----------------------
- July, 24. 2005     -
----------------------
.: Added support for MediaInfo DLL versions 0.6.1 and 0.7.x [Thx to Zenitram]

----------------------
- July, 22. 2005     -
----------------------
.: Updated to zlib 1.2.3 because of security flaws in 1.2.2 

----------------------
- July, 18. 2005     -
----------------------
Unk: Fixed possible crash on malformed Kad packet.. (Kry)
Unk: Auto Kad bootstrap wasn't updated to work with eMule's Multipacket protocol. Fixed.

----------------------
- July, 16. 2005     -
----------------------
Ornis: fixed bug (v0.46b) in using regular expressions as view filter in categories [thx kinmenalex]

----------------------
- July, 9. 2005      -
----------------------
Ornis: fixed bug in checking for tempfolder when multiple folders were used, and a little splitterbar bug [tHeWiZaRdOfDoS]
Ornis: new and changed category incoming directories will now appear in the new shared files control

----------------------
- July, 8. 2005      -
----------------------
.: The upload limit and capacity as well as the downloadlimit will now be set to unlimited by default
.: When the uploadcapacity is set to unlimited (0), USS will be automatically enabled to determinate the best uploadspeed
.: If using the prio default capacity (16KB), the new version will reset it (one time) to the new default unlimited
zz: UploadSpeedSense will at most raise speed 30 KBytes/s above current upload speed. This will prevent it from raising to very high limits if your client can't upload fast enough to reach the limit due to no clients in queue.
zz: Bugfix+enhancement to the code that requests less of the file from slow download sources. Will now only activate this code if there's little enough left of the file to complete.
Ornis: Resizeable collection windows
Ornis: added some USS localisations
Unk: Some cpu fixes for Kad. (Kry)
Unk: Changed how we maintain contacts for kad. 
Unk: Kad node lookup algo modified to use far less overhead with better results.
Unk: Collections were storing extra tags causing them to be "bloated".. Fixed.

----------------------
- July, 5. 2005      -
----------------------
Ornis: fixed/improved downloading big files via webinterface 
Ornis: fixed tiny memleak in the preferences/statistics dialog


v0.46b
----------------------
- July, 4. 2005      -
----------------------
zz: fixed Uploading sort bug
Unk: Collection Names more relaxed for the users.. (ie: It doesn't reformat the name or remove tags)
Unk: Lowered number of stores to help with routers.
Ornis: Multi-Temp folders should work now.
Unk: Fixed Comment Icons staying when no comment/ratings are available.
.: Fixed several smaller glitches in the new share control
.: Fixed the filesizelimit for downlaoding files from the webinterface
.: Fixed some crashing bug with duplicated files
.: Fixed some minor general GUI glitches (Icons, save&restore, etc)

----------------------
- July, 1. 2005      -
----------------------
Unk: Some users complained that the "Users | Files" box wasn't large enough for their lang. Double clicking that box now pulls up MyInfo with user/file counts included.
Unk: Added some extra info to the full screen MyInfo box. (Parts based on Morph mod)

eMule 0.46b Beta
----------------------
- June, 28. 2005     -
----------------------
zz: Removed "Automatically Swap All (A4AF) Sources To This File" menu item. For the same effect, raise download priority on the file instead. See Web Help&Support -> Features -> Source Management
zz: When downloading from a really slow source, request less of the file at a time. This locks less of the file, so if there's a faster source available we have a better chance of downloading from it even when the file is almost completely downloaded.
Unk: Basic Collection framework and gui (see documentation for detailed information on this)
.: Improved Collection Gui.
.: Collections are now properly signed/verfied. If verifying failes, the authorname and key are removed
.: Downloadrequests for collections will bypass the downloadqueue and served immediately
.: Added splitter control to the shared files window
.: Changed the apperearence of the splitter slightly
.: Collection files can now be linked to eMule, click the "Take ED2k-links" Button to do so, if not already done by the installer


----------------------
- June, 27. 2005     -
----------------------
Ornis: Fixed crash when downloading via HTTP source and viewing the downloadclient-list

----------------------
- June, 26. 2005     -
----------------------
.: Extended the "Run as unprivleged User" function: If starting with the eMule-Account fails (for example because of lacking privileges)
    eMule will restart as the same users but with reduced privileges (but same file permissions).
        This helps users which are already working with an Non-Admin account to improve the security a bit more

----------------------
- June, 25. 2005     -
----------------------
Ornis: minimule shows now count of all completed files, in all categories [by TED]

----------------------
- June, 19. 2005     -
----------------------
.: Added new control into the Shared Files window which lets you browser your shared files by directories and add/remove shared directories
        (you can also drag&drop a directory from "All Directories" into "Shared Directories" to share it)
.: Added support for Related File-Search into the Search window (contextmenu). This allows you to search for files which are shared by users which also shared the selected file [lugdunum]


----------------------
- June, 16. 2005     -
----------------------
Unk: Kad Notes (Comments from the Kad network) are now filtered like normal comments.
Unk: Tray shutdown bug fix. [Xman1]

----------------------
- June, 13. 2005     -
----------------------
Unk: Ratings icons now show a range of ratings based on the average total instead of just good/bad.
Unk: Converted all comment Lists to Mule Style Lists. (Do to sync issues, sorting doesn't work yet..)
.: 16 color support added. (eMule will now look better when viewing it with remote desktop at 16 color display.)

----------------------
- June, 13. 2005     -
----------------------
Unk: Fixed a bug in kad that returned the incorrect order of contacts to start a search. (thx Agthorr for finding bug)
Unk: During a KadRequest, we now sort the contacts in the bin based on the target first to make sure we send the best results.
Unk: Fixed a bug that treated all KadResults as a best result causing extra overhead. (thx Agthorr for finding bug)
Unk: Fixed a bug that removed wanted contacts in the "possible" list during Kad searches. (thx Agthorr for finding bug)
Ornis: splitterbar for the serverwindow
Ornis: reworked dialog lists setup save&restore:
        - added save&restore sort history
        - fixed column order error
        - sort history added for serverlist, sharedfileslist and all lists in the transferwindow
        - Updating to this version will not load your previous lists sort orders

----------------------
- June, 10. 2005     -
----------------------
Ornis: added support of multiple tempfolders (to seperate by  |  ). A tempfolder out of several is selected when adding a download, depending on the incomingfolder (category) and most free space. (temppath can not (yet) be changed lateron)
Ornis: webinterface links changed to be relative
Unk: FileDetailDialog is now used for all CListCtrl that deals with files.
Unk: General code changes.. (Ex. AbstractFile, SearchFile, KnownFile, StatisticFile are now in seperate .cpp/.h files. Changed class name of kademlia tags to avoid confusion of ED2K tags.)

----------------------
- June, 5. 2005      -
----------------------
zz: Print "0" instead of "<0" in Complete sources column in shared files list.

----------------------
- June, 2. 2005      -
----------------------
.: Added support for MediaInfo library versions 0.5.1 and 0.6.0 (http://mediainfo.sourceforge.net)

----------------------
- June, 2. 2005      -
----------------------
.: Added support for previewing encrypted RAR files and RAR files with "solid" compression.

----------------------
- June, 1. 2005      -
----------------------
Unk: All Comment lists auto refresh.
Unk: Added comment icon into sharedfile lists.
Unk: Comments found in search results are carried over into the download list.
Unk: Fixed possibility of accessing a deleted client object in the comment list.
Unk: Can view comments to more then one file at the same time.

----------------------
- May, 31. 2005      -
----------------------
.: Added support for previewing RAR files which contain extended date/time file information.
Unk: Added the ability to view comments (Kad Notes) on search results. (Find out what people think of the file before downloading..)
Unk: Fixed a possible memleak with Kad Notes.

----------------------
- May, 28. 2005      -
----------------------
.: Possible fix for minimize to tray problem reported for Windows NT SP6.
.: Added a startup check for proper version of Windows Shell32 DLL - should also help folks using Windows NT!
Unk: Fixed a lowID bug that caused a lowID user to report the wrong buddy IP/Port.
Unk: Added the ability to view comments (Kad Notes) for your shared files. (Find out what people think of your files..)

----------------------
- May, 26. 2005      -
----------------------
.: Fixed bug where ED2K search results were shown in Kad search results.

----------------------
- May, 26. 2005      -
----------------------
.: Fixed bug with client software statistics where equal client numbers were not shown.

----------------------
- May, 23. 2005      -
----------------------
.: MiniMule shows the nr. of completed downloads currently available in Download list only if 'Autoclear completed downloads' is disabled. If 'Autoclear completed downloads' is enabled, it shows the nr. of completed files in the current session.

----------------------
- May, 21. 2005      -
----------------------
zz: Fixed underflow error for "Shared parts" column in Shared files list, which caused parts to sometimes be shown as light blue even when they are common in the net.

----------------------
- May, 19. 2005      -
----------------------
zz: Bugfix to UploadSpeedSense (USS). Sometimes with low ping times and low Ping Tolerance settings it could get stuck at min speed.
zz: USS now detects when max ul limit is raised in prefs, and goes into "fast reaction mode" for a short while to quickly find out if it can raise the limit.
zz: When using several pings (tweak prefs setting), USS now uses median value instead of average value. This removes some of the randomness in the ping times to better see the trend and give a more stable speed. About 1-8 pings recommended.
zz: Slightly changed colors in "Shared parts" (fka "Obtained parts") column in shared files list:
      White = You don't have the part.
      Red   = You are the only one known to have/share this part. Please don't unshare the file.
      Blue  = You and others are sharing this part; the lighter blue, the less people sharing it.
      Black = You have this part, but its availability in the net is unknown (i.e noone have asked you for this file yet, and you are not downloading it)

----------------------
- May, 16. 2005      -
----------------------
.: Some modifications to avoid disapearing Search Parameters window.
.: Added new functions for PreviewApps.dat file. After the command line several parameters (separted by ';') can be specified:
Ext=<file extension> (the command will be invoked only for the specified file extension, specify several "Ext" commands for more extensions)
MinSize=<bytes> (min. completed part file size to enable the preview command)
MinStart=<bytes> (min. completed part file size from the start of the file to enable the preview command)

----------------------
- May, 15. 2005      -
----------------------
.: Added new tooltips for Transfers window.
.: Fixed bug in ZIP file archive preview for files containing a directory archive entry.

----------------------
- May, 11. 2005      -
----------------------
.: Fixed bug with SetSystemACP setting for fresh eMule installations.
Ornis: filesize limit of fileupload via webinterface can now be set in the preferences.ini, Section [WebServer] :  "MaxFileUploadSizeMB=5"  (or 0 for no limit)

----------------------
- May, 10. 2005      -
----------------------
.: Fixed wrong dealing with kBit/s and KB/s in several places.
.: Fixed glitches with main statusbar when using large system fonts.
.: Changed: Notifier.ini file is by default searched in eMule config folder.

----------------------
- May, 9. 2005       -
----------------------
.: Fixed bug with dropdown buttons in transfer window for large system fonts.
.: Added missing middle mouse button handling to transfere windows [thx SiRoB]
.: Added .cbz and .cbr file extension to ed2k/kad archive file type and previewable archive types.

----------------------
- May, 8. 2005       -
----------------------
.: Fixed a crash in Message window when right clicking on Close button.
.: Added new macros to webservices:
#name inserts the filename without extension
#cleanname inserts the cleaned up filename without extension
#cleanfilename inserts the cleaned up filename
.: Fixed a problem with registering eD2K links to be taken by eMule.
zz: Improved a4af code to work better for No Needed Part sources. Earlier code could make a source get stuck on a high prio NNP file even if there were other files (with lower prio) that weren't NNP.

----------------------
- May, 7. 2005       -
----------------------
.: Servers with a failure count of >= 2 or with a failure count which exceeds the specified one are shown in gray shades in server list control
.: 'Add Source' dialog and 'Add Friend' dialog: the IP and port optionally can be specified right in the IP control.
Ornis: fixed some bugs in the webinterface ( category change, javascript problems for some languages, speedbar percentage display,
       saving timeout from preferences, mixed priority assignment for servers)

----------------------
- May, 6. 2005       -
----------------------
Ornis: show filespecific source limit in downloadlist [] (if modified)  and in the filedetails dialog
Ornis: fixed disabled status of the source handling submenu (selection dependend), to allow access to the submenu items


v0.46a
----------------------
- May, 3. 2005       -
----------------------
.: Added eMail-Notification settings to the GUI, optional encryption still needs to be configured in the preferences.ini
.: Added the setting for alternate toolbar layout in the transferwindow into the preferences dialog
Ornis: fixed removing servers from static list from the webinterface

----------------------
- May, 2. 2005       -
----------------------
.: Fixed a socket resource leak in web interface.
.: Access to web interface can be restricted to a list of specified IP addresses. preferences.ini setting "AllowedIPs=<IP>[;<IP>]" section "[WebServer]"
Ornis: Renamed "adresses.dat" to "addresses.dat" for automatic serverlist updates on startup. Renaming will be done automatically during startup on this upgrade.

----------------------
- May, 1. 2005       -
----------------------
.: eMule now (optional) remembers files which were cancelled and marks them in the searchresults
.: Remembering downloaded files can be disabled and eMule will purge all unneeded records from known.met and known2.met
.: Fixed a bug which sometimes caused a sharing Violation in known2.met when starting eMule

----------------------
- Apr, 28. 2005      -
----------------------
.: Implemented protocol change for server for getsources (local/udp) suggested by lugdunum

----------------------
- Apr, 26. 2005      -
----------------------
.: Added new drop down buttons in Transfers window to select different view types for main and sub window.
.: Added preferences.ini setting "WinaTransToolbar=1" (section "eMule") to enable an alternate toolbar layout in Transfere window.

----------------------
- Apr, 23. 2005      -
----------------------
.: Fixed: Queue Ranking of sources in Download Listview were not always updated properly.
.: Added some missing protocol overhead stats.
Unk: Couple very small gui changes to the setup wizard and file comment list.

----------------------
- Apr, 19. 2005      -
----------------------
.: Merged the view selector and the downloadingclients view from Mods [TBH]

----------------------
- Apr, 17. 2005      -
----------------------
.: Fixed a bug which made it theortical in some rare cases possible that eMule sent unverified data to other clients
Ornis: fixed not working commands on downloadlist multiselections in certain cases
Ornis: added manual filename cleanup on selected files in the downloadlist by pressing Ctrl+F2

----------------------
- Apr, 13. 2005      -
----------------------
.: Fixed bug with file comments/ratings when receiving a rating without a comment [thx MogTheCat]
.: Added support for new PeerGuardian IP filter file format v2.
.: To reduce overal network overhead, dead servers are detected faster and not used for UDP sources and file searches until they are deleted.
.: The priority specified in downloaded server.met files is ignored. Server priorities can still be used for the local server list.

----------------------
- Apr, 6. 2005      -
----------------------
.: Sortorder and scrollposition are now saved for every open searchresult when switching between them


----------------------
- Apr, 4. 2005       -
----------------------
.: Added E-Mail notification for "Download finished" and "Important Error" eMule notifications. Configurable via preferences.ini file section [eMule]
        Enable E-Mail notifications with: "NotifierSendMail=1"
        Specify SMTP server with: "NotifierMailServer=<server>"
        Specify recipient's E-Mail address with: "NotifierMailRecipient=<e-mail-address>"
        Specify sender's E-Mail address with: "NotifierMailSender=<e-mail-address>"
Optional: Specify certificate to be used for encrypting the e-Mail with S/MIME with: "NotifierMailEncryptCertName=<certificate-subject>". The certificate is searched in the local 'addressbook' certificate store only.

----------------------
- Apr, 1. 2005       -
----------------------
.: Fixed bug with eD2k link parsing when no filename (or filename with just spaces) was specified in link.
.: Fixed bug with partfile renaming when new filename contains only spaces.

----------------------
- Mar, 23. 2005      -
----------------------
.: Source base is compiled with warning level 4 (and corrected)
.: Kad keyword searching and publishing of short words changed to circumvent some limitations for Asian phrases.
.: Fixed bug in keyword publishing related to filenames ending with too much unpublished characters.
.: Fixed some GUI glitches in Friend listview.
.: Fixed bug which prevented eMule to minimize to system tray.
.: Brushed up Shared Folders context menu in Options/Files.
.: Changed all sound creating functions to not use the PC-speaker in case there is no sound card available.
.: Log files clearly show session start/end messages.
.: Fixed bug with log messages which were not written to log files during early startup. 
.: MiniMule shows accurate connection icon.
.: MiniMule shows the nr. of completed downloads currently available in Download list.
.: MiniMule can be properly attached to each edge of the desktop window (depending on taskbar position).
.: MiniMule - fixed problem with eMule installation path containing some special characters.
.: Added optional Text-To-Speech notification. For each generated notification eMule will "read" the log message in the system's default Text-To-Speech engine.
.: Added support GZip compressed IP-filter files.
.: Fixed bug in log panes which could create auto-endless up-scrolling.
.: Fixed bug in log panes which displayed text too far on top if pane was first time enabled.
.: Disabled extracting of MetaData with DirectShow - until a more reliable way is implemented.
.: Experimental: Added a more efficient method to reject TCP connections of filtered and/or banned clients; see Options/Ext. settings
.: All graphs in Statistics window have a different appearance when "StraightWindowStyles=1" is specified in Preferences.ini, section [emule].
.: Couple of optimizations in drawing the statistics graphs.
.: When closing the Options dialog, the preferences.ini file is saved only if really needed.
.: Searchresult panes: When switching to/from panes with collapsed search entries, the state is properly saved/restored.
.: Couple of optimizations in search result handling.
.: When receiving different file names for a search result, the filename with the highest availability is eventually used for showing the result
.: In ext. user mode only: Search results show nr. of complete sources by percent and accurate number.
.: Fixed bug with not adding all available source found during searching when adding a file via an sub-entry to the download queue.

----------------------
- Mar, 14. 2005      -
----------------------
Ornis: Filename cleanup: dont uppercase character behind apostrophe
Ornis: Fixed wrong file statistics of (previously) stopped files [Xman]
Ornis: Set file based sources limit via downloadlist context menu (when extended controls enabled)

----------------------
- Feb, 27. 2005      -
----------------------
.: Log file format for standard and verbose log files can be set to UTF-8 with preferences.ini setting "LogFileFormat=1" (section "[eMule]").
.: Added support for new PeerGuardian IP filter file format v1.

----------------------
- Feb, 26. 2005      -
----------------------
.: Fixed bug with too high PeerCache socket timeouts [thx so8so]
zz: Small fix to USS to prevent it from sometimes disabling itself when network connection is lost. Once the first init of USS is complete it should now never disable itself.

----------------------
- Feb, 22. 2005      -
----------------------
.: Fixed issue where bugged compatible clients could receive sources for a file they did not ask for.
.: Fixed bug with Kad-notes which were received but not stored.

----------------------
- Feb, 18. 2005      -
----------------------
Ornis: moving mouse over statisticgraphs and holding down left mousebutton will display a tooltip containing the corresponding date and time at the current mouseposition in the graph (calculated by the CURRENT statistic settings)
Ornis: merged webinterface from eMule+, adapted, did some fixes and added:
                         - Kad-window
                         - show comments & ratings
                         - download of completed files via browser (up to 5MB filesize)

----------------------
- Feb, 12. 2005      -
----------------------
.: Fixed 'Transferred' column data display and sorting in Upload list control.
.: Reworked all dialogs to properly show the '&' characters in filenames.
.: Fixed comment rating label order.
.: Fixed possible misplaced up/down buttons in details dialog.
.: Upgraded to zlib 1.2.2.
.: Experimental: Added Right-to-Left reading support. Enable in Preferencs.ini: Section=[eMule]; Setting=RTLWindowsLayout=1


v0.45b
----------------------
- Feb, 11rd 2005     -
----------------------
.: Fixed a bug related to the new kad-filecomments which would cause eMule to freeze [thx gcostanza]
.: Fixed a bug related to the udp-server protocol which could emule let drop packets or if malicious crafted freeze [kry]
.: The downloadwindow now remembers the 4 last sort orders and uses them as secondary sort orders
.: A displaybug in the uploadwindow has been fixed
.: A problem which caused eMule to call the onlinehelp even if an appropriate helpfile was available has been fixed[cml]
Ornis: Fixed lowercased path entries in the shared files list
Ornis: Fixed issue with autoresume after file completion
Ornis: Fixed secure identitfication statistics with a >100% entry


eMule 0.45a
----------------------
- Jan, 25rd 2005     -
----------------------
Ornis: little updates in the web interface to category items, remember last used category in session, display first results on new search)
Ornis: statistic graphs: added vertical marker for every hour and enlarged statistic update delay [CB mod]
Ornis: added command line argument to reload ipfilter: "emule.exe reloadipf"
Unk: Corrected a issue where the keyword or source index was not restored.
.: Fixed bug with wrong user-id/IP for http sources [thx SiRoB]

----------------------
- Jan, 23rd 2005     -
----------------------
Unk: Fix a possible situation that may cause kad to not store sources.
Unk: Removed some unneeded parameters in the search class.
Unk: Added "Notes" for kad. Currently used to store file comments.. (Will not work until a majority of users upgrade.)
Unk: The time between Kad file source reasks slowly adjusts over time to ease up on overhead and redundant results. (Let the source exchange do it's job..)

----------------------
- Jan, 17th 2005     -
----------------------
Unk: Some general cleanup in some code when Kad thread was integrated to the main thread.
Unk: Fixed Download List sort bug where sources could be displayed with the wrong file. (Fix by KinkyJohn)
Ornis: category view filters more flexible
Ornis: categories can be filtered by regular expressions on the filenames (as view filter)
Ornis: middle mouse click closes tabs (messagewnd, irc, search results)
Ornis: coloring of search results customizable via skin

----------------------
- Jan, 16th 2005     -
----------------------
Unk: The AddOnNextConnect flag we gave to lowID users that missed their uploadslot still didn't work well as the user had to reconnect within a specific window.
- Now that flaged user can reconnect anytime that doesn't violate the protocol and get the upload slot.
- Only one user can have that slot at any given time to avoid the uploadlist from getting out of hand just in case more then one lowID user got flaged.
- Once a user is removed from the upload list, this slot is available again.
Unk: Relaxed the conditions for users to enter the upload queue of a lowID client.
- We still monitor for users on the upload list that try to get around the lowID callback limits through servers.
- We do not monitor Kad users on the upload list as the callbacks are all currently valid.
Ornis: automatic category assignment can now also be done by regular expression rules
.:          Navigation in the file detail- and client detail dialog:  up/down buttons allow scrolling through the items within the current list

----------------------
- Jan, 14th 2005     -
----------------------
.: Fixed bug with Unicode passwords in Web-interface and MobileMule-interface. Note: Your need to specify new passwords for those interfaces.

----------------------
- Jan, 9th 2005      -
----------------------
.: Added new setting in preferences.ini (Section=[eMule], Keyword=PreviewOnIconDblClk, Value=1) to invoke preview command when double clicking on file icon in download list. This setting is used only if "Downloadlist doubleclick to expand" (in Options/Display) is disabled.
Unk: We now use load balancing on publishes. If we publish a keyword to a section of network that has a high load, we increase delay for the next republish time. These times are also carried between restarts of the client.
Unk: Reworked the loop that rechecks what keywords to publish to reduce cpu load.

----------------------
- Dec, 31th 2004     -
----------------------
bluecow: Changed: Amount of uploaded/downloaded data to/from a client shows the raw (compressed) data size (which is also used for credits).
bluecow: Fixed sorting bug in upload list control.
bluecow: Changed: Maximum supported file size is 4290048000 bytes.

----------------------
- Dec, 30th 2004     -
----------------------
bluecow: Fixed bug in client statistics for banned and IP-filtered clients.
bluecow: Fixed crash with sending a message to an new added friend [thx Libbnor]
bluecow: Fixed bug with wrong hashset creation in case file could not successfully read (may indeed happen with NTFS compressed files with very high compression!?)
bluecow: Fixed bug with files of too large size when added via search results.

----------------------
- Dec, 29th 2004     -
----------------------
bluecow: Added 'Extract Meta Data' setting to enhanced options dialog.
Unk: Fixed a bug in SMIRC if CHANMODES was missing from the welcome message.

----------------------
- Dec, 27th 2004     -
----------------------
Unk: Ping/Pong system added for buddies to prevent stalled buddy connections.
Unk: Fixed a couple bugs in the hello packets for buddy information.
- If your firewalled and you have sources that are also in your queue, they will be able to more easily follow you if you change buddies.
- Only firewalled users with a buddy will send the buddy info to lower overhead.

----------------------
- Dec, 26th 2004     -
----------------------
bluecow: Added default creation of 'skins' subdirectory in eMule application folder which will be used as default directory for eMule Skins and Toolbar bitmaps.

                 -enabled Japanese translation, which was updated by DukeDog

----------------------
- Dec, 24th 2004     -
----------------------
bluecow: Added Windows Internet Security Manager for external loaded HTML files.
- Internet Security Zone policies are taken from Windows Internet Settings System Applet (same settings as used by Internet Explorer).
- Default Internet Security Zone used by eMule is set to highest level: "Untrusted Zone"
- Internet Security Zone can be changed in preferences.ini file: Section=[eMule], Keyword=InternetSecurityZone, Values=Untrusted|Internet|Intranet|Trusted|LocalMachine
bluecow: Added sorting of context menu entries for toolbar bitmaps and skin profiles.
bluecow: Shared files which have a user comment and/or user rating attached are displayed with a small additional overlay icon in Shared Files window.
bluecow: Added icons for network share information column in Shared Files window.
bluecow: Fixed some GUI glitches [thx apph]
bluecow: Fixed some bugs with statistics colors in Options/Statistics page.
bluecow: Added some double-click shortcuts:
- Server window: Double-click on Server list icon opens Options/Server page.
- Shared Files window: Double-click on Shared Files list icon opens Options/Directories page.
- Messages window: Double-click on Friends list icon opens Options/Files page.
- Statistics window: Double-click on any graph opens Options/Statistics page.

----------------------
- Dec, 22th 2004     -
----------------------
bluecow: Fixed bug with status.log file which truncated filenames to 50 chars.

----------------------
- Dec, 21st 2004     -
----------------------
zz: Improvements to download throttler to lower amount of timed out/failed download sessions.

----------------------
- Dec, 19th 2004     -
----------------------
bluecow: Fixed Unicode bug with ed2k links added via web interface.
bluecow: Fixed bug with file priority in web interface [thx CML]
bluecow: Added Unicode search parameter to web interface [thx CML]
bluecow: Local hostname (if specified in ext. settings) is used for web interface URL shown in MyInfo.
Unk: Force a node lookup when it appears Kad may be disconnected to verify if we are really disconnected.
Unk: Firewalled Kad users will instantly look for a new buddy when it loses it's current buddy instead of waiting for next firewall check.
Unk: Firewalled users will republish it's sources if they changed buddies.
Unk: If something happens and a Kad Buddy lookup fails, it will continue to retry the lookup until successful.

----------------------
- Dec, 13th 2004     -
----------------------
Unk: Changed the Kad search list to show info clearer and to add the Node Load column.
Unk: Fixed a bug that could access a NULL kad buddy pointer.
bluecow: Fixed crash with system tray context menu, opened preferences dialog and restored main window.
bluecow: Fixed bug: Shared directory names with Unicode characters were ignored at startup.
bluecow: File format of "shareddir.dat" and "adresses.dat" changed to Unicode. Old (ANSI) files are read and converted to Unicode automatically at startup. Previous (ANSI) eMule versions can not read those files any longer.
Unk: Fixed a bug that prevented lowID clients from publishing as a source into the Kad network.

----------------------
- Dec, 12th 2004     -
----------------------
bluecow: Added startup check for proper version of COMCTL32.DLL.
bluecow: Merged debug dump build into release build. To enable crash dump generation, specify "CreateCrashDump=1" in "eMule" section of preferences.ini file.

----------------------
- Dec, 9th 2004      -
----------------------
bluecow: All packets received from eD2K servers can contain Unicode strings. (Server admins can announce their server's description in Unicode).
bluecow: Added new Mini eMule window with basic stats and functions. Single click in eMule System Tray icon to open it.
- Mini eMule window can be customized with HTML template (see Template.eMuleSkin.ini for details).
- Mini eMule window can be disabled with following setting in preferences.ini file (section "[eMule]") setting: "MiniMule=0". (read only on startup)
- Mini eMule window can be customized with following settings in preferences.ini file (section "[eMule]"). Those settings can be modified during eMule is running (no need to restart).
-      Setting: "MiniMuleAutoClose=1" Mini eMule window will automatically close itself if mouse cursor is not located within the window (similar to a tooltip).
-      Setting: "MiniMuleTransparency=<0-100>" Transparency (in percent) of Mini eMule window.

----------------------
- Dec, 4th 2004      -
----------------------
bluecow: Reworked 'Startup Minimized' and main window restoring after startup to avoid some window redrawing problems.

----------------------
- Nov, 21th 2004     -
----------------------
bluecow: Fixed sorting bug in download list with "Time Remaining".

----------------------
- Nov, 17th 2004     -
----------------------
bluecow: Reworked eMule Main toolbar:
- Added chevron support: If toolbar is too small to display all buttons a chevron (">>" icon) is shown at the very right side which opens a menu with the remaining button commands.
- Tooltips are shown for truncated button titles and in "No Labels" mode of toolbar.
- Buttons can be moved and/or removed from the toolbar by holding down Ctrl+Alt key while draging a button with the mouse.
- Buttons can be set to large or small.
- Button sizes more similar to Windows Explorer.
- All new toolbar features can be disabled with "ReBarToolbar=0" setting in preferences.ini.
- Toolbar background can be customized with skin profile (see Template.eMuleSkin.ini file)
bluecow: Fixed bug with vertical oriented fonts in Statistics window.

----------------------
- Nov, 16th 2004     -
----------------------
bluecow: Preferences.ini setting ShowCopyEd2kLinkCmd=1 replaces "Show eD2K Links" command with "Copy eD2K Links"
bluecow: Fixed GUI glitches with context menus in Log-, Message- and IRC panes.

----------------------
- Nov, 14th 2004     -
----------------------
bluecow: Searching in eD2K and Kad is now defaulted to use Unicode search expressions.
bluecow: File comments dialog in Shared Files window can be invoked for multiple files.
bluecow: Fixed not working buttons in Message window.
.: Icons in contextmenus have been disabled for Win98/ME due to reported problems
.: Minor bugfix in the new corruption detector

v0.44c
----------------------
- Nov, 8th 2004      -
----------------------
.: eMule is now able to detect which clients sent corrupt data and bans those if a threshold is reached (based on AICH)

----------------------
- Nov, 1st 2004      -
----------------------
bluecow: Fixed counter overflows for some cumulative statistics. [thx BinGordon]
bluecow: Fixed bug with max. download rate. [thx ChrisV]
bluecow: Fixed bug with "Needed Spaced for Downloads" stats for NTFS compressed and sparse files.
bluecow: Brushed up preferences dialog.

----------------------
- Oct, 15th 2004 -
----------------------
.: Added icons to most contextmenus [thanks Daan for providing the icons]
.: Fixed a unicode bug in the MobileMule server
Ornis: added commands (show details and add as friend) to the contextmenu for tabs in the chatwindow 

----------------------
- Oct, 14th 2004     -
----------------------
Ornis: view filer now available for all category tabs

----------------------
- Oct, 10th 2004     -
----------------------
Ornis: imported part files will be shared immediately if possible

----------------------
- Sep, 28th 2004     -
----------------------
bluecow: Fixed memory leaks, exception handling and tag list reading of Kad tags.

----------------------
- Sep, 26th 2004     -
----------------------
bluecow: Fixed bug in some log panes which were not obeying the max. log buffer limit.
bluecow: Added support for NTFS sparse files for new created part files.

----------------------
- Sep, 25th 2004     -
----------------------
bluecow: Fixed bug in client download data rate computation [thx Aw3]
bluecow: Optimized MD4 and SHA1 hashing code to a total increase of hashing performance by 50% [thx Camper(Shareaza)]

----------------------
- Sep, 24th 2004     -
----------------------
bluecow: Fixed default font selection for some GUI elements for locales with multibyte character fonts.
        
----------------------
- Sep, 20th 2004     -
----------------------
bluecow: Reawakening of search parameters restoring. Double-Click or Ctrl+Click on Search Result tab to restore all parameters used for that particular search.
bluecow: All eMule*.log files are stored in .\logs directory. Already existing log files are automatically moved there.
bluecow: Fixed duplicate scroll bar problem in search dialog for low screen resolutions.

----------------------
- Sep, 19th 2004     -
----------------------
bluecow: Fixed bug with queued thread log messages which could lead to a crash in some cases.
bluecow: Fixed Unicode bug in Statistics HTML file export function.
bluecow: Added:Errors/Warnings/Success messages are shown in log panes with dedicated colors.
bluecow: Reworked ID3 tag reading code for Media Info dialog to show more proper information.

----------------------
- Sep, 15th 2004     -
----------------------
bluecow: Added tooltip for "Connected" pane in status bar which shows the currently connected eD2K server and server users.


v0.44b        
----------------------
- Sep, 10th 2004     -
----------------------
bluecow: Fixed Unicode (Win9x) bug with wrong displayed free disk space.
bluecow: Fixed Unicode (Win9x) bug with not working shared directories control.
bluecow: Fixed Unicode bug with missing UTF8 conversion in web interface.
bluecow: Added 7-zip file extension to known archive types for publishing and searching files.
bluecow: Fixed Unicode bug in main toolbar initialiation which could cause not working shortcuts.
bluecow: Fixed Unicode (Win9x) issue with copying ed2k links to clipboard.
bluecow: Workaround for an obvious bug in Windows DNS library which returned invalid data.
bluecow: Fixed a bug which could cause resumed files (due to less disk space) get paused again immediatly.
bluecow: Added option to specify whether the system code page shall be used to non-Unicode string conversions (SetSystemACP=1). This is only for backward compatibility for users which specified a different codepage for non-Unicode applications. It is not recommended to use this option without having a very special reason to do so.
bluecow: Added automatic detection of system code and current codepage when eMule is started the 1st time (semi-automatic setting of SetSystemACP=1).
bluecow: Fixed Unicode (Win9x) bug with empty IP filter listview control.
bluecow: Fixed Unicode (Win9x) bug with missing tooltips in download listview control.
.: Fixed the "Run As Secure User" function
.: Fixed a "Runtime Error"-crash which could appear when Kad is enabled
.: Fixed handling of corrupt known2.met files
.: Fixed a bug which let eMule temporary assume a wrong AICH hash for a partfile which was rehashed after startup
.: Fixed some potential problems with reading media info from files

----------------------
- Sep, 9th 2004      -
----------------------
bluecow: Fixed divide by zero bug in Kad contact histogram
zz, bluecow: Fixed UploadSpeedSense UDP pinger.
zz: Fixed alphabetical sortorder for resume next file.
Unk: The delay in creating upload slots can cause the credit system upload method to remove too many upload slots.. (fixed)

----------------------
- Sep, 8th 2004      -
----------------------
Unk: Fixed a possible memleak bug I added in 44a with a bad Kad Tag.
bluecow: Fixed memleaks in PC finder and frame grab threads.
bluecow: Added AspectRatio property to Media Info dialog.
bluecow: Added verification whether file extension of downloaded/shared files matches the file format (only used with MediaInfo library installed -- see also, older change log entries according MediaInfo Lib).
bluecow: Added new preferences setting 'InspectAllFileTypes=1', currently used only in MediaInfo dialog to determine the file format of downloading/shared files by evaluating the headers (most usefull when MediaInfo Lib is installed).
bluecow: Fixed bugs in Video Preview and Archive Preview threads related to wrong file pointer usage which could create wrong temporary files for previewing (in rare situations).
bluecow: Added new preferences setting 'PreviewCopiedArchives=0' to use an alternate method for previewing archive files (faster, uses less disk space on temporary folder drive).
bluecow: Added new preferences setting 'ShowActiveDownloadsBold=1'. Active downloading files and uploading sources are shown in bold font in Transfere window.
bluecow: Changed: server.met and ipfilter.dat URLs are added to auto-completion lists even the download failed to not loose the entered URLs.
bluecow: Added: When selecting multiple servers in servers list control, a tooltip is shown with summarized stats of selected servers.
bluecow: Added: When selecting multiple search results, a tooltip is shown with shows the summarized file sizes of the selected files.
bluecow: Fixed Unicode bug with manually saved log files.
bluecow: Fixed Unicode bug with "?" character in file comments dialog.
bluecow: Fixed Unicode bug with ANSI log files which were continued in Unicode.

----------------------
- Sep, 3rd 2004      -
----------------------
Unk: Change in the source Index so it only sends the most recent entries..

v0.44a
----------------------
- Sep, 2nd 2004      -
----------------------
Unk: Kad now remembers Kad's last open/firewall state during the recheck process to prevent temporary false reports.
Unk: It now takes two consecutive matching IP responses for Kad to change your current known IP to help filter bad responses.
.: Updated MobileMule protocol to 0.9a (bugfix)
.: Fixed a bug which could lead to a wrong status of obtained parts for downloading clients

----------------------
- Sep, 1th 2004      -
----------------------
.: Added new Dialogpage for creating ED2K Links with of shared and downloading files (replaces old context menue entries)
.: Update ligpng to 1.2.6 to fix security issues (which however had only minor influence on eMule)
.: IP Filter is now also used to ignore filtered incoming UDP packets
.: Added a preference option to choose between simple (prio 0.43) or adanced calculation of the remaining time for downloading files
.: Introduced additional new hashsystem (AICH Hashs) which will reduce the average amount of dataloss when a part is corrupted from
   4.64MB (with ICH) to 180KB. The system is most effective when using links with attached AICH hash, which eMule can now also create
   Please refer check the helpfiles/onlinehelp for more information about this new feature.
   IMPORTANT: Due to the additional hash algorithm, eMule has to rehash all your shared files - this is a one-time thing, which can't be avoided.
    

----------------------
- Aug, 26th 2004     -
----------------------
Unk: Attempt at a estimate file count in Kad.

----------------------
- Aug, 23rd 2004      -
----------------------
Unk: Fixed potential memleak in a upload client.
Unk: Changed how we estimate Kad users.

----------------------
- Aug, 22nd 2004     -
----------------------
Unk: Changed method of deleting Kad Contacts. Contact list should stay more up to date.
Unk: We do not save all Kad contacts on exit. Save a sample of up to 200 contacts to help lower to amount of pinging to dead contacts.
Unk: Changed it so all displayed transfering values goes through one method to try to standardize them.

----------------------
- Aug, 21st 2004     -
----------------------
Unk: Added an option to manually add a source.
Unk: If Kad has seen no incoming traffic for a set time, it's assumed you lost your connection and will auto disconnect.
Unk: Fixed a bug that sends many Kad Bootstrap packets when not needed.
Unk: Some maintance with the Kad code.. (Removing some unneeded code, switching the log events to eMules, ect.)

----------------------
- Aug, 20th 2004     -
----------------------
Unk: Adjusted the estimated time remaining again to hopefully get it more stable.
.: Reworked handling of dead sources (avoids that sources which are known to be unreachable are asked again within a certain time period)

----------------------
- Aug, 19th 2004     -
----------------------
Unk: Added a option to auto start eMule when starting windows..
Unk: Fixed a bug in TryToConnect that at times could check the wrong IP/ID with the IP filter..
Unk: Added to the statistics how many known clients are connected to ED2K and/or Kad.

----------------------
- Aug, 18th 2004     -
----------------------
Unk: We now keep track of Half Open sockets and limit new connection if Half Open sockets are too high. (If approved and kept in, it should help with SP2 and some nick cards and routers..)
Unk: We no longer allow a socket pending Connect to time out until OnConnect is called. ( If approved and kept in, it should help with SP2 and lost sources..)
Unk: Added to the statistics how many sources are connected to ED2K and/or Kad.
Unk: Added to the client details if the user is connected to Kad.
Unk: Removed warnings about Kad being beta.

----------------------
- Aug, 15th 2004     -
----------------------
Unk: First phase in adding firewall user support for Kad. This support will not work well until most users upgrade within the Kad network..

----------------------
- Aug, 9th 2004      -
----------------------
Unk: Increased time between keyword publishes to reduce overall Kad overhead.
Unk: Fixed possible memleak if an incoming Kad publish failed.
Unk: Put some limits on how many keywords you index.
1) Global keyword limit.. (You never index more than this)
2) Local keyword limit. If your indexing one VERY popular index, it will be limited to allow less popular indexes to be stored.
3) Now if you happen to be one of the "lucky" ones that indexes a very popular node, your client will not freeze up trying to keep up.

----------------------
- Aug, 8th 2004      -
----------------------
zz: Resume next now uses a4af order: Alphabetical order if enabled for a category, cat-prios, file-prios etc. If you select "Resume next" in a category popup menu, it will only resume a file in that category; none if no file is paused in that category.

----------------------
- Aug, 5th 2004      -
----------------------
zz: UploadSpeedSense min limit is now allowed to be lower than 10 KB/s (default is 1 KB/s). Please note that when UploadSpeedSense lowers the speed below 10 KB/s, the ratio download limiter will dynamically kick in until the speed goes over 10 KB/s again.

----------------------
- Aug, 4th 2004      -
----------------------
zz: improved No Needed Parts a4af management. Will now occasionally reask lower prio nnp files on a source, if all files are nnp on that file. This will prevent it from remaining on the highest prio file when it's nnp and lower prio files has stopped being nnp since last checked.

----------------------
- Aug, 1st 2004      -
----------------------
bluecow: Fixed client version statistics.

----------------------
- Jul, 31st 2004     -
----------------------
Unk: Fix a upload bug that caused uploads to stop sending after a complete chunk with a small queue. This should fix some issues with lost Friend Slots.
Unk: Did some merging from some Mods..
1) IRC gui updated.
2) Message gui updated.
3) Statistics gui updated.

----------------------
- Jul, 26th 2004     -
----------------------
bluecow: Sorting of strings in UI is locale dependant (very similar to sorting order of Windows Explorer)
Ornis:fixed a bug on processing the downloadlist in the webinterface

----------------------
- Jul, 24th 2004     -
----------------------
bluecow: Added 'Network Info' dialog. Double click on connection icon in statusbar to open it.
bluecow: Fixed some minor bugs in file comments/ratings processing and GUI.
bluecow: Download listview shows system file icons for part files.

----------------------
- Jul, 20th 2004     -
----------------------
bluecow: Fixed bug with servers which when added via ed2k link were set to low priority.
Ornis:on regular intervals, avoid recreating the same systrayicon as before
Ornis:Ctrl+V inserts ed2k-filelinks from the clipboard to the download

----------------------
- Jul, 17th 2004     -
----------------------
bluecow: Added Kad contact histogram control.
Ornis: added port-checker. Integrated into the first-start-wizard and the connection preferences, you can start a port test. A webscript will check your eMule and display results and hints on your browser.
Ornis: TCP and UDP Port can be changed during the runtime of eMule, if no server or kad connection is established an no client has been connected yet.

----------------------
- Jul, 16th 2004     -
----------------------
zz: Fixed USS bug to make it survive rare occasions when no earlier ttls is pingable than the differing ttl is found.
zz: Fixed bug that didn't resume/pause/stop all files in a category when context message for a category is used.

----------------------
- Jul, 12th 2004     -
----------------------
zz: Prevent client that doesn't currently have an upload slot from successfully adding blocks to their request queue. This prevents us from sending these blocks when the client then receives an upload slot.

----------------------
- Jul, 7th 2004      -
----------------------
zz: Small fix to make eMule request sources for files in the same order as the a4af priority (a4af auto, cat prio, file prio, alpha).
zz: Show which upload slots are in standby, with status text and graying them out.

----------------------
- Jul, 6th 2004      -
----------------------
zz: Soft queue limit at whatever entered in preferences. Hard queue limit 25% higher. When soft limit is reached, eMule only allow high credit clients, or clients that want high prio files, to get on queue.
unk: Fixed an priority bug that cause lower priority files overseed high priority files. Also hopefully lowered some cpu cycles with this change.

----------------------
- Jul, 5th 2004      -
----------------------
zz: "Try to get preview parts first" selectable on individual files if "Try to get preview parts first" is disabled in preferences. Please note that "Advanced mode controls" (tweak prefs) needs to be enabled for this menu option to show up.

----------------------
- Jul, 3rd 2004      -
----------------------
bluecow: Statistics in Shared Files window show a summary of all selected files.


v0.43b - Hotfix
----------------------
- Jul, 5th 2004      -
----------------------
.:    Fixed a bug which let eMule reject most available PeerCaches
Ornis:Statistics (requests,accepted requests,transfered) of partfiles are now saved and restored too (like for shared files)
zz: Opens less slots if UploadSpeedSense lowers upload limit


v0.43a
----------------------
- Jun, 28th 2004     -
----------------------
bluecow/. : eMule now supports PeerCache, a technology which allows ISPs to reduce the bandwidth usage by caching instead of throttling the downloadspeed
Unk: Option to block people from adding you as a friend through SMIRC.
Ornis: Option to auto resume paused downloads only for same category as a completed download (additional to option of prefering same category)
Ornis: Dont show "new message" loginfo for filtered messages
bluecow: eMule is entering defcon level 3..
*) TCP connection attempts from filtered IPs are refused right at TCP protocol level.
*) TCP connection attempts from banned clients are refused at TCP protocol level.
*) LowID callback requests from servers are dropped if IP is filtered or banned.
*) Received sources (servers, source exchange) are filtered to drop already banned clients.
*) All UDP packets from banned clients are ignored.
*) Extra safety code to prevent connecting to an IP filtered IP or banned client.

----------------------
- Jun, 25th 2004     -
----------------------
.: eMule can open the ports it needs on the internal WinXP(SP1 or 0) firewall itself either permanently (connection pref) or on each startup (extended settings)

----------------------
- Jun, 20th 2004     -
----------------------
zz: Possible fix to the reported cases when eMule doesn't reach the upload limit.
bluecow: Added some protocol procedure sanity checks to avoid getting flooded by bugged clients.
bluecow: Fixed a flaw in the IP filter which lead to not reading some lines from PeerGuardian filter lists which had a bad format.

----------------------
- Jun, 15th 2004     -
----------------------
bluecow: Added new context menu item in Shared Files window (only for completed 'eMuleSkin.zip' files) to install eMule Skins.
zz: Changed upload bandwidth throttler to minimize the number of ACK packets.

----------------------
- Jun, 13th 2004     -
----------------------
zz: Some changes to speed up UploadSpeedSense preparing phase, when a ttl doesn't respond to pings. Also changed the upload limit during preparing phase to 2 KB/s instead of 512 bytes/s to prevent kademlia from getting false "firewalled" status.
zz: Changed the equal-for-all implementation in upload bandwidth throttler to minimize packet fragmentation on tcp level.

----------------------
- Jun, 12th 2004     -
----------------------
bluecow: Reworked the 'charset' selection for emule web interface to use proper codepage value in returned HTML code.
bluecow: Reworked searching via web interface in relation to file type search parameter. (New web templates!)

----------------------
- Jun, 10th 2004     -
----------------------
bluecow: Changed option to remove dead servers: Any server which exceeds a max. failure limit is removed from server list.
bluecow: Added "Document" file type for published files and also to search parameter for eD2K and Kad.
Ornis:   Splitted statistics to be stored in "Statistics.ini"

----------------------
- Jun, 9th 2004      -
----------------------
bluecow: Many small fixes for changing language during runtime.

----------------------
- Jun, 6th 2004      -
----------------------
zz: Improved a4af manager. Set the file you want first to "high" download priority (priorities now effects a4af decisions). You can chose to get the files in a category in their alphabetical order. A source may be (automatically) swapped to another file to enable source exchange on that file. Respects reask times in all cases, so it may take a while before sources are moved (but this change prevents banning due to a4af actions).

----------------------
- Jun, 3nd 2004      -
----------------------
bluecow: Added unzipping of IP filter files from PeerGuardian ZIP files.

----------------------
- Jun, 2nd 2004      -
----------------------
Unk: Completely reworked the gui structure for SMIRC.
Unk: SMIRC will now get available channel modes from the server on connect.
Unk: You can now set/unset TypeD channel modes.. You can also unset TypeC channel modes. (More support may be added later)

----------------------
- Jun, 1st 2004      -
----------------------
bluecow: Reworked IP Filter tool window to support large IP filter lists more effeciently.
bluecow: Added progress information for part files when getting hashed or copied to incoming folder.
bluecow: Added color customization (via skin profile) for server info, log, chat and IRC windows.
.: Added loglevels for verbose output in order to allow showing only important messages
.: Fixed a bug which caused that some known contacts were never deleted, even if not needed anymore
.: Complete sources are now shown as percentage in a new column. If there are zero complete sources for a file, this colum is marked red

----------------------
- May, 31st 2004     -
----------------------
Unk: SMIRC will now get available user modes from the server on connect to allow it to use servers that use non standard usermodes.
Unk: SMIRC Now creates a dynamic nick menu showing which Op commands are available based on the user you click and user modes available.
Unk: SMIRC can now handle an nicklist from the server that contains ALL usermodes not just the major mode.
Unk: SMIRC is now able to detect what type of MODE change was done so it can handle/display it correctly.

----------------------
- May, 27th 2004     -
----------------------
bluecow: Fixed bug with inaccurate completed size for part files.
bluecow: Couple of minor bug fixes and optimisations in bar shader related usage for part files and downloading/uploading clients.
bluecow: Fixed bug which sometimes draws randomly yellow blocks for sources.
Ornis:         Category-wide resume will now also care for out-of-diskspace-paused downloads

----------------------
- May, 26th 2004     -
----------------------
bluecow: Fixed bug with specifying empty directories for incoming and temp folders.
bluecow: Added server LowID statistics to Server and Statistics window.
bluecow: Added stats for showing amount of data saved by I.C.H.
bluecow: Added saving/restoring of corrupted part list to part.met files so that I.C.H. can work on those parts even after eMule was restarted.

----------------------
- May, 23th 2004     -
----------------------
bluecow: Fixed potential crash bug under Win98 with helper icon in search parameters window.
bluecow: Fixed bug with wrong part count for very large files. [thx Pichuein]
bluecow: Fixed bug in Directory preferences dialog which changed the active directory.
Ornis:          Fixed a bug in the toolbar button code, when all buttons were removed
Ornis:         (possibly) fixed the issue of misplaced category tabs (couldnt reproduce it at all, for testing)
Ornis:   Fixed webinterface exploit (content length misuse)

----------------------
- May, 19th 2004     -
----------------------
bluecow: Added context menu command for creating eD2K links with hashsets to Shared Files window.

----------------------
- May, 14th 2004     -
----------------------
bluecow: Fixed data rate control for rates > 80kb [thx zz]

----------------------
- May, 13th 2004     -
----------------------
bluecow: Properly completing and sharing of files when no hashset is available.
bluecow: Files without hashsets are no longer shared until they are completed or a hashset was received.
bluecow: Added support for HTTP redirection for websources.
bluecow: Added icons for websources in transfer window.
bluecow: Added a setting to preferences.ini (Section "Statistics", Keyword "SaveInterval") to specify the time interval in seconds for saving statistics. Default value is 60 sec.
Ornis:   title tags for images in Webinterface template "chicane"          [mARKUS]

----------------------
- May, 12th 2004     -
----------------------
bluecow: Added pasting of extended eD2K links for http:// sources and hashsets.
bluecow: Added downloading from http:// sources.

----------------------
- May, 11th 2004     -
----------------------
Unk: Rewrote most of the core of SMIRC to make it more stable and faster..
Unk: I now read the entire receive buffer in SMIRC's socket on each receive. Messages were getting left in the buffer and backlog'd..
Unk: SMIRC connection status could get a little messed up and not tell the user it failed to connect. (fix)
Unk: Added a simple nick completer to SMIRC.
Unk: Updated zz's USS and throttler.. With some modifications.. (I'm commiting this because I know blue wants to merge, this is still a work in progress..)

----------------------
- May, 10th 2004     -
----------------------
bluecow: Fixed crash with downloading of several files with same filename and reloading the shared files list.
bluecow: Optimized periodically stats file writing.

----------------------
- May, 4th 2004      -
----------------------
bluecow: Added filehash evaluation for completed part files when hashset is missing.
bluecow: Fixed bug with duplicate scrollbars in search window.
bluecow: Kad search expression parsing: The Kad keyword is now part of the ed2k search expression to support "<keyword> <op> <ed2k-search>" expressions.

----------------------
- May, 3rd 2004      -
----------------------
bluecow: Fixed bug with receiving of new ed2k meta tags which used a too large tag type range for string types.
bluecow: Removed auto restoring of search parameters when a search results tab is selected and/or closed.
bluecow: Reworked saving of onlinesig.dat to provide better support for other applications which are reading that file concurrently.
bluecow: Changed all file shareing modes (at OS level only) to allow read only access by other applications.
bluecow: eD2K and Kad searches are shown as still active or stopped with an appropriate icon in the search results list.
bluecow: Inactive search results panes show new received search results with red colored text in tab control.

        
v0.42f
----------------------
- May, 1st 2004      -
----------------------
bluecow: Added file error handling for writing of onlinesig.dat file.
.: Fixed a bug which could cause a too fast queue rotation when not using the option "try to upload full chunks" for uploading

----------------------
- April 30th, 2004   -
----------------------
bluecow: Fixed bug in Kad tag name string compare which was dependent to locales with multi byte character pages. [thx Big Mamma]
bluecow: Fixed bug with general string compares which were dependent on locale. (Note: Depending on your locale, you may experience somewhat different sorting orders for strings.)
Ornis:   Fixed issue of jumping category tooltips
Ornis:   Added 2 more statistics to category tooltips

----------------------
- April 29th, 2004   -
----------------------
Unk: If a client doesn't respond to udp packets after a few times, we force only tcp connections.
Unk: Increased the maximum number of upload slots to accomidate high rate connections.

----------------------
- April 24th, 2004   -
----------------------
bluecow: Added context menu to closeable tab control in Search Results, Message and IRC Chat windows to have another way to closeing the tabs.
Unk: Changed several areas of the code to help with *.*.*.0 clients that is labeled a lowID in the ed2k network.
Unk: If you reconnect to a server, all your shares would not get published unless something in your share list changed..(fixed) (thanks lugdunummaster)
Unk: Fixed a bug that allowed you to do a more command in search to the wrong search window.

----------------------
- April 22th, 2004   -
----------------------
.: eMule is now able to drop privileges and run on a secure user account on Win 2k/XP, when started as administrator (can be enabled in preferences -> security)
.: Updated MobileMule protocol to 0.8a
Unk: Kad user estimate is no longer based on Overnet's user count as the numbers appear to be to high.. (Numbers may still look to high for some users, will try to improve this as we go..)
Unk: Although I couldn't reproduce the double text bug in the IRC, I changed a couple things that may be the cause. (Seems some still get the bug)

----------------------
- April 21th, 2004   -
----------------------
bluecow: Fixed another crash bug with renaming of completed files in transfere window.
bluecow: Several changes in client statistics: detailed aMule version stats, added lphant client detection, cDonkey moved to eMule Compatible and more...
bluecow: Added searching for eD2K file hashs on eD2K servers. To search for a file hash, either enter "ed2k::<hash>" or the complete ed2k link. [thx lugdunum]
bluecow: Numeric search parameters are checked for reasonable values to avoid invalid search expressions.

----------------------
- April 20th, 2004   -
----------------------
bluecow: Fixed bug in global server searches which could send endless name queries in some rare situations. [thx lugdunum]
bluecow: Completed shared files which are deleted from Shared Files window are also removed from Transfer window.
bluecow: Added download statistics for UDP file reask.

----------------------
- April 19th, 2004   -
----------------------
bluecow: Fixed bugs with "Last Reception Time" and DST fix.

----------------------
- April 15th, 2004   -
----------------------
bluecow: Fixed crash bug with renaming of completed files in transfere window.
bluecow: Fixed small bug with AutoTakeEd2kLinks.
Ornis:   added category selector to the ed2k-box

----------------------
- April 14th, 2004   -
----------------------
bluecow: Fixed a window resizing crash bug in Message window.
bluecow: Client chat and IRC chat messages are limited to 450 characters.

----------------------
- April 13th, 2004   -
----------------------
bluecow: Disabled extracting meta data from OGM/OGG files due to many bug reports about problems with according DirectShow filters.
Unk: IRC names accept uppercase again.
Unk: Kad Publishes now stop in real time to avoid some overhead.

----------------------
- April 11th, 2004   -
----------------------
bluecow: Added capability to publish files on ed2k servers with new meta data tags. [thx lugdunum]
bluecow: Fixed bug with error message boxes which could show up due to a remote search invocation.
Ornis:         some minor GUI addons & corrections

----------------------
- April 10th, 2004   -
----------------------
bluecow: Added capability to parse new ed2k meta data tags. [thx lugdunum]

----------------------
- April 9th, 2004    -
----------------------
bluecow: Added docking/floating search parameters window to search dialog.

----------------------
- April 7th, 2004    -
----------------------
bluecow: More safety in parsing of new OP_SERVER_DESC_RES server packets.
bluecow: Proper parsing of unused eD2K meta data tag types.
bluecow: Fixed memory leak with known files entries and invalid hashsets in general [thx bzubzu.]

----------------------
- April 6th, 2004    -
----------------------
bluecow: Fixed sorting bugs in Known Client listview control.
bluecow: Removed syntax coloring from search expression control (caused too much trouble for some languages).
Ornis:   fixed search for webinterface

----------------------
- April 3nd, 2004    -
----------------------
bluecow: Added Ctrl+C keyboard shortcuts in all list views for copying eD2K links to clipboard.
bluecow: Added Ctrl+V keyboard shortcut for pasting servers from clipboard to server list view.
Unk: For waiting files, an remaining time will be estimated, based on previous idle time and downloaded data. (Note: Files started with some mods or older clients may give strange relults)

----------------------
- April 2nd, 2004    -
----------------------
bluecow: Removed Jigle search methods.
bluecow: Added context sensitive help.

v0.42e
----------------------
- April 1st, 2004    -
----------------------
Ornis: reduced javascript dependence on webinterface templates

----------------------
- Mar 31th, 2004     -
----------------------
bluecow: Added Paste command for ed2k file/server links to Transfer and Server window context menus.
bluecow: Fixed memory leak in Kad packet parsing [thx bzubzu.]

----------------------
- Mar 30th, 2004     -
----------------------
bluecow: Fixed security exploit in IRC module and Web server (aka DecodeBase16 exploit) [thx DonDiego]

----------------------
- Mar 29th, 2004     -
----------------------
bluecow: Add seperate dialog for "Paste eD2K Links" function (prev. called as 'Direct Download'). Dialog can be invoked from Tools menu or eMule context menu.
bluecow: Added MLdonkey compatible client tag recognition.

----------------------
- Mar 28th, 2004     -
----------------------
bluecow: Fixed crash bug with selectively deleting of expanded search results.
Ornis:   on category creation, if the edit dialog is canceled, no category will be created

----------------------
- Mar 27th, 2004     -
----------------------
bluecow: Added support for new eserver 16.45 UDP description packet.

----------------------
- Mar 25th, 2004     -
----------------------
Ornis: fixed security risk in the webserver [thx4hint2 MKThunderStorm]
bluecow: Added syntax coloring for search name (expression) control.
Unk: /topic and /msg now works with the IRC.
Unk: Changed some of how complete sources is determined..
 - Complete files will now show better complete numbers.
 - Somehow dead files continued to show many complete sources? This should correct itself as people upgrade.

----------------------
- Mar 24th, 2004     -
----------------------
bluecow: Added some error/help messages for invalid Kad search expressions.

----------------------
- Mar 23th, 2004     -
----------------------
bluecow: Filename detail dialog, shows system file icons for remote client's filenames.

----------------------
- Mar 21th, 2004     -
----------------------
bluecow: Fixed some minor bugs in ed2k searches related to comparison operators.
bluecow: Added more comparison operators to Kad search expression evaluation.

----------------------
- Mar 20th, 2004     -
----------------------
bluecow: Added a set of additional search parameters (Complete sources, Length, Bitrate, Codec, Title, Album, Artist)
Ornis:   Preferences/Display: Option to clear or disable autocompletion boxes (search-name, servermet-urls, ipfilter-urls). Disabling takes full effect after restart.

----------------------
- Mar 19th, 2004     -
----------------------
bluecow: Webservices are split into file based and general URLs. General URLs are shown only in Tools/Links.

----------------------
- Mar 18th, 2004     -
----------------------
bluecow: Fixed crash bug with downloading of already downloaded files which were already in known file list.

----------------------
- Mar 16th, 2004     -
----------------------
bluecow: Fixed bug with recovering block requests of compressed packets after a zstream error occured.

----------------------
- Mar 15th, 2004     -
----------------------
bluecow: Added 'Active download time' stats for part files which shows the amount of time the file was active in download queue.
bluecow: Added: Completed files are republished to servers to update the 'complete sources' info.
bluecow: Fixed bug with reloading of shared files where just completed and externaly removed/renamed files still showed up.

----------------------
- Mar 14th, 2004     -
----------------------
bluecow: Fixed possible mem leak with OP_REQUESTPARTS message. [thx eklmn]
bluecow: Added support for integer media length eD2K tag for servers and clients. [thx lugdunummaster]
bluecow: Added publishing of basic file status (complete/incomplete) to servers.
bluecow: Added: Nr. of complete sources returned from servers are shown with availability data in search result list.
bluecow: Added: Viewing shared files of remote clients also transferes the nr. of complete sources.
unk: IRC now remembers your last nick.
unk: Added a couple more IRC info message options.

----------------------
- Mar 13th, 2004     -
----------------------
bluecow: Added customizable preview commands (new config file PreviewApps.dat)

----------------------
- Mar 7th, 2004      -
----------------------
bluecow: Verbose options are disabled and not shown by default. To enable the verbose options specify "VerboseOptions=1" in "eMule" section in preferences.ini.
bluecow: Fixed bug with processing of remote preview answer.
bluecow: Fixed bug in IRC property page; "Load channel list on connect" option was missing.
bluecow: Removed "ResizableLib" from source tree. Donwload the library at http://sourceforge.net/projects/resizablelib/

v0.42d
----------------------
- Mar 7th, 2004      -
----------------------
.: Fixed bug which let eMule crash when there is too much load on the UDP Socket

v0.42c
----------------------
- Mar 5th, 2004      -
----------------------
bluecow: Fixed rehashing on change of Daylight Saving Time (DST) [MightyKnife]. To disable this patch, add "AdjustNTFSDaylightFileTime=0" in "[eMule]" section in preferences.ini file.

----------------------
- Mar 3rd, 2004      -
----------------------
bluecow: Fixed bug with colors and known-type in searchlist control after files were canceled and/or added/removed from share.
bluecow: Fixed bug with sorting by category in download listview.
Unk: USS will temporarly be limited to a minimum of 10K until we correct a couple issues at lower speeds.

----------------------
- Mar 2nd, 2004      -
----------------------
bluecow: Fixed bug in UDP socket with ReaskFilePing which was not answered for files in most cases
bluecow: Fixed bug in IP filter; adjacent ranges with different levels were merged.
Unk: IRC now handles sound events. (/sound [*.wav] [message]) (Sounds are stored in "../eMule/Sounds/IRC" dir)
Unk: Fix KadID bug which created some clusters and reported bad user counts..

----------------------
- Mar 1st, 2004     -
----------------------
Unk: Packets for the UDP socket send queue now have a lifetime now to keep from creating a backlog of packets. 

----------------------
- Feb 29th, 2004     -
----------------------
Ornis: fixed a bug, that resumed 2 (instead of 1) files for the function "start next paused file, when a files completes"
Ornis: correction in the statistics for source-type passive - and several minor GUI fixes
bluecow: fixed invoking the comment page
Ornis: fixed Chicane webinterface template, to be able to start downloads from searchresults
Unk: Fixed a IRC crash bug thanks to reports from several irc ops..
Unk: Fixed the IRC Accept links from friends only option.
Unk: IRC default name gets a pseudo random nick on connect to avoid nick collisions.
Unk: Extra IRC filter options.

----------------------
- Feb 28th, 2004     -
----------------------
bluecow: Fixed flaw in exception handling which did not immediatly disconnect a client which sends invalid file data packets.
bluecow: Fixed bug in UDP socket with processing of a received file status.
bluecow: Fixed several flaws in Kad window with connect and bootstrap function/buttons.
Unk: Put back ping info for USS and small adjustment to USS - zz
Unk: Removed some debug info in the upload bars

v0.42b
----------------------
- Feb 28th, 2004     -
----------------------
Unk: Hotfix for keyword publishing..

v0.42a
----------------------
- Feb 27th, 2004     -
----------------------
Ornis: Several minor corrections on the GUI

----------------------
- Feb 22th, 2004     -
----------------------
bluecow: Several changes and optimizations to verbose log options.
Unk: Hopefully reduced keyword overhead some more by only publishing complete files.

----------------------
- Feb 21th, 2004     -
----------------------
bluecow: Added new connection state icon showing seperate eD2K and Kad network connection state and seperate LowID/HighID.

----------------------
- Feb 20th, 2004     -
----------------------
bluecow: Added new AVI file parsing code for getting attributes in File Info dialog.
bluecow: Added a thread for getting audio/video attributes of multiple files when using File Info dialog.

----------------------
- Feb 19th, 2004     -
----------------------
bluecow: Added optional support for MediaInfoLib (http://mediainfo.sourceforge.net) for viewing audio/video attributes of part and shared files. This feature is optional and will only be used if version 0.4.0.1 of MediaInfoLib (MediaInfo.DLL) is copied to eMule application folder.

----------------------
- Feb 18th, 2004     -
----------------------
bluecow: Added merging of audio/video attributes in File Info dialog. All audio/video attributes from all selected (part) files are merged to verify if selected files are of same audio/video format.
        
----------------------
- Feb 16th, 2004     -
----------------------
bluecow: Added new column to search results showing local file info.

----------------------
- Feb 15th, 2004     -
----------------------
bluecow: Search type or shared files list request is shown in each search results tab.
bluecow: Added automatic creation of 'downloads.txt' file in eMule application folder. This file holds the current part file names and related ed2k links to recover more easily after lost part.met files.

----------------------
- Feb 14th, 2004     -
----------------------
bluecow: Windows thumbs.db files with missing system file attribute are no longer shared.
bluecow: Thoroughly handling of max. nick name length.

----------------------
- Feb 12th, 2004     -
----------------------
bluecow: Tweaked tab controls in server window/chat window to show unread log/chat messages.

----------------------
- Feb 10th, 2004     -
----------------------
bluecow: Added caching of webservices menu entries.
bluecow: Fixed multi threading issue with file completion.
bluecow: Fixed some problems with duplicate entries in known file list and shared file list.

----------------------
- Feb 9th, 2004      -
----------------------
bluecow: Added a lot of protocol logging and debugging code.
bluecow: Several optimizations in processing search expressions for keyword index.
bluecow: Reworked UDP socket exception handling.
Unk: Split source and keyword indexing to allow specific tweaking later.

----------------------
- Feb 6th, 2004      -
----------------------
bluecow: Added more logging options in Extended Settings.
Unk: Kad now allows smaller local networks if you turn off LANIP filtering. (This should only be used for debuging and testing)
Unk: A lot of Kad has been converted to use CSafeMemFile.. To finish converting all, we need to convert the Kad's Tags and Kad's Taglist to work with it..
Unk: When duplicates are found in the KnownFileList, the stats are now merged..

----------------------
- Feb 4th, 2004      -
----------------------
bluecow: Reworked internal storage of preferences.
bluecow: Fixed bug with downloads added from search result in paused mode which dropped possible found sources.
unk: Redid the knownfilelist.. Before you could have multi entires.

----------------------
- Feb 3nd, 2004      -
----------------------
bluecow: Fixed bug with Kad keyword publishing list due to renaming a shared file which was completed in current session.

----------------------
- Feb 2nd, 2004      -
----------------------
bluecow: Fixed bug in Kad search with implicit ANDed search expressions.
. :        Merging of the extended trayicon menue [eMule+]

----------------------
- Feb 1st, 2004      -
----------------------
bluecow: Reworked IP filter
- Optimized IP filter lookup for less CPU load.
- Optimized loading of IP filter files.
- Added merge of overlapping and adjacent filter ranges.
- More safety in determining format of IP filter files (support for eMule IP filter and PeerGuardian file formats).
- More tolerance in eMule IP filter format files (level and description is now optional).
- Added IP filter dialog for basic editing and viewing IP filters (accessible via Tool menu).
- Added IP filter rule hit statistics.
Unk: Fixed a bug in the UDP port that resent UDP packets to dead clients.

----------------------
- Jan 29th, 2004     -
----------------------
Unk: Major rewrite of the Kad code..
 - Kad is now part of eMule's thread so we don't have to worry about Sync issues.
 - Although many will say that this is a performance loss, I feel the the simplification of the code out ways this.
 - Kad will now use eMule's UDP port (And eMule's TCP port in the future) instead of their own.

----------------------
- Jan 27th, 2004     -
----------------------
bluecow: New data (packet + files) processing code for less CPU load.

----------------------
- Jan 25th, 2004     -
----------------------
Unk: Fixed a few issues that occured when a partfile became a complete file.

----------------------
- Jan 22th, 2004     -
----------------------
bluecow: Fixed bug with wrong category directory shown for new created downloads.
bluecow: Fixed printf-flaw with category directories.
bluecow: Fixed problem with empty file data packets which could corrupt the gap list.
bluecow: Fixed timing issue in PerfLog module.
bluecow: Fixed statistics bug with ICH in download session category.

----------------------
- Jan 19th, 2004     -
----------------------
bluecow: Fixed: If the very first downloaded part of a file was recovered by ICH, the file was though not shared until another part was completed without ICH.
Unk: Incoming ExtendedFileInfo was done without checking the version number.
 - This fix seems to have found that a couple older eMule Mods and Shareaza (And maybe a some other mods) are sending the wrong version number here.
 - They say they support the ExtendedFileInfo which makes us send the our info, but they in return do not send it to us when we are expecting it..
Unk: A part of the ED2K protocol has been redone into a eMule protocol. This allows us to do several ED2K type packets with just one packet hopeing to save overhead.
Unk: The UDP file reask now updates the FileStatus and it transmits all the ExtendedFileInfo.
Unk: File reasks have been extended for less overhead.
Unk: Source exchange times have been adjusted for less overhead. (May have to set the received source request time check back to older values so older clients don't suffer. Needs testing.)

----------------------
- Jan 17th, 2004     -
----------------------
Unk: The switch for processing sources for a download had some fall through bugs.
Unk: There was a bug the allowed the client to send a UDP and TCP file reask at the same time.
Unk: NNP sources was allowed to do a UDP reask which does not update our chunk info.. So, this was a wasted packet..
Unk: It was possible (But unlikely) for the client to send a UDP reask to a client he has never done a TCP reask..
Unk: AskForDownload() now returns a result so we know if the source was deleted.
Unk: Only count sent Kad overhead that was actually sent, not queued or failed..
Unk: Clients even without a valid file request could still get on the queue.
Unk: There were three different methods creating a per file upload list. Some of them rebuilt this list each time needed. We now maintain an upload list per each client in real time to avoid this.
 - Update: there is a bug that allows the same file to be in the KnownFileList.. This messes up this real time management..
 - For the moment, there is a debug code in the client the saves from creating dangling pointers..
 - This code will be removed once we fix the issues..
Unk: Source exhange for a complete file is now like part files, you only send sources that has chunks the user needs.

----------------------
- Jan 15th, 2004     -
----------------------
Ornis: IPFilter - file can be now in peerguardian-format as well
Ornis: Preferences/Security: option to download the ipfilter-file from an URL
Ornis: Fix: Handling of deleting files, which are currently into diskspace allocation
bluecow: View Shared Files command of remote clients is disabled if client published that he does not support that feature.
bluecow: Fixed bug in viewing shared files from remote client - shared part files were not shown.
bluecow: Reduced memory usage of client instances #2.
bluecow: Fixed Kad UDP socket usage to avoid loss of packets to send.
bluecow: Optimized client listview controls for less CPU load.
bluecow: Fixed several flaws in context menus, shortcuts and usage of middle mouse button.
Unk: Try to filter self sources better.
Unk: We receive all incoming Kad sources now. (Was a bug that blocked them if the file got a lot of sources from a server or source exchange)
Unk: Again LowID Callbacks were messing up because of Kad and ED2K states. This is now checked more closly.
Unk: Nodal searches for publishing extended to allow full publish. Nodal searches for sources is lessened to reduce overhead with very rare files.

----------------------
- Jan 10th, 2004     -
----------------------
bluecow: Some changes for more proper Winsock initialisation and termination.
bluecow: Fixed and added some statistics for file data transfer.
Unk: Nodal lookups are now deleted with a delay when allowed. In other words, we try not to waste delayed incoming result packets.
Unk: There is a bug with the experation timer to Nodal lookups when you exhausted all pending contacts.
Unk: Keyword republishing is delayed longer to lower overhead.


0.41b.29 release
----------------------
- Jan 05th, 2004     -
----------------------
bluecow: Fixed several flaws in client and server overhead computation. (Note: You will see somehow increased overhead).
bluecow: Added Kademlia overhead statistics.
bluecow: Added client protocol handshake validation.
bluecow: To avoid spreading of false meta data, any (already) received meta data is dropped and locally created by examining file contents only.
bluecow: Fixed bug server connection duration statistics [Gnaddelwarz]
Unk: We delay publishing keywords to avoid spamming network with users that only stay connected for a very short time.

----------------------
- Jan 04th, 2004     -
----------------------
bluecow: Added thread safe synchronous command processing to Kad listener socket.
bluecow: Added explicit removing of file block requests for disconnected client to avoid file completion problems.
bluecow: Fixed sorting problems in shared files list control.
bluecow: Fixed very tricky bug in structured exception handling of client TCP socket.
bluecow: Already received but not processed packets are discarded after a client was disconnected.
bluecow: Fixed a potential client deletion crash bug related to IP filter.
bluecow: Added client protocol procedure state error log messages.

----------------------
- Dec 31th, 2003     -
----------------------
Unk:  Changed Log messaging from Kad to Emule to a thread safe method. win98 should be able to run a little better now.. But, there seem to still be issues.
Ornis:Sharefileslistcontrol offers rename,delete,open it's folder via contextmenu for files
      (deletes to recycle bin! use preferences.ini: RemoveFilesToBin=false, to have a eternal deletion)
Unk:  Until a fix is found, we only update the clients ID when adding a Kad Contact to the list. This seems to avoid the win98 freeze.
Unk: Small change in Kad search tolerance and bootstraping.

----------------------
- Dec 30th, 2003     -
----------------------
Ornis: Downloadfile-Details, Filenametab: improved listing and sorting of the available filenames
Ornis: Allocating new filesize for tempfiles not blocking anymore  (threading+buffering)
Ornis: Downloadlist: Sorting of the remain column for files now in 4-way-mode, to sort by remaining size OR by remaining time
Unk: Auto Kad bootstrap if you are trying to connect and see a Kad client.
Unk: The client now detects conflicts between UDP ports to prevent the client from freezing..
Unk: Bootstrap selectable by IP:Port or by a known Kad-client (searches your known client list for a Kad client to boot from)
bluecow: Reworked part file details dialog; added showing of several accumulated values for multiple selected part files.
bluecow: Removed Permissions column from Shared Files window (don't worry, it was never used).
bluecow: Reworked all Server-, Search-. Download- and Shared Files window context menus for supporting multiple selections.
bluecow: Fixed bug with first runtime wizard and enabled startup minimized option.
bluecow: Added option to restore the last used main window dialog at startup; (specify "RestoreLastMainWndDlg=1" in preferences.ini)
bluecow: Added Ornis' 4-way sorting for shared column in shared files window.

----------------------
- Dec 28th, 2003     -
----------------------
Unk: Added a lot of exception catching to Kad and SMIRC.
Unk: Gave incoming and outgoing Kad UDP packets same priority to keep outgoing packets from backlogging.
Unk: We now keep track on how many packets are sent with Kad Node lookups.
Unk: Search Jumpstarts are now only used when the search appears to have stalled.
Unk: IRC: /hop added.
Unk: Joined channels get focus now.
Unk: Fixed several memleaks with the Kad client
Unk: Added some flags to the Node lookups for future special purposes. (Can't be used until most client upgrade)
Unk: Small change to contact tree. More nodes known so that you find your target faster.

----------------------
- Dec 22th, 2003     -
----------------------
bluecow: Fixed problem with servers with IP 255.255.255.255 which could be added to the server list.
bluecow: Resolved IPs of DynDNS servers are now verified and optionally filtered (IP-filter).
bluecow: Reduced memory usage of client instances.
Ornis:   Option for automatic removal of completed downloads from list
Ornis:   Create lang-folder if neccessary on language download

----------------------
- Dec 21st, 2003     -
----------------------
Unk: Fixed a bug with rechecking firewall.
Unk: You can bootstrap into kad even if your not connected.

----------------------
- Dec 18th, 2003     -
----------------------
bluecow: Improved reading of UL/DL priorities read from known.met and part.met files to avoid usage of unknown values.
bluecow: Fixed mem leak and possible stall in server UDP socket related to failed DNS queries.
Unk: Adjusted disconnect timeout for Kad.
Unk: IRC: Small tweak to add friend.
Ornis: Fix of auto resume next file of same category

----------------------
- Dec 17th, 2003     -
----------------------
bluecow: Optimized processing of keyword publish list.
bluecow: Removed multiple part file source lists for more performance.
Unk: Search requests now send up to 300 results
Unk: Keywords now publish in Clusters of 150 files making use of the keyword publish list.

----------------------
- Dec 13th, 2003     -
----------------------
bluecow: Added more memory and C++ object check code for debug builds.
bluecow: Fixed wrong usage of some internal lists [rayita]
bluecow: Improved updating of GUI for donwload queue [rayita]
bluecow: Removed automatically resuming of files with state Insufficient diskspace.
bluecow: Addeded manually resuming of files with state Insufficient diskspace.

----------------------
- Dec 10th, 2003     -
----------------------
bluecow: Improved sending of OP_CANCELTRANSFER.

----------------------
- Dec 8th, 2003      -
----------------------
bluecow: Reworked includes of entire source branch.
bluecow: Added showing of server attributes to MyInfo panel.
bluecow: Fixed very rare occuring bug with decompressing of high compressable blocks.
bluecow: Improved error handling for decompressing corrupted blocks.
bluecow: Upgraded to zlib 1.2.1

----------------------
- Nov 27th, 2003     -
----------------------
bluecow: Added Drag&Drop support for Windows Shell URLs and more IE URL formats. This means you can drag&drop eD2K-URLs which are stored as Windows Shell URLs (like the entries in IE Favorites folder) into the eMule window. Works for eD2K-file-, server- and serverlist-links.
bluecow: Couple of code optimizations for processing the sources lists.

----------------------
- Nov 25th, 2003     -
----------------------
bluecow: Added Drag&Drop support for ANSI Text and HTML Text clipboard data formats. This means you can drag&drop eD2K-URLs from Internet Explorer Windows into eMule window. HTML fragments means: everything which is currently selected within the HTML page and which is allowed to contain more than just one eD2K-URL. Works for eD2K-file-, server- and serverlist-links.

----------------------
- Nov 24th, 2003     -
----------------------
bluecow: Fixed crash bug when file date of local files was out of range.
bluecow: Fixed performance issue with log files which got too large.
bluecow: Log files which are larger than 1MB are renamed to a filename with the start of the log and the current log file is restarted. Max. log file size can be specified in preferences.ini section "eMule" keyword "MaxLogFileSize=<bytes>".

----------------------
- Nov 23th, 2003     -
----------------------
bluecow: Fixed context menu support in IRC and Message window.
bluecow: All listview context menus are positioned correctly when invoked with keyboard interface.
bluecow: Statistics graphs are not deleted if according property page was opened and closed without changing values.

----------------------
- Nov 22th, 2003     -
----------------------
bluecow: Added support for selectable text, copy to clipboard, save log to disk and rotating log for IRC Chat windows.
bluecow: Fixed handling of windows shutdown message (WM_QUERYENDSESSION).
bluecow: Added support for external performance logging with NT Performance Monitor compatible log files.
bluecow: Changed socket creation code for non-proxy connections to reduce system resource usage.

----------------------
- Nov 21th, 2003     -
----------------------
bluecow: Fixed performance problem with rotating log which could create very high CPU usage in some cases.
bluecow: Fixed mem leaks in UDP sockets [rayita]
bluecow: Added support for selectable text, copy to clipboard, save log to disk and rotating log for Message windows.

----------------------
- Nov 20th, 2003     -
----------------------
bluecow: Fixed window resizing problem related to customizable toolbar and system color/theme change.
bluecow: Main windows are maximized correctly (depending on toolbar style/height) at startup.
bluecow: Fixed string format buffer overflow with status command line argument [KuSh].
bluecow: Fixed several problems with skinnable icons which were not updated on the fly.
bluecow: Added background colors (skinnable) for IRC channel window and nick window.
bluecow: Removed closeable tab control for IRC windows.
bluecow: Added close command to context menus of IRC/Message windows.
bluecow: Added tripple click feature to search term edit control.

----------------------
- 7. November 2003   -
----------------------


----------------------
- Nov 5th, 2003      -
----------------------
bluecow: Fixed rare occuring problem with staled server source request related to invalid part.met file contents.
bluecow: More safety in part.met file reading.
bluecow: Fixed problem with too frequently occuring server connection attempts with very short server lists.

----------------------
- Nov 2nd, 2003      -
----------------------
bluecow: Fixed minor issue with queued local server source requests after new server connect.
bluecow: Fixed sorting of buffered part file blocks to achive less HD stress.
bluecow: Fixed memory leaks and flushing of buffered data to HD of paused files when file was canceled.
bluecow: Files which could not be completed because of not enough free disk space can be resumed manually to try another file completion process.
bluecow: Fixed bug in check min. free disk space which could cause endless low disk space notifications.
bluecow: Improved check min. free disk space for better handling NTFS compressed/sparse files.
bluecow: Fixed a bug where an NTFS compressed file could not be created because there was not enough free disk space to hold the uncompressed file.

Unk: Several bugs noted in the forum. Tried to check most of them.
* Sources to a Paused or Stopped file will be removed once an hour to remove old sources..
* We no longer send sources to Paused or Stopped files.
* A better check of valid sources to Part files for source exchange.
* Source exchanges for complete files now sends sources with obtained parts first.
Unk: Removed some redundent For Loops to save CPU in the DownloadQueue..

----------------------
- Oct 30th, 2003     -
----------------------
bluecow: Added grouping of local server source reasks packets into one TCP frame
bluecow: Fixed bug with check diskspace
bluecow: Fixed problem with lost read-only settings in preferences.ini after version change
bluecow: Fixed server TCP overhead statistics
bluecow: Fixed HTTP download dialog string resources

----------------------
- Oct 29th, 2003     -
----------------------
Unk: Fixed a non thread safe area that moved Kad Contacts in the list.
Unk: Fixed a area that would stop Kad sources from being added.
Unk: Added zz upload throttler.

----------------------
- Oct 23th, 2003     -
----------------------
bluecow: Fixed multi threading problem with a completing file which was concurrently uploaded.

----------------------
- Oct 22th, 2003     -
----------------------
bluecow: Fixed bug in webserver which can cause memory corruption [MoNKi]

----------------------
- Oct 21th, 2003     -
----------------------
bluecow: Changed creation of Kademlia threads for proper RTL initialization.
bluecow: Fixed some glitches in shared directories control; added keyboard interface; added volume labels

----------------------
- Oct 19th, 2003     -
----------------------
bluecow: Fixed bug with friends where a client without an IP or hash could be added as a friend.
bluecow: Fixed bug with ed2k URL registry key where path contains special characters.
bluecow: Fixed system and tray context menu items for connecting/disconnect to/from both networks.
bluecow: Added new MyInfo control; shortcuts for Ctrl+C=copy selected text; Ctrl+A=select all text

----------------------
- Oct 16th, 2003     -
----------------------
bluecow: Fixed GDI resource leaks in video preview dialog.
bluecow: Added more functions for icon customizing (see documentation in Template.eMuleSkin.ini file)

----------------------
- Oct 15th, 2003     -
----------------------
bluecow: Added more icons for Kademlia windows [this and other eye candy icons were made all by Daan]
bluecow: Fixed bug in friend list/control.
bluecow: Added sorting to friend list control.
bluecow: Fixed more context menus (search listview, queue list, client list,...)

----------------------
- Oct 14th, 2003     -
----------------------
bluecow: Fixed shutdown freezing bug
bluecow: Fixed bug with View Shared Files command
bluecow: Fixed glitches in Kademlia listviews
bluecow: Added icons for Kademlia listviews
bluecow: Fixed toolbar strings for customizing dialog
bluecow: Fixed context menu for friend listview
bluecow: Added keyboard shortcuts for friend listview (Del=Remove friend, Ins=Add Friend)
bluecow: Fixed context menu for shared files listview
bluecow: Added icon/color customization for all main listviews/treeviews
bluecow: Reduced GDI resource usage for all image lists
Unk: Fixed a bug introduced when changing how we published.
Unk: Adjusted the Server and Kademlia a little.

----------------------
- Oct 13th, 2003     -
----------------------
Unk: Publishing of sources is now seperate from publishing keywords. This allows better control.
Unk: We now rotate the sources to a key better making sure the freshest sources are always first.
Unk: We also only index up to 50 sources per file since we only send a max of 50 sources to save memory.

----------------------
- Oct 12th, 2003     -
----------------------
Ornis: Webinterface: better connection separation of both networks
Ornis: Webinterface: displaying statistics fixed

----------------------
- Oct 8th, 2003      -
----------------------
Unk: Removed previous change to Contact tree, the contact tree is now a fixed size as the network grows..
Unk: The change to the contact tree also changes when we do nodelookups and contact pings.
Unk: Added a special "me" lookup to fill the tree quickly when you've been connected for a small period of time
Unk: Added bootstrap options to the lists if your stuck at conneting on Kademlia.
1) Only works with clients that are "connected" to Kademlia.
2) v40e and up only send a KadUDP port if they are connected so we know that client is connected.
Unk: Many of the intial kademlia lookups are now delayed to avoid quick connections from spamming.
Unk: Node Lookups are now ended once we receive a answer and no longer asks evenone in the list.
Unk: Changed the prefix on emule toolbars to ".eMuleToolbar.kad1.*" so that you can seperate from the classic toolbars.
Unk: Also, the default directory for the ".eMuleToolbar.kad1.*" files are now the incoming dir. So, just download them and they are already installed.
Unk: Change the timing of when you start checking contacts to help speed up the inital connection process.

----------------------
- Oct 7th, 2003      -
----------------------
bluecow: Fixed bug with upload list control which was not refreshed automatically [Xman1+KuSh]
bluecow: Fixed mouse/keyboard acces bug in HyperText control [MoNKi]
bluecow: Added keyboard shortcuts to main toolbar.
bluecow: Support for loading of toolbar bitmap images and taskbar notifier images with GDIPLUS.DLL if installed. Toolbar images can be transparent.

----------------------
- Oct 6th, 2003      -
----------------------
Unk: Contact list was still growing to much. Removed one more passive contact method.
Unk: The Contact tree is now skewed even more to stop the Contact list from growning in log size.

----------------------
- Oct 5th, 2003      -
----------------------
bluecow: Fixed bug with server warning messages which were shown as errors.
bluecow: Fixed bug with random drawn block requests in file progress bars.

----------------------
- October 4th, 2003  -
----------------------
Ornis: enhanced webinterface for some kademlia control/information
Ornis: some more localisations
Unk: New contacts are set to type 1 initially to keep dead contacts from spreading.
Unk: The client now ignores indexes are are very far from it's clientID.
1) Saves wasted memory and a little overhead.
Unk: The client now skips publishing to contacts are are very far from the target.
1) Saves from wasting other clients memory and overhead.
Unk: Fixed a major bug in the Kademlia search algorithm.
1) It now does the correct hops to find a target better.
2) Stops from doing requests from the wrong target.
bluecow: Changed several resource string loading code to support string based resource identifiers [SlugFiller+itsonlyme]
bluecow: Added: download links can contain hostname sources, instead of just ip; You can set your own hostname in preferences, and create eD2K links with sources with your chosen hostname instead of your IP [SlugFiller+itsonlyme]
bluecow: Added speed improvements made to the bar shader, making it display much faster than before [SlugFiller]
bluecow: Added code improvements for faster sorting complete sources [SlugFiller]
bluecow: Added sorting of complete source column in shared files window [SlugFiller]
bluecow: Fixed visual bug in upload status bar [wistily]
bluecow: Added check free diskspace option which ensures that complete files can be stored [SlugFiller]
bluecow: Added check free diskspace option which ensures that a minimum of free diskspace remains available.
bluecow: Added uncompressing of NTFS compressed files for completed files.
Unk: Less Node lookups into the network.
Unk: Partfiles no longer republish into the Kademlia on every restart.
Unk: You now only publish each key to 10 targets.
1) Slightly speeds up publishing.
2) Since we are publishing faster, overhead may be a little higher.

----------------------
- October 2nd, 2003  -
----------------------
Unk: Protocol change.. Going to have to restart the network.. (Everyone Update!)
Unk: Kademlia searches should be far be far better.

----------------------
- October 1st, 2003  -
----------------------
Ornis: Added connect buttons to Kad and Servers.
Unk: Passive contact collection during publishing is causing the contact list to grow too large..
1) This will help the contact list to stay at a lower level..
2) Also should lower the overhead as you don't have to keep track of as many contacts..
Unk: A very unreliable user estimate.
Unk: Extended the window to publish files..
1) This allows more files to be published..
2) Reduces overhead for those not sharing a lot of files..
3) But will increase the amount of files everyone has to index.
i ) This increase in indexes will actually be testing things for when publishing speed is increased..
4) Will cause a more old sources to be indexed..
Unk: All contacts after level 4 are now checked at least once an hour.
bluecow: added the long awaited More button to search window for getting more search results from the local server.
bluecow: rewrote tooltips for transfer window to fix several small glitches.
bluecow: buffered partfile data is explicitly written to disk before a preview command is invoked.
bluecow: partfile disk usage is determined with respect to NTFS compression and/or NTFS sparse files.

----------------------
- Sep 25th, 2003     -
----------------------
bluecow: Added server TCP connection keep alive function.
bluecow: Tooltips in search results listview are shown only if Shift+Ctrl is pressed while moving the mouse over a listview item.

----------------------
- Sep 21th, 2003     -
----------------------
bluecow: Changed all integer (8,16,32,128 bit) data to little endian format at lowest (network) level.
Unk: Initial merging of eMule and eDonkey's hello packets with help from bluecow.
Unk: Created new format of eMule's version number to show more info.
Unk: Cleaned up some of the Indexing code.
Unk: Index list is now cleaned better.
 Passive Cleaning) If someone does a search request and the client finds old keys to that request, they are deleted.
 Acitve Cleaning) Once every 30 mins, the index is scrubbed of old keys.
 
----------------------
- Sep 20th, 2003     -
----------------------
bluecow: changed all meta tags with string names into integer IDs
bluecow: changed "Length" meta tag for eMule/Kad internal to type "Integer"
bluecow: eMule/Kad tags are converted on-the-fly into ED2K tags when sent to a server or client
bluecow: received ED2K tags are converted into eMule/Kad tags; includes also ED2K tags read from known.met
bluecow: Redid Kad meta tag class to support:
 - data type for nr. of meta tags (in list) changed from uint32 to uint8
 - "dynamic" integer tags - this tag type selects the appropriate integer (8,16,32 bit) depending on the actually value
 - data conversion functions and property functions for each tag type to support on-the-fly and easy to use data conversion without caring about the actual data type
Unk: Search & source results are now bundled.
 - If your going to recieve more then 1 result from a client, this will save 16Bytes(data)+UDP(packet overhead) for all extra results.
 - Also, compression seems be able to compress these packets close to 50%..
Unk: Files with no valid keywords were able to stall publishing of all other files.. This was fixed.
Unk: Kademlia search results are now process availability a little different to try to get a better idea of availability.

----------------------
- Sep 18th, 2003     -
----------------------
bluecow: Fixed bug with invalid client objects in upload list after a file was unshared/reshared [zegzav]
bluecow: Shared files listview and Search Results list view; Alt+DoubleClick opens Details dialog.
bluecow: Fixed several format string errors [mandrag0re]

----------------------
- Sep 16th, 2003     -
----------------------
Unk: Any large Kad packet is now compressed.

----------------------
- Sep 15th, 2003     -
----------------------
bluecow: Added support for showing all available MP3 tag information for downloads and shared files.
Unk: Rework of the Kademlia protocol.
 1) Search requests no longer sends MaxResults.
 2) Search result packets now support sending more then one result per packet.
  a) We still use one packet per result. This is for future expansion.
  b) Once compression is added to the protocol, search results should start combining into one packets.
 3) Publish request packets new support sending more then one request per packet.
  a) We also still send one packet per result. This is for future expansion.
  b) Once compression is added to the protocol, these requests should also start combinging into one packets.
 4) Contact types went from 0-4 to 0-2.
  a) This keeps a cleaner contact list
  b) This also may increase overhead. Therefore, adjustment after first beta may change..
 5) The contact list is set to stop Node requests when a branch in the tree reaches level 4.
  a) This means that when the network is in full force, contacts will be limited. (Not sure how much yet.)
  b) At the moment I allow the right most branch to continue to build.
   i) This allows a client to know more clients close to it's own hash. 
   ii) Hopefully this allows searches to find home quicker..
   iii) This may cause to much overhead and may need adjustment.
 6) Kademlia Requests now sends the recievers ID.
  a) This adds a little bit of security.
  b) If you change your KadID, this will hopefully help remove your old ID from the system.
 7) Redid how you set contact as alive.
  a) You only set contacts the respond to a request as alive.
  b) This keeps from scanning the contact list on EVERY packet.
   1) Since we don't know the contacts ID we can't use the tree, but sequentually scan it.
   2) We can't just add the contactID to the packet as we can't trust them.
  c) This will most likely miss some opportunities to mark a contact as alive.
   1) In some instances this wouldn't matter since it will be used in a Kad Request.
   2) In other casses, it will matter as you would need to ping that client to see if it's still there.

----------------------
- Sep 14th, 2003     -
----------------------
bluecow: Added support for extended UDP server protocol for lugdunum 16.40 servers to receive multiple file search results in one UDP packet.
bluecow: Server UDP socket handles blocking socket state which could happen for larger UDP packets.
bluecow: More helpful error/logging messages for server UDP socket related functions.
bluecow: Optimizations in server UDP socket code for less CPU load (avoiding memory copy operations).
bluecow: Fixed bug in client UDP socket which did not handled the blocking state correctly.
bluecow: Search parameters are saved for each search result list; when selecting a search result list, the used search parameters are restored in the according controls
bluecow: When deleting a search result list the search result list following the deleted one is selected instead of the first one
bluecow: Last used search method is saved and restored in next eMule session.
bluecow: Servers can be added by pasting an eD2K server link into the IP address control of the server window.
bluecow: Shared files and downloading files are not counted in search results for the search result limit.

-----------------------
- September 13th, 2003-
-----------------------
Unk: Fixed a bug that tried to access a Contact after deleting it.
Unk: Fixed a overflow bug.
Unk: Seperated the KadID from clientID. The eMule tags in the Hash interfered with the routing.
Unk: Fixed a bug that didn't set experation of a contact correctly.
Unk: Changed the MaxUp and Maxdown into sliders.

----------------------
- Sep 11th, 2003     -
----------------------
bluecow: Added server TCP/UDP protocol logging+debug code.
bluecow: Added support for new welcome server message from lugdunum 16.40 servers.
bluecow: Added support for compressed server protocol for lugdunum 16.40 servers; welcome message and file search results are received as compressed data; shared files are sent to server as compressed data
bluecow: Added support for extended UDP server protocol for lugdunum 16.40 servers; global source finding is done more effeciently and with less bandwidth.
bluecow: Fixed crash bug in host name resolution.
bluecow: A global file search is started if the local server does not answer with file results within max. 50 seconds.
bluecow: Fixed bug with eD2K link control in search window which did not accept more than 3 or 4 links.

-----------------------
- September 10th, 2003-
-----------------------
bluecow: Added support for compressed server protocol for lugdunum 16.40 servers.
bluecow: Added support for extended UDP server protocol for lugdunum 16.40 servers.

----------------------
- September 4th, 2003-
----------------------
bluecow: Redid ON window listviews; sorting, restoring of col widths, sort order; tooltips for meta data
bluecow: Meta data dialog shows classic and new tags.
Unk: Slots now try as much as possible to stay at 3K or above.
Unk: Contacts further away from you are now limited to remove overhead.

----------------------
- September 3rd, 2003-
----------------------
Unk: Indexing is now updatable..
Unk: Indexed files now have a life time.
Unk: Indexed files are now reloaded on restarts.
Unk: Fixed a bug that only published the file ID once..
Unk: Recheck firewalled periodically.. This "should" also correct your IP on those 24hr disconnect users.
Unk: Publishes no longer assumes a successful publish. It now only count successful responses.
Unk: Kademlia searches now terminate if they have no more contacts pending.

----------------------
- September 1st, 2003-
----------------------
bluecow: Meta Data and File Comments dialogs changed into property pages which are shown together with File details property sheet. All property sheet/page related dialogs are resizeable and restore LRU size+position. Widths of columns in File Comments. File Names and Meta Data listviews saved+restored. Same applies for Meta Data dialogs for search results and shared files.
bluecow: New "Match keywords" search option for both Jigle search methods.

----------------------
- Aug 30th, 2003     -
----------------------
Unk: Rewrote the entire kademlia protocol.. We are no longer using Overnet..
Unk: Adding availability to publishing.
bluecow: Change in usage of search file type parameter "Program": When searching for a file of type "Program", the results are no longer locally filtered according Windows Program Files extension (*.exe, *.com, *.bat). The eD2K file type "Program" is meant to contain all file types which are "used" by a program like compressed archives and CD-ROM images. This means that you will get more search results than in previous versions. If you still want to search for a Windows Program File, specify "exe" for the file extension.
bluecow: Added proxy support for IRC; all proxy settings are also used for IRC
Ornis:   bugfix in webserver socket code, [Jan B.,nice bugreport]

----------------------
- Aug 29th, 2003     -
----------------------
Ornis: Filedetailsdialog restructured, + showing date of downloadstart and duration since (until now or until download completion)
Ornis: added some missing percentages in  the statistic tree
Ornis: added option to scheduler, to disable the endtime and therefor make changes of an event permanent

----------------------
- August 26th, 2003  -
----------------------
bluecow: More tweaks in the gSOAP module for better performance with Jigle server and reliable compiling by modders (always ensure that WITH_GZIP is defined!); a Jigle search request always has to include either a file type and/or a file extension, otherwise the request will not be sent for reducing server load; HTTP User-Agent field changed to reflect eMule version.
bluecow: Fixed several issues with the new CComboBoxEx control (keyboard interface).
bluecow: Several visual changes in the new search list view for proper windows color scheme handling and sorting of child items

----------------------
- August 24th, 2003  -
----------------------
bluecow: Added support for Jigle SOAP interface to search the Jigle database with eMule [special thanks to Melange from Jigle for offering this great feature to eMule]
bluecow: Jigle SOAP interface: search results are limited to 100 results; optimized code for less server load; local filtering of search results
bluecow: Added extended combobox control for search methods [eMulePlus]

----------------------
- August 20th, 2003  -
----------------------
Unk: Changed how it detects firewalled users.
Unk: Indexed keywords now handles all tags.
Unk: Available is better updated during a search.
Ornis: added stats of where sources came from (ed2k-server, ON, source exchange)
Ornis: custimizable toolbar [eMule+]
Ornis: Downloadlist: F2 opens inputbox to change filename of the selected file
Ornis: Searchlist can expand items to show the received different filenames and their count

----------------------
- August 11th, 2003  -
----------------------
Unk: One more change to smoothing out the packets.. Hopefully this is the last.
Unk: Contacts are now checked in a more systematic way to help lower bandwidth.
Unk: Only low buckets are updated to lower bandwidth.
Unk: Hopefully fixed another shutdown crash.

----------------------
- August 7th, 2003   -
----------------------
Unk: More outgoing flood control to try to avoid lagging. (No more spikes)
Unk: Major change to how we sent shared files to servers for better efficiency.
Unk: Overnet status are now only updated once a sec to reduce CPU overhead.
Unk: Kademlia searches are now regulated by total and type to keep from two many searches at once.

----------------------
- July 29th, 2003   -
----------------------
Unk: IRC: Now sorts nicks correctly.
Unk: IRC: Can now add other eMule nicks as friends.
Unk: IRC: Can now send each other ed2k links within the IRC.
Unk: IRC: Added security to Add nick and Sending links. You can choose to accept all links, links for friends only, and no links at all.

----------------------
- July 26th, 2003   -
----------------------
Unk: Contacts are now filtered from invalid IP and Ports.
Unk: Again adjusted how dead contacts are removed.
Unk: Older contacts are no longer added on restart.
Unk: Trying to reduce UDP spikes that can flood connections.
Unk: Moved Overnet Log and Debug line info into eMules Log and Debuglogs..

----------------------
- July 24th, 2003   -
----------------------
Unk: Fixed a bug that allowed searches to access already deleted contacts.
Unk: Serverlist is now updated when connected to Kademlia only.
Unk: Seemed Kademila thread still tried to access some of it's main objects during shutdown. (Hopefully fixed)
Unk: Fixed some connected status issues.

----------------------
- July 16th, 2003   -
----------------------
Unk: Testing out Maella request patch.
Unk: Dead contacts are removed more efficiently.

----------------------
- July 5th, 2003   -
----------------------
Unk: Contact type is now being updated. May later use this and "madeContact" to update the contact list a little better.
Unk: Contact list no longer shows temp contacts during searches. Also, redid how contacts are updated to limit the number of refreshes needed. (Cpu Savers)
Unk: Converted the ED2K ID system to the Hyrbids ID system to avoid false lowIDs that the ED2K ID system created and to be more compatable with the Hyrbid.
---- Also standardized the LowID checks to 2 central methods (ED2K and Hybrid). We were using several different methods to check lowID.
---- This changed a lot of code and needs tested well.

----------------------
- July 1st, 2003   -
----------------------
Unk: You can now see if your files are published to a ED2K Server and/or Overnet.
Unk: You no longer republish files to a ED2K server that is already on there. This should save a lot of bandwidth and allow more files to be listed..

----------------------
- June 30th, 2003   -
----------------------
Unk: Single keyword search requests are now processed.
Unk: Fixed a bug that could get the publishing stuck trying to publish a file over and over.

----------------------
- June 28th, 2003   -
----------------------
bluecow: Added the code to process the incoming Keyword Search Requests.
Unk: Added a simple response packet to keywords.
bluecow: Fixed a crash on exit bug.

----------------------
- June 27th, 2003   -
----------------------
Unk: Entries in the Index list can now be removed. Which also fixes a bug with a lot of dangling pointers when restarting the overnet connection.. :)
Unk: Fixed a bug that caused all kinds of issues if you disconnected and reconnected real fast with overnet.

----------------------
- June 26th, 2003   -
----------------------
Unk: Overnets overhead is now processed and added to the server catagory.
Unk: Tweaked the overhead a little to try to get better estimates.
bluecow: Fixed a deadlock at shutdown.
bluecow: Fixed a bug when restarting ON during a single eMule session.
Unk: Fixed a bug that allow the connect button to get confused.
Unk: Fixed a bug that crash when trying to bootstrap

----------------------
- June 25th, 2003   -
----------------------
Unk: There are now preferences that allow the user to choose which network to connect too.
Unk: Added Network Choice to First Time Wizard.
Unk: Changed how connection status is relayed between Overnet and eMule.
Unk: Fixed some issues with the search dialog. SearchID is no longer and issue between eMule and Overnet and you can now select which network so search. 

----------------------
- June 24th, 2003   -
----------------------
Unk: IP request now responds if the other client is firewalled.
Unk: Found that damn bug that wasn't deleting clients when the socket timed out..
Unk: Cleaned up some code.

----------------------
- June 22nd, 2003   -
----------------------
Unk: Corrected a bug that didn't let you just connect to Overnet.
Unk: Fixed duplicate keyword indexed files.
Unk: Rolled back to VS2002.. Seems to have corrected the socket bug.
Unk: Removed a gui slowdown when a search quit and all the temp contacts were removed.
Unk: Completely rewrote the messaging code between eMule and Overnet to clean it up.
Unk: Added refresh messages to the Overnet lists. There should be no more ghosts or blanks in the lists.
Unk: Your ID is now calculated differently. Also there is a better check if your firewalled if using both networks at once.
-If you are seen to not be firewalled by either Overnet or ED2K, eMule will assume your not firewalled.
-If either ED2K or Overnet has a high ID, eMule will use it.
-If the server things your firewalled and Overnet knows better, you can still download from lowID users.
-If the server things your firewalled and Overnet knows better, you will tell the other clients the correct ID.
-Because we do not support firewalled users in Overnet yet, if you want to use overnet, you must also connect to a server before eMule starts working.

----------------------
- June 6th, 2003   -
----------------------
Unk: Tried to go through and clear up some areas that check for LowID and Connected status.

----------------------
- June 5th, 2003   -
----------------------
Unk: Changed up the ON gui some.. Although it's not great, the lists are now seperate for easier manipulation later.
Unk: Fixed duplicates of fileID indexed files.

----------------------
- June 4th, 2003   -
----------------------
Unk: Now responding to fileID search requests and sending and search_end packets
Unk: Connect button support added.
Unk: The OVERNET_IDENTIFY_ACK now updates the TCP port of the Contacts and Indexes. (This was messing this up, needs redone)
Unk: Added a Firewall recheck button.
Unk: Change how it checks if firewalled. (Less wasted packets, better timing.)

----------------------
- June 3rd, 2003   -
----------------------
Unk: Changed how it displays connection status.
Unk: Searches are now terminated better when a file is Stoped, Paused, or Canceled.

----------------------
- June 1st, 2003   -
----------------------
Unk: The timer for checking dead servers was changed to now get messed up when resetting your computer.
Unk: Server Description requests delay has been increased to save server bandwidth.
Unk: Found a major bug that sent packets to the wrong IP.. We now index Overnet publish requests.

----------------------
- May 26nd, 2003   -
----------------------
Unk: Knownfile met is now saved periodically.
Unk: Published ON files are now remember between restarts to cut down over publishing.
Unk: We now detect if the our ON client is firewalled. Also, if the server side thinks we are firewalled but overnet isn't, we use the Overnet ID instead of the server ID.
Unk: Found out that many of the mldonkey clients don't publish correctly. Hours wasted trying to debug a packet that is incorrect.. 
Unk: Changed the order of publishing to make it more efficient.
Unk: No longer treat bcp://hashid:ip:port as a source. These are firewalled sources and the ip and port is the firewalled server, not source..
Unk: Corrected the searches to reflect correct search types.
Unk: Uploading clients could get stuck in the upload list without a socket. This is the same problem as noted above, therefore it's not the sole problem with FileNotFound.

----------------------
- May 26nd, 2003   -
----------------------
Unk: Adding the overnet to the client brought up unknown issues with the original client.
1. Rewrote how clients and sockets delete each other to avoid clientlist & socketlist corruptions.
2. Clients are able to get in a connected or connecting state without a socket, these clients are now removed. (This may be releated to FileNotFound packets. Will rework that later..)

----------------------
- May 22nd, 2003   -
----------------------
Unk: Merged the base Kademlia code into eMule with the help of bluecow.
Unk: Added a Overnet debug window.
Unk: Added many new Overnet opcodes.
Unk: Can now download from Overnet clients.
Unk: Note to self: Need to find out why incoming Publish Requests send UDP port, but when we send a publish request, we HAVE to send a TCP port??????? (Fixed: mldonkey is the one sending UDP port which is incorrect and very bad!)
Unk: Can now publish to the Overnet network. (Something still doesn't seem correct with Publish Requests)
Unk: Indexing Overnet files. (Something still doesn't seem correct with Publish Requests)
Unk: Beging to change the eMule base code to better handle the Overnet network as a seperate network. (So you can use both or just one)
Unk: Duplicate clients are now found a little better. More CPU power needed, but it had to be done to detect cross source findings.. 
Unk: CUpDownClient::CalculateDownloadRate() is causing strange exceptions.. WHY? (Update: fixed)

----------------------
- March 16th, 2003   -
----------------------
Unk: Changed opcodes to match eMule for easier merging later.

----------------------
- March 15th, 2003   -
----------------------
Unk: Original Programmer of Kad seems to have left the building. I'm am going through the code trying to see where he was going with it..

        
        
PRIOR 0.4x
===================

v0.30e
----------------------
- Dec 9th, 2003      -
----------------------
bluecow: Fixed very rare occuring bug with decompressing of high compressable blocks.
bluecow: Improved error handling for decompressing corrupted blocks.
bluecow: Upgraded to zlib 1.2.1.


0.30d
----------------------
- Nov 20th, 2003     -
----------------------
.: Missing language-dlls are now downloaded and installed automatically by emule
.: Changed auto-versioncheck to a DNS-based method which is more effictive. Also the auto-versioncheck is now enabled by default.
.: Updated MobileMule protocol to 6b

----------------------
- Nov 16th, 2003     -
----------------------
Ornis:  some changes for less CPU load
Ornis:  Searchlist: contextmenu also provides download in paused mode selection
Ornis:  copy a selected comment to the clipboard [NoamSon]

----------------------
- Nov 7th, 2003      -
----------------------
Ornis:  Save IRC/Messages-chats to disk (context menu)
Ornis:  preferences-webinterface: enable/disable usage of GZIP compression

----------------------
- Nov 5th, 2003      -
----------------------
bluecow: Fixed rare occuring problem with staled server source request related to invalid part.met file contents.
bluecow: More safety in part.met file reading.
bluecow: Fixed problem with too frequently occuring server connection attempts with very short server lists.

----------------------
- Nov 2nd, 2003      -
----------------------
bluecow: Fixed minor issue with queued local server source requests after new server connect.
bluecow: Fixed sorting of buffered part file blocks to achive less HD stress.
bluecow: Fixed memory leaks and flushing of buffered data to HD of paused files when file was canceled.
bluecow: Files which could not be completed because of not enough free disk space can be resumed manually to try another file completion process.
bluecow: Fixed bug in check min. free disk space which could cause endless low disk space notifications.
bluecow: Improved check min. free disk space for better handling NTFS compressed/sparse files.
bluecow: Fixed a bug where an NTFS compressed file could not be created because there was not enough free disk space to hold the uncompressed file.
Ornis:   updated importer to load eD/ON v0.48 partfiles

Unk: Several bugs noted in the forum. Tried to check most of them.
* Sources to a Paused or Stopped file will be removed once an hour to remove old sources..
* We no longer send sources to Paused or Stopped files.
* A better check of valid sources to Part files for source exchange.
* Source exchanges for complete files now sends sources with obtained parts first.
Unk: Removed some redundent For Loops to save CPU in the DownloadQueue..

----------------------
- Oct 30th, 2003     -
----------------------
bluecow: Added grouping of local server source reasks packets into one TCP frame
bluecow: Fixed bug with check diskspace
bluecow: Fixed problem with lost read-only settings in pref.ini after version change
bluecow: Fixed server TCP overhead statistics
bluecow: Fixed HTTP download dialog string resources


0.30c
----------------------
- Oct 23th, 2003     -
----------------------
bluecow: Fixed multi threading problem with a completing file which was concurrently uploaded.

----------------------
- Oct 22th, 2003     -
----------------------
Ornis: added ability to import partial downloads from Overnet/eDonkey when having used the "old style" format
bluecow: Fixed potential exploit due to memory corruption in webserver [MoNKi]

----------------------
- Oct 19th, 2003     -
----------------------
bluecow: Fixed bug with friends where a client without an IP or hash could be added as a friend.
bluecow: Fixed bug with ed2k URL registry key where path contains special characters.
bluecow: Fixed GDI resource leaks in video preview dialog.

----------------------
- Oct 12th, 2003     -
----------------------
Ornis: Import partial downloads from eDonkey/Overnet ("new style"-splitted partfile). Build-in converter to import downloadfiles from a selected folder to your eMule-downloads right away. (use the Hotmenu Alt+X to access it)
Ornis: Serverlist highlights the currently connected server

----------------------
- Oct 9th, 2003      -
----------------------
Ornis: dynamic category tabcontrol size
Ornis: prevent empty date/time output with faulty preferences.ini

----------------------
- Oct 7th, 2003      -
----------------------
bluecow: Fixed bug with upload list control which was not refreshed automatically [Xman1+KuSh]
bluecow: Fixed mouse/keyboard acces bug in HyperText control [MoNKi]
bluecow: Added keyboard shortcuts to main toolbar.

----------------------
- Oct 5th, 2003      -
----------------------
bluecow: Fixed bug with server warning messages which were shown as errors.
bluecow: Fixed bug with random drawn block requests in file progress bars.

----------------------
- Oct 4th, 2003      -
----------------------
Ornis:   set speedlimits to unlimited manually (again)
bluecow: Changed several resource string loading code to support string based resource identifiers [SlugFiller+itsonlyme]
bluecow: Added: download links can contain hostname sources, instead of just IP address; You can set your own hostname in preferences, and create eD2K links with sources with your chosen hostname instead of your IP [SlugFiller+itsonlyme]
bluecow: Added speed improvements made to the bar shader, making it display much faster than before [SlugFiller]
bluecow: Added code improvements for faster sorting complete sources [SlugFiller]
bluecow: Added sorting of complete source column in shared files window [SlugFiller]
bluecow: Fixed visual bug in upload status bar [wistily]
bluecow: Added check free diskspace option which ensures that complete files can be stored [SlugFiller]
bluecow: Added check free diskspace option which ensures that a minimum of free diskspace remains available.
bluecow: Added uncompressing of NTFS compressed files for completed files.

----------------------
- Oct 1st, 2003      -
----------------------
bluecow: added the long awaited More button to search window for getting more search results from the local server.
bluecow: rewrote tooltips for transfer window to fix several small glitches.
bluecow: buffered partfile data is explicitly written to disk before a preview command is invoked.
bluecow: partfile disk usage is determined with respect to NTFS compression and/or NTFS sparse files.
Ornis:   new translation: Czech, by Patejl


0.30b
----------------------
- Sep 25th, 2003     -
----------------------
bluecow: Added server TCP connection keep alive function.
bluecow: Tooltips in search results listview are shown only if Shift+Ctrl is pressed while moving the mouse over a listview item.

----------------------
- Sep 24th, 2003     -
----------------------
.: You are now able to preview shared video files from clients who let you see their share. You will  be able to view 5 screenshots of the first ~10 min.
.: Upgraded MobileMule Protocol to 5x. Note that you need to download the new clientversion too if you use MobileMule. 
.: Merged some code changes from eMule Plus
Ornis: larger category control when several categories are added (simple condition for now)
Ornis: show A4AF-count for files in the downloadlist when additional controls are enabled

----------------------
- Sep 21th, 2003     -
----------------------
Ornis: added disk usage statistics [emule+]

----------------------
- Sep 18th, 2003     -
----------------------
bluecow: Fixed bug with invalid client objects in upload list after a file was unshared/reshared [zegzav]
bluecow: Shared files listview and Search Results list view; Alt+DoubleClick opens Details dialog.
bluecow: Fixed several format string errors [mandrag0re]

----------------------
- Sep 15th, 2003     -
----------------------
bluecow: Added support for showing all available MP3 tag information for downloads and shared files.

----------------------
- Sep 14th, 2003     -
----------------------
bluecow: Added support for extended UDP server protocol for lugdunum 16.40 servers to receive multiple file search results in one UDP packet. [thx lugdunum for coop.]
bluecow: Server UDP socket handles blocking socket state which could happen for larger UDP packets.
bluecow: More helpful error/logging messages for server UDP socket related functions.
bluecow: Optimizations in server UDP socket code for less CPU load (avoiding memory copy operations).
bluecow: Fixed bug in client UDP socket which did not handled the blocking state correctly.
bluecow: Search parameters are saved for each search result list; when selecting a search result list, the used search parameters are restored in the according controls
bluecow: When deleting a search result list the search result list following the deleted one is selected instead of the first one
bluecow: Last used search method is saved and restored in next eMule session.
bluecow: Servers can be added by pasting an eD2K server link into the IP address control of the server window.
bluecow: Shared files and downloading files are not counted in search results for the search result limit.

----------------------
- Sep 11th, 2003     -
----------------------
bluecow: Added server TCP/UDP protocol logging+debug code.
bluecow: Added support for new welcome server message from lugdunum 16.40 servers.
bluecow: Added support for compressed server protocol for lugdunum 16.40 servers; welcome message and file search results are received as compressed data; shared files are sent to server as compressed data
bluecow: Added support for extended UDP server protocol for lugdunum 16.40 servers; global source finding is done more effeciently and with less bandwidth.
bluecow: Fixed crash bug in host name resolution.
bluecow: A global file search is started if the local server does not answer with file results within max. 50 seconds.
bluecow: Fixed bug with eD2K link control in search window which did not accept more than 3 or 4 links.

----------------------
- Sep 1st, 2003      -
----------------------
bluecow: Meta Data and File Comments dialogs changed into property pages which are shown together with File details property sheet. All property sheet/page related dialogs are resizeable and restore LRU size+position. Widths of columns in File Comments. File Names and Meta Data listviews saved+restored. Same applies for Meta Data dialogs for search results and shared files.
bluecow: New "Match keywords" search option for both Jigle search methods.

----------------------
- Aug 30th, 2003     -
----------------------
bluecow: Change in usage of search file type parameter "Program": When searching for a file of type "Program", the results are no longer locally filtered according Windows Program Files extension (*.exe, *.com, *.bat). The eD2K file type "Program" is meant to contain all file types which are "used" by a program like compressed archives and CD-ROM images. This means that you will get more search results than in previous versions. If you still want to search for a Windows Program File, specify "exe" for the file extension.
bluecow: Added proxy support for IRC; alle proxy settings are also used for IRC
Ornis:   bugfix in webserver socket code, [Jan B.,nice bugreport]

----------------------
- Aug 29th, 2003     -
----------------------
Ornis: Filedetailsdialog restructured, + showing date of downloadstart and duration since (until now or until download completion)
Ornis: added some missing percentages in  the statistic tree
Ornis: added option to scheduler, to disable the endtime and therefor make changes of an event permanent

----------------------
- Aug 26th, 2003     -
----------------------
bluecow: More tweaks in the gSOAP module for better performance with Jigle server and reliable compiling by modders (Modders: always ensure that WITH_GZIP is defined!); a Jigle search request always has to include either a file type and/or a file extension, otherwise the request will not be sent for reducing server load; HTTP User-Agent field changed to reflect eMule version.
bluecow: Fixed several issues with the new CComboBoxEx control (keyboard interface).
bluecow: Several visual changes in the new search list view for proper windows color scheme handling and sorting of child items

----------------------
- Aug 24th, 2003     -
----------------------
bluecow: Added support for Jigle SOAP interface to search the Jigle database with eMule [special thanks to Melange from Jigle for offering this great feature to eMule]
bluecow: Jigle SOAP interface: search results are limited to 100 results; optimized code for less server load; local filtering of search results
bluecow: Added extended combobox control for search methods [eMulePlus]

----------------------
- Aug 22th, 2003     -
----------------------
Unk: Irc: Nicks are now sorted correctly.
Unk: Irc: If another nick is an eMule you can add them as a friend. (Both clients must be v0.30b and up)
Unk: Irc: You can now directly send download links to other eMules. (Kinda like DCC, both clients must be v0.30b and up)
Unk: Publishing shares to the server is now done better to reduce traffic.
Unk: Added: Display of an estimated count of complete sources for files in the downloadlist and shared-files-list [modified Zegzav]

----------------------
- Aug 20th, 2003     -
----------------------
Ornis: fixed some statistics, like count of banned sources, A4AF-sources
Ornis: fixed search via webinterface
Ornis: fixed some not updated labels when changing language [itsonlyme]

----------------------
- Aug 19th, 2003     -
----------------------
bluecow: Language DLLs are no longer loaded if the version information stored in the DLL does not match the eMule application version information.
bluecow: Fixed colors of search results and log windows texts to be properly/visible in Contrast-Windows color schemes.


v0.30a
----------------------
- Aug 15th, 2003     -
----------------------
bluecow: Added dialog for showing the eD2K meta data for search results, download files and shared files. The according context menu item is only in "Advanced mode" available.

----------------------
- Aug 14th, 2003     -
----------------------
.: Added some new checks and fixes in order to ban unfair clients
.: Changed the TCP (local) and UDP (global) source search for clients who are downloading many files, to make some server software happy one more time and to avoid blacklisting
.: Unused credits are removed after 5 month (to limit the memory usage for credits) 

----------------------
- Aug 12th, 2003     -
----------------------
bluecow: Server error messages are no longer displayed in the server info window, but in the application log window.
bluecow: ED2K file meta data received during a file search is filtered before adding it to the part.met and eventually to the known.met file to avoid storing of not needed data.
bluecow: Several changes in the file preview command: The preview command is enabled, if a minimum of 16 KB (MPEG audio/video) or 256 KB at the beginning of the file is available. The preview command is also enabled for files of type "CD-ROM image" or if the ED2K meta data indicates an audio/video file type. To enable the new features of the preview command specify VideoLAN client as the video player for preview or (if using some other player) specify the 'PreviewSmallBlocks=1' (section=eMule) setting in the preferences.ini file and disable the 'Create backup for preview' option.
Ornis:   better counting of the stats: saved by ICH, lost due to corruption and saved by compression
Ornis:   little GUI fixes/updates

----------------------
- Aug 10th, 2003     -
----------------------
Ornis: Source-swapping cares for download priorities now and is more safe against useless handing over sources back and forth
Ornis: Alt-Return opens detail dialog for downloads and user
Ornis: added Enhanced Chunk Selection, better selection which part of a file to download next  [Maella & jicxicmic]

----------------------
- Aug 4th, 2003      -
----------------------
bluecow: Added extracting of meta data and audio/video characteristics for MP3,AVI,MPEG and other files. To disable this option use the "ExtractMetaData" setting (file=preferences.ini, section="eMule", name=ExtractMetaData, value=0 (disable), value=1 (enable for MP3 and AVI files), value=2 (default; enable for MP3, AVI, MPEG and other files).
bluecow: Added sending of extracted meta data and audio/video characteristics for MP3,AVI,MPEG and other files to servers and clients. The text meta data (e.g. Title, Author, Album) is not sent to the servers but to clients when viewing the shared files. Data sent to servers includes audio/video codec, media length and bitrate.
bluecow: More safety in checking shareable files in temporary directory.

----------------------
- Aug 2nd, 2003      -
----------------------
bluecow: Added new Server Info window with optional auto scroll, rotating log, copy+paste
bluecow: Added new option to specify or to disable the server UDP port (file=preferences.ini, section=eMule, name=ServerUDPPort, value=0 (disable server UDP port), value=65535 (default; use random server UDP port), value=<n> (UDP port)
bluecow: Added some helpful server socket error messages.
bluecow: Fixed some minor focus problems in search window.
bluecow: Added more columns to search list for showing new ed2k meta tags.
bluecow: Format of date/time strings is no longer dependent of the selected language.
bluecow: Statusbars of paused files are shown in a dimmed colors [SlugFiller grayPause]

----------------------
- Aug 1st, 2003      -
----------------------
bluecow: Splitted the taskbar notification for "Download finished and new add file added"

----------------------
- July 30th, 2003    -
----------------------
bluecow: Fixed some security bugs concerning log messages [thx i0nic]

----------------------
- July 29th, 2003    -
----------------------
.: Made some changes and fixes in SecureHash. Also clients with the status "invalid" will no longer be able to use a Friend Slot
.:Implemented MobileMule protocol 0.4 (visit mobil.emule-project.net for more info)
bluecow: ED2K protocol: fixed handling of OP_FILESTATUS for files with a size of PARTSIZE*N
bluecow: Fixed crash at exit bug which occurred when flushing internal file data buffers to part files
bluecow: Fixed crash bug with clients sending more than one OP_HELLO packet.
        
----------------------
- July 27th, 2003    -
----------------------
bluecow: Fixed handling of hashsets for files with a size of PARTSIZE*N
bluecow: Invalid entries in known.met are deleted at startup
bluecow: ED2K protocol: OP_SETREQFILEID is no longer sent for files <= PARTSIZE
bluecow: ED2K protocol: OP_FILEREQANSNOFIL is no longer sent when receiving OP_FILEREQUEST

----------------------
- July 25th, 2003    -
----------------------
Ornis:   manual disable textbox auto-completion in the preferences.ini file, by setting "UseAutocompletion=0"
Ornis:   Webinterface: added sorting of search results
bluecow: searching of listview items for all owner drawn listview controls (just type the first view characters of the label to find) [ZZ]

----------------------
- July 22th, 2003    -
----------------------
bluecow: Disabled sharing (by accident) of eMule installation folders (config, lang, webserver) and several files from the temporary directory.
bluecow: Fixed a rare problem where a client could receive properly compressed blocks but was though not capable of decompressing the entire compressed stream.
Ornis:   Fixed Drag&Drop-image of downloadfiles

----------------------
- July 20th, 2003    -
----------------------
Ornis: IRC- & Message-Windows use closeable tabs now
Ornis: history function in the IRC- & messages-dialog, scroll by cursor up & down
Ornis: Doubleclick on serverinfo in the statusbar opens a dialog with the details of the connected server
Ornis: new downloads catched from the browser are now assigned to the current targetcategory from the search-dialog
Ornis: to reset the popup-history of searchtext/serverlist-URL : press ALT or CTRL   and then DEL
Ornis: Statistics: percent display of successful/failed upload sessions added
Ornis: Fixed count of failed upload sessions [Maella]

----------------------
- July 19th, 2003    -
----------------------
bluecow: Fixed bug with downloading of files with a size of 9728000 bytes.
bluecow: Added several parts of SlugFiller's SafeHash [SlugFiller]
- SafeHash: Known file hashing features
- SafeHash: Miscellaneous safety and tweaking features
Ornis:   improved update of the downloadlistcontrol, when new sources are added to an expanded downloadfile
Ornis:   Fix of a typo in the webinterface, which could have led to instability on some systems
Ornis:   Webinterface: (re)added two settings in the preferences
bluecow: Upgraded to CTreeOptionsCtrl v1.55 [thx PJ Naughter]
bluecow: New log panes, multiline edit controls with optional auto scroll and rotating log. 
(Note: The previously used "MaxLogMessages" entry in preferences.ini is obsolete and is replaced with "MaxLogBuff" which
can be used to specify the size of the buffer(s) in KByte. Default size = 64 KByte)
bluecow: Searchresult list: Search results which match files in the download list are shown in a fixed shade of red.
bluecow: Font for Server-, Message- and IRC-Window can be specified.
bluecow: Timestamp setting for IRC-Chat also applies timestamps to messages from clients in Message window.
bluecow: Timestamps in IRC-Window and Message-Window localized.
bluecow: Added memory debug statistics for debug builds only [UVman]

----------------------
- July 18th, 2003    -
----------------------
Ornis: Added extended control: manual handling of sources, at several requests to the same client (A4AF) [based on sivka,enkeyDEV]
Ornis: Added: automatic assignment of new Download to categories by filename filters [HoaX_69]
Ornis: corrected saving position for the scheduler-ini-file (-> \config\ )

----------------------
- July 16th, 2003    -
----------------------
bluecow: Fixed bug with downloading of files with a size greater thean 2 GB [thx Maella]
Ornis:   Bugfix: spanish & french translation bugfix. (bug resulted in less search results)
Ornis:   better update of the SecureIdent-statistic


v0.29c
----------------------
- July 13th, 2003    -
----------------------
bluecow: Several small bug fixes and code improvements [Maella, dpr, rayita]

----------------------
- July 11th, 2003    -
----------------------
Ornis+bluecow: String resources split into language resource DLLs [Elandal]

----------------------
- July 9th, 2003     -
----------------------
bluecow: Fixed flaw in IPFilter.

----------------------
- July 7th, 2003     -
----------------------
bluecow: Added LAN-IP and IP-Filter for server IPs and client IPs received during source exchange and received from servers.
Note: The option "Server/always filter bad IPs" was changed to handle the LAN IP filtering of IPs for servers and
clients and was moved to the "Extended Settings" page and is now called "Filter server and client LAN IPs".
If you are running eMule within a LAN you may decide to disable this option to be able to communicate with
servers and clients within the LAN.

----------------------
- July 5th, 2003     -
----------------------
.: Added some SecureHash security fixes, also SecreHash is now enabled by default
.: The Queueposition (waitingtime) is now also protected by SecureHash (if enabled)
.: Fixed a bug which caused source to have wrong information and filecomments/names
bluecow: Fixed problem with completing file which was concurrently uploaded.
bluecow: Fixed bug with previewing of files with spaces in the path [mediterranean]
bluecow: Fixed bug with client deletion [SlugFiller]
bluecow: Fixed minor bug in statistics with error and banned client stats.

----------------------
- July 2nd, 2003     -
----------------------
bluecow: Better filtering of sources according valid IP+Port found during file searches.
bluecow: Added boolean search expressions (AND, OR and NOT operator and parenthesis)

----------------------
- July 1st, 2003     -
----------------------
bluecow: Fixed minor bug in search query with file extension.
bluecow: Added version column of server software to server listview control.
bluecow: Fixed minor bug where the 0.0.0.0 ServerIP of some clients were added to the server list.
bluecow: Fixed bug with compressed control data packets length [thx MKThunderStorm]
bluecow: Optimized source exchange for clients which are asked for sources for the first time in the current session.

----------------------
- June 30th, 2003    -
----------------------
bluecow: Added more units for specifying min/max filesize in search dialog. (append b[yte],k[byte],m[byte],g[byte] to the numbers to change the units).
Ornis:         minor tweaks in the filename cleanup
Ornis:   corrected codepage-settings for turkish language in the webinterface

----------------------
- June 29th, 2003    -
----------------------
bluecow: Fixed mem leak in upload client caused by clients requesting too large blocks.
bluecow: Fixed mem leak with duplicate hashed files.
bluecow: Couple of changes for more stable code and less potential mem leaks.
Ornis:   Fix, preventing crashes after IRC disconnection
Ornis:   Show size of partfiles on disk (Filedetails & Tooltip)
Ornis:   little GUI fixes

----------------------
- June 27th, 2003    -
----------------------
bluecow: Added sending shared files list to server with ClientIP+Port to get more sources when performing global UDP search requests.
bluecow: Added sending shared files list to server with more meta tags for more accurat search results according file extension and file type.
bluecow: Added tooltip for showing the entire meta data for a search results which was received from the server/client.

----------------------
- June 25th, 2003    -
----------------------
bluecow: Added overlay icons for clients which were successfully identified by a secure hash
bluecow: Fixed bug with GetTickCount timer meassurement [dpr]
Ornis:   Added Secure-Ident-Statistic (how many successfully and how many failed identificated clients)
Ornis:   Fixed menu-ressource bug in the preferences
Ornis:   Turkish language fix


v0.29b
----------------------
- June 17th, 2003    -
----------------------
bluecow: Dragstart of category-tabs not hypersensible anymore
Unk: Irc: Now detects UnderOps.
Unk: Desc ping to servers are now done less frequent.
Unk: Fixed a bug in the server ping time delays.
Unk: Fixed a small bug in the stats.
Ornis:Speedmeasurement tweaked [zz]

----------------------
- June 15th, 2003    -
----------------------
bluecow: Fixed bug with an deleted client instance which was used for the A4AF statistics value.
bluecow: Redid Ext. Settings dialog for more future options.
Ornis:   Webinterface: Links are relative now
Ornis:   improved UNC usage as shared folders
Ornis:   Fixed known.met to be handled correctly in the config-folder
Ornis:   better handling of the check which files to hash
.: Added a secure identification system (against userhash "stealing") based on RSA encryption. For test reasons, it is disabled by default in this version, you can enable it in "security settings". Please check the FAQ for more informations about this system
.: Added first part of an advanced spamfilter which automatically detects and filters suspicious messages

----------------------
- June 13th, 2003    -
----------------------
Ornis: Webinterface: Improved Graphs, bigger, nicer, including the connection-graph [emule+]
Ornis: Webinterface: added button to remove completed files
Ornis: Sharedfileslist: Click with middle mouse button on an item opens the comment dialog of it
bluecow: Implemented ed2k protocol message OP_CHANGE_CLIENT_ID for better dealing with LowID sources.
bluecow: Fixed several issues in dealing with uninitialized memory contents [donq]
bluecow: Fixed problem with wrong file IDs received from clients.
bluecow: Workaround for strange socket deletion crashs which were experienced by WinXP users.

----------------------
- June 12th, 2003    -
----------------------
bluecow: Fixed several potential heap corruptions.
bluecow: Fixed problems with download data rate meassurement which may cause crashs on slower/Win98 systems.
bluecow: Fixed problem with processing an invalid OP_HELLO packet from a client.

----------------------
- June 9th, 2003     -
----------------------
bluecow: Added option "CommitFiles" to select the level of commiting file data to disk (may be interesting for Win98 users) [idea SlugFiller]

----------------------
- June 8th, 2003     -
----------------------
bluecow: For modders only: Added the possibility to compile the sources for string based resource string identifiers (search for USE_STRING_IDS)

----------------------
- June 7th, 2003     -
----------------------
bluecow: Fixed bug in server message handler for OP_SERVERIDENT.
bluecow: More safety in handling server message OP_SERVERMESSAGE and client message OP_MESSAGE.

----------------------
- June 6th, 2003     -
----------------------
Ornis: saving location for own comments corrected (config-path)
Ornis: Webinterface: Categorysupport corrected for order by columns
bluecow: Fixed a potential problem with system tray icon on Win98 systems [Special thx to Ergol/donq]
bluecow: Reduced size of search expression


0.29a
----------------------
- June 2nd, 2003     -
----------------------
Ornis: fixed Win9x incompatibility (instable OS)
Ornis: some menues missed localization after runtime language change - fixed

----------------------
- June 1st, 2003     -
----------------------
bluecow: Sources found during local/global server searching are pre-filtered to avoid false displayed results in the sources column of the searchlist and to avoid using false sources which are sent by some servers.
bluecow: Fixed bug with completed files which were rehashed at next startup and which caused a duplicate entry in known.met.

----------------------
- May 31th, 2003     -
----------------------
bluecow: Fixed minor issue with servers sending different server description packets during runtime.

----------------------
- May 29th, 2003     -
----------------------
bluecow: Fixed bug with temp folder which was set to incoming folder in some situations.
bluecow: Fixed minor bugs in file open and browse folder dialogs and according property pages.
Ornis: Shareaza recognition for Stats & Info
Ornis: added new language Galician (by Emilio)

----------------------
- May 28th, 2003     -
----------------------
bluecow: Fixed memory leaks in uploader.
bluecow: Fixed memory leaks in all timer callback functions; added exception handling.
bluecow: Reduced GDI resource usage for Win9x/WinME.
bluecow: Added more debug log messages for unknown TCP packets.
bluecow: Statusbar text is cleared when reseting the log or debug log.
bluecow: Fixed missing file exception handler in upload function.

----------------------
- May 27th, 2003     -
----------------------
bluecow: Fixed some problems with part.met/part files which could be to long or to small (potential file-completion bug) [SlugFiller]
bluecow: Fixed memory leaks in Archive Recovery thread.
bluecow: Fixed crash in Archive Recovery thread when previewing part files which are currently in "completing" state.

----------------------
- May 26th, 2003     -
----------------------
Ornis: Webinterface: Fix: under certain circumstances, active downloads were displayed as completed
Ornis: added new language Galician (by Emilio)
bluecow: Fixed major memory leaks in WebSocket.
bluecow: Fixed couple of GDI resource leaks and inproper usage of GDI resources.
bluecow: Added proxy error messages. To enable it: Specify "ShowErrors=1" in "[Proxy]" section of preferences.ini.
bluecow: Fixed problems with duplicate sources due to source exchange packets with wrong version.
bluecow: More reliable identification of clients sending an UDP packet by searching clients with IP and UDP port

----------------------
- May 24th, 2003     -
----------------------
Ornis: moved preferences files to "config\" subfolder (cant be shared, old preferences files are moved the at first start)
Ornis: Category-Tabs now sortable (Drag&Drop)

----------------------
- May 21th, 2003     -
----------------------
VQB:  changed LowID UL slot addition to alternate with HighID
VQB:  some code cleanup and changes to use more integer math [Elandal]
Ornis:Webinterface: progressbar shows shades of blue, depending on the amount of found part-sources [Ju1i3n]
VQB:  adjusted sort order for QR (high speed -> low speed DL followed by low -> high QR)

----------------------
- May 19th, 2003     -
----------------------
Ornis: Webinterface: fix add ed2k-Download to a category
Ornis: Webinterface: transferlist offers more categories to filter for (file type, status)
Ornis: update statistic graphs scale when changing up/down capacities over the webinterface
Ornis: upgraded AsyncSocketEx to v1.2
bluecow: Fixed potential problems for Win98 concering windows messaging.

----------------------
- May 17th, 2003     -
----------------------
bluecow: Fixed bug in server window when sorting by server IP
bluecow: Fixed 0-size part.met backup file bug.
bluecow: Fixed potential mem leaks and crashes for several met-file IO related functions by rewriting exception handling.
bluecow: Added system error messages for all file-IO related eMule log messages.
bluecow: Added recently used list for search text and servemet-URL controls (aka autocompletion), reset history by AltGr+Delete)
bluecow: Added searching for listviews in serverwindow/searchwindow (Ctrl+F,F3,Shift+F3)
Ornis: fixed win9x-crash when the view-filter popupmenu of the category-tab was accessed
Ornis: fixed preview of archives before any download
Unk: Fix small overhead bug
Unk: irc: Liquid updated their ircd. It broke eMules IRC.. It is now updated..
Unk: irc: eMule now should support multi mode commands.

----------------------
- May 16th, 2003     -
----------------------
bluecow: Fixed potential mem leak when copying text into the Windows clipboard.
Ornis: Added a lot of new statistics (by Khaos)
Ornis: fixed Scheduler bug
Ornis: Added configuration for date/time-format of the log

----------------------
- May 15th, 2003     -
----------------------
bluecow: Fixed LowID bug which was cause due to corrupted part.met files.
bluecow: Fixed loading of part.met file list: Corrupted part.met files do no longer stop the loading of other part.met files.
Sony: Fixed problem with very large files in MSVC 7.1 release build; Fixed Minimize to Tray icon (thanks zegzav)


v0.28b
----------------------
- May 8rd, 2003      -
----------------------
Ornis: Categories: extented choice of the function of the old "all" tab, switchable to Video,Audio,Transferring,Erroneous ,...
Ornis: Upload-, Queue- and Knownclientlists are titled with the number of the listed clients
Ornis: different trayicon when serverconnection with a lowID (emule with blindfold, from emule+)
Ornis: Webinterface: category support
Ornis: Webinterface: displays completed transfers

----------------------
- May 3rd, 2003      -
----------------------
bluecow: Fixed mem leak when downloading server.met via HTTP [UVman]

----------------------
- May 2nd, 2003      -
----------------------
bluecow: Fixed another bug where an unwanted client could become a friend.

----------------------
- April 28th, 2003   -
----------------------
bluecow: Fixed minor glitch with icons in tab controls on server and message window.
bluecow: Added standard shortcuts to log and debug listview controls (Copy=Ctrl+C, Select All=Ctrl+A)
Ornis:   Websearch Filedonkey.com now supports filter by filesize-limits

----------------------
- April 27th, 2003   -
----------------------
bluecow: Rewrote entire packet processing code to use exception handling and proper memory cleanup.
bluecow: Rewrote most of the meta tag processing code to support new meta tags.
bluecow: Fixed downloading of stopped or paused files.
bluecow: Added passive source finding for files in download queue which were just started and not already in shared file list.
bluecow: Fixed minor mem leaks and improper usage of delete operator [NoamSon]
Ornis:   Webinterface blocks IPs after 5 failed login attempts for 15 minutes
Ornis:   Filenamecleaning: customizable substringfilter (.ini : FilenameCleanups= )
Ornis:   option to auto-clean filenames on downloadstarts

----------------------
- April 26th, 2003   -
----------------------
Ornis: If the connected server has a filelimit, announce not more files than accepted

----------------------
- April 25th, 2003   -
----------------------
bluecow: Fixed bug with empty shared directories and OP_ASKSHAREDFILESDIR.
bluecow: First Run Time wizard finally gets a "Finish" button.
Ornis: Links in Chat (hypertextctrl) dont break on special chars anymore
Ornis: better URL decoding (e.g. for special chars in ed2k links)

----------------------
- April 24th, 2003   -
----------------------
bluecow: Fixed bug with OP_ASKSHAREDIRS where a client could ask for shared directories while there is a currently a shared files list received. Note: The viewing of shared directories of remote eMules was reset to 0.28+ because of a bug in 0.27.
bluecow: Fixed major memory leak with compressed packets (thx Blackstar2)
bluecow: Fixed bug with new meta tags of type "float" which were sent by servers which are offering shared files from Hybrid's 0.48+
Ornis: Scheduler Fixes
Ornis: Schedules can be activated directly via hotmenu (Alt-X) , (de)activating of the scheduler as well
Ornis: identical shared folders are not sent multiple times anymore (under circumstances)
Ornis: added: accurate speed measurement also on busy CPU [based on Ottavio84+Badwolf]
Ornis: small GUI-fixes

----------------------
- April 23th, 2003   -
----------------------
bluecow: Fixed resizing bug in log list controls
bluecow: Fixed potential winsock termination bug
Sony: added option in extened prefs to disable source exchange messages in verbose log

----------------------
- April 22th, 2003   -
----------------------
Ornis: added scheduler controls to hotmenu
Ornis: cleared control of expand/collapse by key

----------------------
- April 20th, 2003   -
----------------------
Ornis: Scheduler: fixed saving settings
Ornis: fixed resumesame-cat & dontRecreateStatGraph - settings
Ornis: fixed changing category-title when downloadinfos on tabs is activated

----------------------
- April 19th, 2003   -
----------------------
bluecow:Fixed bug in preferences/directory control which was deleting the system's icon image list.
bluecow:Fixed bug with non existing shared directories which could not be unshared in preferences/directories.
bluecow:Double click in shared files list opens file with associated application.
bluecow:When opening a file from download list or shared files list, the open command used is the same as when double clicking in Windows Explorer.

----------------------
- April 18th, 2003   -
----------------------
bluecow:Fixed bug with log messages not shown at startup.

----------------------
- April 17th, 2003   -
----------------------
bluecow:Added filetype icons to search- and shared files listviews.
bluecow:Fixed bug with wrong nr. of search results shown in search tabcontrol when viewing files of different directories from remote client.


v0.28a
----------------------
- April 15th, 2003   -
----------------------
Sony/bluecow: tweaked hashing algorithm, should be less CPU intensive now
VQB: long UL sessions checked for not "full chunk" method
VQB: prevent multiple checks of directories when hashing (khaos)

----------------------
- April 14th, 2003   -
----------------------
VQB:  added Total UL/DL ratio to statstree

----------------------
- April 13th, 2003   -
----------------------
bluecow:Redid "Add Friend" dialog.
bluecow:Added "Detail" dialog for not connected friends. If a friend is currently connected, the details function shows the "Client Details" dialog.

----------------------
- April 12th, 2003   -
----------------------
Unk: Receive Hard and Soft file limit for servers.
Unk: Server list was not updated when a server description was received.
bluecow:Workaround for columns resizing to zero width when double clicking on divider.
bluecow:Fixed bug where unwanted client could become a friend.
bluecow:Fixed bug with OP_ASKSHAREDFILESDIR where remote client does not get the shared files from a folder which has no trailing backslash.
bluecow:Support for viewing remote client's shared directories in search results.
bluecow:Fixed bug where client changed from HighID to LowID and receives still the old HighID of itself via source exchange and wanted to connect to itself.

----------------------
- April 11th, 2003   -
----------------------
bluecow:Unified all message boxes.
bluecow:Optimized drawing and sorting functions for several list controls.
bluecow:Fixed bug in source exchange where client gets no sources as long as it does not have at least one complete part.
bluecow:Little optimization on loading of server.met
bluecow:Implementation of eDonkey protol message OP_END_OF_DOWNLOAD
bluecow:Several small code changes and potential bug fixes due to temporary compiling with warning level 4!

----------------------
- April 9th, 2003    -
----------------------
bluecow:Fixed bug when requesting hashset and remote client does not answer immediatly with the hashset.
bluecow:Fixed heap corruption when receiving a server's OP_SERVERIDENT without any strings

----------------------
- April 7th, 2003    -
----------------------
Ornis: Categories: Doubleclick opens category-preferences; Category shown as downloadlist column (optional)
Ornis: Category: new priority preference - new assigned files get this priority 
Ornis: Category: resume next paused download in the same category (optional & manual)
Ornis,bluecow: MLDonkey better recognized
Ornis: Red warning rating icon is shown when more than 1/3 of the ratings are bad

----------------------
- April 6th, 2003    -
----------------------
bluecow:New first run time wizard.
bluecow:Hotfix for partfiles getting too large.
bluecow:Fixed credit score ratio computation for clients which have transfered >4GB to an other individual client. (thx le_fred+Harvey56)

----------------------
- April 5th, 2003    -
----------------------
bluecow:New log window with a rotating log, max. nr. of lines can be specified in preferences.ini (MaxLogMessages=<num>; <num>=-1 ... unlimited)
Ornis:  Webinterface: downloadlist shows priorities of files and the controls to change it
Ornis:  Webinterface serves images. Local files (contained in binary zip & self installer) are now used for Webinterface display

----------------------
- April 4rd, 2003    -
----------------------
Ornis: Removed unnecessary repaint (&program-freeze) of the statistic graphs

----------------------
- April 3rd, 2003    -
----------------------
bluecow:Fixed bug with message box "An attempt was made to access an unnamed file". Instead of that message box the log entry "Invalid or corrupted packet received" is created.
bluecow:Minor speed improvements by replacing many functions which deal with MD4 hashs.
bluecow:Added small hex dump log output for unknown opcodes (Maella).
bluecow:Double click in all client related listview controls opens client detail dialogs.
bluecow:Double clicking on download filename opens file details dialog.
bluecow:Sources found during local server and UDP searching are stored and eventually added to the download file.
bluecow:If adding a file to donwloads from a remote clients file list, the remote client is added as a source.
bluecow:SearchList: Already downloaded files (found in known.met) are shown with an appropriate color.
bluecow:SearchWnd: Last typed in server-met URL is saved in preferences.

----------------------
- April 1st, 2003    -
----------------------
bluecow:Fixed deadlock when canceling an HTTP download of server.met
Ornis:  Tooltips over cat-tabs displays some summary information of that category
Ornis:  optional display of the cat-tabs as "Title (loading/Filecount)"  (Preferences->Display)
Ornis:  Statusbar doubleclick: e.g. Log-Pane shows complete line in MessageBox, MessageIcon opens the message-window
Ornis:  Show Webinterfacestatus in the "MyInfo"-box, incl. current active sessions

----------------------
- March 30th, 2003   -
----------------------
Ornis: Webinterface: fixed sorting transferlist by progress
Ornis: Save category-setup during runtime (avoid loosing settings)
Ornis: Date and time representation appropriate for locale

----------------------
- March 28th, 2003   -
----------------------
Ornis: Webinterface: Dont allow guests to clear the logs
Ornis: Webinterface: server-search control via webserver & start downloads
Ornis: Webinterfacetemplate: set file-settings are saved now
Ornis: more shortcuts for the lists: Ctrl+A selects the whole list; downloadlist +,-,Cursor left/right to expand&collapse sources of files

----------------------
- March 26th, 2003   -
----------------------
Ornis: Uploads-Tooltip better display of transferred data
Ornis: new: Scheduler, to plan settingchanges & actions
Ornis: select the webserver-template as preference

----------------------
- March 26th, 2003   -
----------------------
Ornis: Webinterface, portchange restarts webserver automatically [cax2]
Ornis: Webinterface, disable guestlogin reacts immediately
Ornis: Some potential (certain circumstances) exitcrashes fixed [2bottleMOD]


v0.27c
----------------------
- March 23th, 2003   -
----------------------
Ornis:Fixed security bug which could cause eMule be crashed (new settings in security preferences)
Ornis:Webserver: Fixed display if files>2GB
Ornis:Webserver Template updated by Daan

v0.27b
----------------------
- March 21th, 2003   -
----------------------
Unk: Fixed possible crash with Comment packet.
Unk: Recheck unzip size to avoid problems. (emarc)
Ornis:Patch to enable folderselection when no C: is on system
Ornis:Fixed seek-failures on large files [gabest]
Ornis:Trafficcounter in credits save>4GB now

----------------------
- March 19th, 2003   -
----------------------
Ornis: Added Webserver Control Panel [based on Kuchin], with changed/added:
  -Progressbars with colored part-display!
  -various style changes/corrections
  -datasizes better casted
  -additional preferences: set connectionlimits, sourcesperfile, new connections per 5 seconds, and 2 file settings
  -Two access profiles: Admin(full power) & Guest (only watch)
  -Fixed incompatiliby of control images concerning Opera & old Mozilla
  -Fixed security bug, concerning sessionID creation
  -Add log-message of Logins & Logouts
VQB: Eliminated just created ed2k links prompting to add links from clipboard
Unk: A previous version or mod seems to have set a clients hash to all 0. eMule now verifies your hash at startup and resets it if required.
Unk: UDP only use clients IP for finding the sender.. It now checks for UDP port also to make sure it finds the correct object..

----------------------
- March 16th, 2003   -
----------------------
Unk: Double update in Known Client List fixed. (JustusJonas)

----------------------
- March 15th, 2003   -
----------------------
Ornis:Cancel downloads of a category are now prompted first
Unk: Disabling queue list bug.
Unk: Source Exchange updated to include the users hash to help prevent multiple clients.
Unk: Client Details bug.
Unk: Fixed a bug that didn't upldate last seen if a client in your queue only used UDP.
Unk: Added localization to the Known Client List.
Unk: Fixed a bug where a source could get stuck in the Asking state forever.
Ornis:Adding same ed2k-file multiple times via weblink was possible when eMule was not running
Ornis:You can now enable loggin the verbose-log to disk, without display it in serverwindow

----------------------
- March 14th, 2003   -
----------------------
Ornis: Fix: Versionstats for the Hybridversion now visible
Ornis: Foldercount fixed when sending package SHAREDDIRS
Ornis: Fixed: decision about zipping a package was made case sensitive - not anymore
Ornis: Download-Tooltip corrected (one info was gone)
Orins: Fixed: Sending commands to categories handles "show all unassigned" now


v0.27a
----------------------
- March 13th, 2003   -
----------------------
Ornis:Added options to save logs to disk
Unk: Credit System Optional
Unk: Simple first time setup-wizard
Unk: Another Protocol change for better compatability to the Hybrid.
Team:and a number of tiny corrections, Fixes & graphical updates

----------------------
- March 11th, 2003   -
----------------------
Ornis:Sharedfilelist: linkcopy now for multiple selection too
Ornis:Searchwindow: Box for Directlinks (ED2k-Filelinks) supports multiple links
Ornis:Option to watch the clipboard for new ED2k-Links to enter to the download (after a prompt)
Ornis:Preferences new group: Security (filters), new filter: comments
Ornis:new column "Folder" in the sharedfiles list
Unk: lMule is now detected.
Unk: eMule clients v0.19 and below are now given a lower queue rating.. This is to push these client to upgrade due to the client publishing to the wrong server port that doesn't use the standard port.
Ornis:Added a hotmenu for faster control via keyboard. Press Alt+x !

----------------------
- March 10th, 2003   -
----------------------
Ornis: Completed file in transferlist will be opened when item is activated
Unk: No longer remove uploadclients with a unknown file name to be more compatable with Hybrid.
Unk: ShareFileList now uses the queue&upload list to create a bar to show how spread a complete file is in the network.
Unk: Fixed a bug in the wizard.
Unk: Added a Known Client List to the transfer window.
Unk: UploadClients with unknown filename is no longer removed for better compatablity to the Hybrid client.
Unk: SharedFile list now has a bar that is generated from the queue&upload list to show how well spread a file is.
Unk: Fixed a bug that caused eMule to crash if you got disconnect from your ISP.
Ornis:Comment icon should be more up to date [Moosetea]

----------------------
- March 2st, 2003    -
----------------------
Ornis: Fix: saving alltime transferred size for files not limited to 4GB anymore
Ornis: Fixed bug that didn't allow previews of movies with capital extention
Ornis: Preferences reorganized - new group: Display
Ornis: New option to switch on/off the rating/comment-icon in the downloadlist

----------------------
- March 1st, 2003    -
----------------------
Unk: Nondownloading sources are now updated a 10th of the time. (based on Maella)
Unk: Name and Desc of servers are now updated. Max users is now a seperate column.
Unk: Radio button bug in wizard fixed.
Unk: Changing how eMule exchanges version type.
Ornis: Downloadlist can now be organized in categories, for switching/filter downloadlist, set different incoming folders, colors and perform commands on all files of the category...
Ornis: Date/Timeformat can be changed in the preferences.ini , strftime() compliant format string!!!

----------------------
- February 26st, 2003-
----------------------
Ornis: Fixed: sourceexchange was more seldom under certain circumstances
Ornis: stopped downloads dont collect sources anymore
Unk: Fix bug that allowed a upload to upload for more then one chunk in Full Chunk Mode.

-----------------------
- February 25th, 2003 -
-----------------------
Unk: View transfering parts in uploadlist. (Lonestar)

----------------------
- February 24st, 2003-
----------------------
Ornis: middle-mouseclick on a comment-symbol opens the commentlist
Unk:   Upload bars are now 3D.
Ornis: fixed auto-versioncheck [thx bluecow]
Ornis: added display of the last time data was received (written to disk) for every file (downloadcolumn, tooltip, filedetaildialog)

-----------------------
- February 21st, 2003 -
-----------------------
Unk: Completely changed the auto priority methods. Download and Shared prio is now completely seperate. Auto priority is now defaulted.

-----------------------
- February 19th, 2003 -
-----------------------
Unk: Merged in new DownloadListCtrl. (Maella)
Unk: Merged in view shared list of Hybrids. (Bluecow) 
Unk: Don't try to update queue list at all if not visiable. (zz)
Unk: Another Update on the Min to Tray Button. (Zegzav)
Ornis:Upgraded Notifier, to support customizable skin, close- & history-function
Ornis:Doubleclick on a user in the commentlist starts a (Message)Chat to that user
Ornis:Fixed issue with limiting the downloadspeed at runtime and via commandline


v0.26d        
-----------------------
- February 15th, 2003 -
-----------------------
Unk: Fix queue rotation bug. (Some clients were instantly kicked from upload)
Unk: Several optimizations by BadWolf63,ichi
Unk: Minimize to tray gui button bug fixed. (zegzav)
Unk: cDonkey is now in the stats.
Unk: Splitter bar position is now saved correctly.


v0.26c
-----------------------
- February 13th, 2003 -
-----------------------
Unk: Change how we detect Hybrids.
Unk: Changed some slot management. (Some help from VQB)
Unk: It seemed that some uploads tended to be extremely long in Chunk mode. There is now a check to make sure this doesn't happen.
Unk: Files set to auto no longer hang when you resart eMule. (jicxicmic)
Unk: Roundoff error correction for datarates. (Maella)
Unk: Changed some server connect code. eMule now connects a lot smarter with Safe Mode turned off helping with lowID problems.
Unk: Server stats is no longer lost on restart when autoupdate is turned on.
Ornis:Added commandline command: "limits=up,down" (e.g. "emule.exe limits=50,12") to set up-&down- transferlimits
Ornis:Added option to show up&down-rates in the title of the programwindow
Ornis:Middle mousebutton opens the detailwindow for the selected item in download-, upload- and queuelist
Ornis:Fix: webservices in sharedfileslist works again

-----------------------
- February 11th, 2003 -
-----------------------
Ornis:Reenabled statusbaricon for new messages.
Ornis:a number of little fixes, GUI & functional [some from JonnyB]
Unk: Auto saving serverlist & friendlist list fixed.
Unk: Source exchange now only sends needed sources to the client.
Unk: Small gui fixes.
Unk: Fix some more possible secuity issues and memory managments. (Some by beef2k & bluecow & Juanjo)
Unk: Small fix to maxconnection preference.
Unk: Pausing and Priority now saved again at shutdown.

-----------------------
- February 10th, 2003 -
-----------------------
Ozon: Bugfix; ed2k links is now correctly generated by emule for files larger than 2GB...
Ornis:Fixed GUI-issue in commentslistingdialog when resizing the window
Ornis:Show downloadcount above downloadlist
Ornis:Fixed save&restore columnorder of downloadlist
Ornis:Filter for incoming messages (config in prefs-notification, default filterexample "Your client has an infinite queue")


v0.26b
----------------------
- February 8th, 2003 -
----------------------
Unk: Converted a lot of char[] to CStrings to help avoid buffer overruns.
Unk: If hashset is found to have problems, it now reasks for it.
Ornis:Fixed Webservices in Searchview
Ornis:Fixed running preview [jicxicmic]
Ozon: Added persistent backups of .part.met files
Ornis:little GUI fixes
Ornis:added IP-ranges client-filtering (blacklist), using cDonkeys filter-file-format, basic filtering, more to come:)
Ornis:added own IP:Port to MyInfo-Window

----------------------
- February 7th, 2003 -
----------------------
Ozon: Added the macro THIS_FILE to all source code files, to help in finding leaks with VS. (please don't remove)
Unk:  Fixed secutity hole. (bluecow/zegzav)
Unk:  Serverlist and Friendlist are now saved during runtime too
Ornis:Using list with columns for comments-dialog- looks better

----------------------
- February 6th, 2003 -
----------------------
Ozon: Define EMSOCKET_DEBUG for trace log file for EMSocket...
Ozon: Changed packing alignment for most structs/classes (not the critical ones :), still 1 byte) to 8 bytes.
(can improve preformance...)
Ozon: Backup of Clients.met is now done every time emule starts.
Ozon: Variable renaming started... (CAbstractFile, CClientCredits for now...)
Unk:  Few bug fixes. Stats now have a packet counter.

Bug fixes, help from ZegZav, Bluecow, Ese Juani, jicxicmic
Optimizations, help from ichi, Maella, zz


v0.26a
----------------------
- February 2st, 2003 -
----------------------
Ornis: fixed reset serverlog crash
Unk: Fixed security hole. (beef2k)

----------------------
- February 1st, 2003 -
----------------------
Unk: Created a new algorithm to smooth out the spikeing TCP connections. This will help several things..
1) Spiking CPU & Bandwidth when many sources are added or reasked.
2) Help with conflicts between Source Exchange and UDP file reasks allowing UDP to be used more lowering the need for TCP and overhead.
Unk: Irc: Fixed another bug that could cause a crash when you close a channel.
Unk: Queue size is now adjustable.. (FYI: Contrary to belief, queue size has NOTHING to do with the amount of bandwidth overhead..)
Unk: File buffer size is now adjustable. If you are one of them people that is having problems with the buffer, try lowering it.
Unk: Download file priorities are now usable for rechecking sources.

----------------------
- January 31st, 2003 -
----------------------
Unk: Some clients may be reporting completed file status. Did some changes to hopefully stop this.
Unk: Added queue rank of Hybrid eDonkey clients.
Unk: Fixed protocol to allow eMule to stay in the Hybrid's queue.
Unk: Changing IP shouldn't force you to move to the end of the queue anymore.
Unk: Redid sorting of Download list one more time.
Unk: Sources with a full queue is now treated the same as noneededparts..

----------------------
- January 28th, 2003 -
----------------------
Unk: Fixed a bug that displayed eDonkey & eMule versions incorrectly.
Unk: We now detect eDonkey Hybrid Clients and Added Stats in Statistics.
Ornis: Filecompletion in seperate thread [Lord KiRon]
Ornis: added moified socket reading [by Jordy]

----------------------
- January 24th, 2003 -
----------------------
Ornis: support for  Opcode 0x48 (OP_FILEREQANSNOFILE) of the protocol. [references: DoubleT,eMule+/Tarod]
Ornis: used videoplayer is now selectable
Unk: Did a complete rewrite with the Update functions in Queue and Upload list to speed things up.. You should now be able to turn on the Queue Auto update feature without CPU load..
Unk: Redid the Overhead meter. (I no longer try to estimate the TCP and UDP headers) Also added some Overhead statistics.

----------------------
- January 21th, 2003 -
----------------------
Ornis: optimized internal sources-handling, for reduced cpu-load
Ornis: various runtime optimization for reduced cpu-load (statstree, tray&maindlg, GUI) [coop. with EseJuani]
Ornis: Shared files list now supports more multiselect-commands
Ornis: versioncheck at startup (optional) or manually
Ornis: full customizable Web Services for files
Ozon:  Fixed crash when trying to access statusbar before it was created (AddLogLine)

----------------------
- January 20th, 2003 -
----------------------
Unk: Added protcol to allow you to see what chunks a uploader has of the file.
Ornis: indicate files with ratings/comments by an icon in front of the filename (green/red,rating dependend)
Ornis: downloadlist: added sources-viewfiltering using modifier keys (see faq or help for usage!) [xrmb+Ese Juani]

----------------------
- January 19th, 2003 -
----------------------
Unk: IRC:Reconnect crash should be fixed.
Unk: Small change to downloadlist..
Unk: A client's server is now added with you first connect to him, Now, all client's servers you connect to are added to the server list.

----------------------
- January 18th, 2003 -
----------------------
Ornis: languages in selectionbox now labeled in local-language [pooz]
Ornis: fixed Toolbarbuttons always growing when changing languages [pooz]


v0.25b:
----------------------
- January 17th, 2003 -
----------------------
Ornis: file completion working! (thx to all users helping&testing with us)
Unk:   fixed AutoConnect on startup
Ornis: fixed wrong colormapping on the selector
Ornis: Systray-icon speedbar: color selectable in stats-preferences
Ornis: removed titlebar-preferences-menu for win9x users, which caused crashes for them
Ornis: added button to edit "adresses.dat" (in the server-preferences)


v0.25a:
----------------------
- January 12th, 2003 -
----------------------
Unk: Fix for sources being left behind when a file completes causing crashes.
Unk: Fix hash warning when a file is less then one chunk.
Unk: Made some changes to the download list, sources show more information in columns
Ornis: Handling doubleclicks on trayicon safer in respect to other apps in the systray [thx to reCDVst]
Ornis: Basic command line control:
        emule.exe { connect | disconnect | resume | status | exit }
                status: writes the status to file "status.log"
                resume: resumes next paused file


----------------------
- January 11th, 2003 -
----------------------
Ornis: the sort of Downloadlist by status is now using better order than alphabetically
Ornis: Statistics colorselection by colorpicker
Unk: You now have an idea of the bandwidth overhead eMule uses.. 
Ornis: Search now includes minsizes, maxsizes, extension, availability (thanks to Juanjo)
Ornis: language depended date/time-format is now updated during runtime when switching language
Ornis: Help-file access (FAQ-conversion). Avaiable in the download-section and already in the installer version.
Ornis: all statstics of shared files now handle >4GB

----------------------
- January 9th, 2003  -
----------------------
Ozon: Rewrote the hash thread code...
Changes: Now using worker threads instead of user interface threads; less overhead when creating threads.
Uses one thread for all new shared files that needs to be hashed instead of one thread for each file.
Cleans up the thread and associated objects if the user terminates the app when the thread is running.
And other changes...

----------------------
- January 8th, 2003  -
----------------------
Unk: Source asked count was nonfunctional. Fixed.
Unk: All lists now are initialized on a timer to help with win98 compatabilities.. Partially modified patch from Lucus. 
Sony: Search is now canceled when closing the active search tab; added support for Blindwrite, Alcohol 120% (CD Images) and flac (Audio) file extensions
Barry: When reading staticservers.dat file and looking for priority, only accept comma if it is in second position, try to avoid finding comma in server name.
Barry: When changing priority of a static server, also need to update staticservers.dat file.

----------------------
- January 7th, 2003  -
----------------------
Ozon: Added version tag to preferences.ini, to help with compability. Backup of old file and creating a new file for every new version, thereby deleting old and unused tags.

----------------------
- January 6th, 2003  -
----------------------
Unk: Wizard now auto detects OS version.
Unk: Sources now show if their queue is full.
Unk: Fixed a sort issue in the upload queue when the file a client wanted wasn't known yet.
Dirus: We no long ask for sources from clients that don't support it.
Dirus: Increased compatibility between clients (and future potential clients) by using special tags instead of version numbers.

----------------------
- January 4th, 2003  -
----------------------
Unk: Minimize to tray button added [thanks to Zegzav]
Unk: Old MLDonkey clients are now identified. (Some code by Mav)
Unk: Option that allows the client to try to upload based on finishing chunks, not time.. [VQB]
Ornis: Corrected display of '&' on some places
Ornis: Bugfix: Filedetails now closeable by ESC and Titlebar-Closebutton
Unk: Option to auto resume files when a file Completes or is Canceled. (This is meant to work in conjunction with "Added option to start new files from link or search etc. in paused mode". )

Barry:
------
-Saving received data without delay. When requesting files it now asks only for what is needed, not in 180k blocks. Compressed packets are now unzipped as they arrive and written to disk instead of waiting for full block.
-Write buffer:Writing to files is now buffered on a per file basis.The part file is flushed to disk when the buffer reaches 500k or 5 seconds since last flush. (Some code modified)
-Added option to auto-connect only to static servers.
-Added priorities to servers in staticservers.met (Modified for backward compatibiity)
-Option to change manually added servers to high.
-Option to refresh upload queue every 30 seconds.
-Automatically stores the last sort order of list views.
-Changed download list colour bar to show part downloading from client and part(s) pending in different yellows.
-Changed colour gradient to variable strength - level can be set in preferences (General)
-Give priority to part currently being downloaded when requesting next blocks.
-Changed priority order for parts of archives & movies as follows
        1) first (Optional)
        2) last (Optional)
        3) rarest, with priority to second then penultimate parts if same rarity
-Added preview for archives (zip, rar & ace)
-Enable preview when only first and last parts are complete, not first and last two
-Fixed bug that caused corrupt preview file if part wrote to disk during preview file copy.
-Fixed bug that did not tell remote client to stop sending file when it was cancelled.
-Don't run the normal timer processing if the app is shutting down - can cause unhandled exceptions.
-Added option to start new files from link or search etc. in paused mode.
-Added option to automatically set the registry values for ed2k-links to this application while running, then set them back when finished.

----------------------
- January 3rd, 2003  -
----------------------
Ornis: merged fix for better handling of loading corrupt partfiles (gaplist) [from SlugFiller]

----------------------
- December 31st, 2002-
----------------------
Unk: If you cancel a download, everyone queued for that file will be removed from the queue when the next upload slot is freed.
Unk: Support to upload to mutliple clients within a network. (Ie, clients with same IP, different ports) (Reported by Lord KiRon)

----------------------
- December 30th, 2002-
----------------------
Unk: Option to download preview chunks first. (Leaving this option off helps spread files faster.)

----------------------
- December 28th, 2002-
----------------------
Dirus: Fixed sorting by percent complete bug which caused the list to stay unsorted until all status bars had been drawn.
Unk: Small gui preference gui fix. General is no longer defaulted as the title in the preference window.
Unk: Small gui fix in download list. QR is now adjusted when you begin to download from that source.
Unk: Irc: ed2k file links with source attached now clickable.
Unk: Low2LowIP and NoNeededPart sources are slowly removed in the hopes of getting a better source. These sources are only removed when that file is close to it's max sources to prevent sources from being removed or added over and over. Also, if this souce is a AskedForAnotherFile source for another file, it will switch to that file.
Unk: Set up a verbose mode. This is for you people that like to watch useless info. Do Not Report Errors You See In This Window! 

----------------------
- December 27th, 2002-
----------------------
Dirus: Fixed finding yourself as source bug (at last).

----------------------
- December 26th, 2002-
----------------------
Dirus: Added a check for fake versions to the program version statistics.


v0.24b
----------------------
- December 24th, 2002-
----------------------
Dirus: Fixed a bug that made caused eMule to ask the same person for sources instead of a new person after a set time.
Dirus: Fixed a bug that allowed eMule to respond too often (as often as asked) to source sharing requests, rather than according to our preset limits.

----------------------
- December 23rd, 2002-
----------------------
Dirus: Fixed a bug that prevented people who use UDP from getting sources from those with complete files.

----------------------
- December 22th, 2002-
----------------------
Unk: Changing max source per file bug fixed.
Unk: Highest and Release priority bug fixed.
Unk: Search results added to a search list with no tab fixed.
Unk: Some of the connection statistics wasn't updated while not in the statistic window.. Fixed.
Dirus: Made source exchange use compression more aggressively.
 
----------------------
- December 20th, 2002-
----------------------
Dirus: Fixed crash due to stopped/canceled file corrupting the download list controller and the shared file list.
Dirus: Partial fix for preventing ourselves from being readded to a sourcelist when someone sends us back as a source.  (some code by Lord KiRon)
Ornis: Connectionattempts restart when reaching the serverlist-end
Ornis: Added statistics: Clientversions (# of clients using the 4 latest edonkey-/emule-versions) [xrmb] ; server occupation (% of userload on servers with known userlimit)

----------------------
- December 19th, 2002-
----------------------
Dirus: Fixed crash that can occur from a corrupted part.met file.
Dirus: Accepted fix for possible garbage displayed in labels when run with multibyte character set. (by pooz)


v0.24a
----------------------
- December 16th, 2002-
----------------------
Unk: Friend Upload Slots can now be toggled on/off..
Dirus: Fixed a bug that prevent source sharing from working until you had at least one complete part of the file!

----------------------
- December 15th, 2002-
----------------------
Unk: Smart LowId check now helps you keep that HighID when disconnected.
Unk: Safe connect option. (eDonkey style connect.)
Unk: Resumes collecting sources on reconnect.
Dirus: Fixed bug that caused column order to be loaded incorrectly.
Dirus: Fixed bug that could cause crash if invalid table values were manually written to the ini.
Dirus: Fixed bug that prevented source sharing packets from being compressed.
Dirus: Clients with complete files can now also share sources; a source list is built from their upload queue.  (An even more intelligent means of picking sources from upload queue will be included in a later version.)

----------------------
- December 13th, 2002-
----------------------
Dirus: The part.met files are now backed up before being replaced.  The backup files are deleted when new part.met has been written to disk and safely closed.  When loading part.met files we now also check for part.met.backup.
Juanjo: File comment and rating [Thanks to pitap for some code]
Unk: Main screen now shows Users and Files of the server your on.. It also shows a very loose estimate of all Users and Files in the Ed2k network.
Juanjo: Close buttons in search tabs [enkeyDev]
Ornis: Added [eMule+] idea of Sources-Sorting by QueueRating.
Unk/Dirus/Ornis: You can now manually add friends.
Unk: Irc: Some changes to the interface.
Unk: Irc: If another eMule client is in a channel, you can add him as friend.
Unk: Up/Down ration is now the same as eDonkey..
Unk: Several bug and gui fixes. Merged some code from Mods..

----------------------
- December 12th, 2002-
----------------------
Unk: Getting booted from Lugdunum servers due to LowID during is now handled better..
Unk: Using the Wizard did not update the statistic graphs correctly.. Fixed.. 
Unk: Found the LowIP problem after first connect..

----------------------
- December 9th, 2002-
----------------------
Juanjo: Added "List files" to the sources context menus

----------------------
- December 7th, 2002-
----------------------
Unk: Upcomming servers will have a new ServerStatus packet that will be incompatable with previous eMules.. Fixed.
Unk: Added a Max Users to the server list.
Unk: Connection failures to servers should now report the correct error.
Unk: Irc: Channel Tabs got confused when leaving channels.. Fixed.
Dirus: Fixed bug that caused program to leak some resources (GID Objects)

----------------------
- December 5th, 2002-
----------------------
Ornis: New Serverconnecting handling - more reasonable order to connect to servers
Ornis: Pending serverconnection-attempts will be discarded after a timeout to prevent everlasting hanging connection attempts
Ornis: Preferences: Added configuration for maximal new connections per 5 seconds
Juanjo: Added autopriority patch [Thanks to Tarod]


v0.23b
----------------------
- November 30th, 2002-
----------------------
Juanjo: Fixed: when changing between windows without using the toolbar (context menus or taskbar notifier) the toolbar buttons state are not updated
Juanjo: Added support for multiple backup urls in addresses.dat  [Thanks COOLER[T]]
Juanjo: Fixed bug when adding files to download from the search results and the temp directory is inexistent

----------------------
- November 29th, 2002-
----------------------
Juanjo: Group of sources can be appended to ed2k links [Thanks Linearcity] this is the extended edk url format:
                ed2k://|file|fname|size|hash|/|sources@expiration,src1ip:src1port,src2ip:src2port,...|/
                "@expiration" is optional: e.g. @021126 (YY,MM,DD) - always 6 digits
Juanjo: Fixed issue with multiple instances
Juanjo: Added two new statistics values: top download value and top download average value
Dirus: HttpDownload now also accepts x-gzip encoding.
                
----------------------
- November 26th, 2002-
----------------------
Ornis: Added button in transferview, to switch between uploadlist and queuelist (title over the listcontrol)
Ornis: Added Patch in sharedfolderselection to mark multiple subfolders by Ctrl+Click on a folder-checkbox [by VQB]
Ornis: Fixed the disabled Speedselector on Systemmenue

----------------------
- November 25th, 2002-
----------------------
Juanjo: Avoid multiple instances of emule
Ornis:        UDP-Port is now configurable in the preferences (connection)
Ornis:        Ensures some more status-feedbacks be uptodate
Dirus:  Rewrote incoming part highlighted so it doesn't blink on slow or stalled downloads.

----------------------
- November 24th, 2002-
----------------------
Dirus: Added support for gzip encoding to serverlist-download

----------------------
- November 23rd, 2002-
----------------------
Dirus: IRC: Fixed bug where double clicking on empty users list caused a crash.

----------------------
- November 22th, 2002-
----------------------
Juanjo: Patch to show active chunks (yellow) for each downloading source [Cax2]
Juanjo: Patch to avoid saving 0/0 Download Upload Clients to Clients.met [sulamidor]
Juanjo: Several cpu-optimizations [Insh_Allah]
Ornis:         Addes some handling improvements to the searchwindow, like resultcount-display in search-tabs
Ornis:        Added an option to remove servers from staticserver-list [DonGato]
Ornis:  Now uses lowest free partfile number [InterCeptor]
Dirus:  Some more tweaks and optimizations for autosort.

----------------------
- November 21st, 2002-
----------------------
Unk: Irc: Fixed another crash bug when updating the channel list.
Unk: Irc: Removed SendLink and AddFriend popup menus to put in security mesures for next release.
Ornis: Fixed shifted columnheaders in the searchlist
Dirus: Added autosort to all lists.

----------------------
- November 20th, 2002-
----------------------
Unk: Added a connection wizard in the preference's connection tab.. Win98 users having problems need to use this..
Ornis: Reduced hashing files, when starting emule (tarod)
Ornis: various bugfixes (Insh_Allah) - fixed memleaks, buffer overruns, incomplete initialations, bad memoryaccess

----------------------
- November 19th, 2002-
----------------------
Unk: Asked count is reset when a client reenters the queue to avoid confusion.
Unk: Small tweak to the queue list refresh function to better handle evil clients.

----------------------
- November 17th, 2002-
----------------------
Dirus: Download list has autosort, code is in place to autosort other lists.
Unk: The HyperTextCtrl buffer wasn't able to handle the large amount of text caused by busy IRC channels which cause the channel's text to become unreadable.. Fixed..
Unk: Irc: Added a preference to ignore all info messages so you can see through all the clutter in a channel.
Unk: Irc: Increased font size so those at 1024X768+ didn't need a magnifying glass to read the text. :)
Unk: Asked count is reset when a client reenters the queue to avoid confusion.
Unk: Small tweak to the queue list refresh function to better handle evil clients.

----------------------
- November 16th, 2002-
----------------------
Unk: Upload prioity is now saved for files currently being downloaded.
Ornis: Added quick-Speedselector (xrmb +) to systray-popupmenu and systemmenu
Ornis: Fixed bug concerning column-handling at save&restoring

----------------------
- November 15th, 2002-
----------------------
Ornis: Option to start emule minimized
Ornis: Fixed 2 bugs concerning sorting downloadlist by progress
Ornis: Stats: Fixed function and enabled slider in the stats-preferences to change the duration of the average graphs
Ornis: Stats: Graphcolors are now selectable (using RGB-values)
Unk: Changed tranfered data in shared files to support 4GB+..

----------------------
- November 14th, 2002-
----------------------
Ornis: Added mousecontrol to the Sourcefilenames-List in Filedetailsdialog

----------------------
- November 13th, 2002-
----------------------
Dirus: Added a warning for windows 9X/ME users who set their max connections to high.
Unk: Irc:Added support so that two eMule clients can directly send ed2k links to each other.
Ornis: Show counts of Filenames at sources in the filedetails (Juanjo)
Ornis: Renaming filename of downloads (in filedetails) & cleanup name (. _ %20 leading caps)
Ornis: Copy Serverlink in popupmenu of the serverlist (Interceptor)

----------------------
- November 12th, 2002- (nice date)
----------------------
Ornis: Show filetype in Sharedfiles-list
Ornis: Tabs in preferences now translated (Interceptor)

----------------------
- November 11th, 2002-
----------------------
Unk: Irc:Fixed the nick already used when logging in bug.
Unk: Irc:Preference now has: Server, Nick, Perform, Load Serverlist, Serverlist Filters. ( Perform example: "/msg nickserv identify | /join #emule" )
Unk: Irc:You can now use /msg nickserv and /msg chanserv...
Unk: Irc:Hyperlinks now work in a Notice and Info message.
Unk: Irc:The Strip Color function could crash with some strings.
Unk: Irc:The % char is now handled correctly.
Unk: Irc:Ready for the friends list.
Unk: Irc:Channels are now Tabs.

----------------------
- November 10th, 2002-
----------------------
Dirus: Preview now works with extensions longer than 3 characters, fixed other minor issues related to extension length.
Dirus: Fixed bug where previewed file was not deleted when unable to spawn associated program.

----------------------
- November 8th, 2002-
----------------------
Dirus: Download list now also has draggable columns.
Dirus: Increased accuracy of percent completed from int8 to float.

----------------------
- November 7th, 2002-
----------------------
Dirus: Files with duplicate names are now saved correctly after download.

----------------------
- November 6th, 2002-
----------------------
Dirus: Arrays are stored on 1 line in the ini.
Dirus: size, position, and hidden status of all tables are now saved.

----------------------
- November 3rd, 2002-
----------------------
Unk: Added a IRC client (With help from Merkur)
Unk: HyperTextCtrl now detects ed2k://
Unk: Some server were deleted even when the option was unchecked.
Ornis: Added preferences tab for statistics-setup
Ornis: Number in front of sources-count now gives the real useful-sources count (onqueue+downloading sources)

----------------------
- Oktober 31st, 2002-
----------------------
Dirus: Added support for "double arrows" (for 3 columns of shared-files list)
Dirus: Small visual changes, download list can now hide/show columns.
Ornis: Added export of Online Signature (by Bouc7)
Ornis: Added logmessage when sharedfiles-list is requested

----------------------
- Oktober 30th, 2002-
----------------------
Dirus: Update all column headers on language change (thanks to InterCeptor for the idea).  Also, server list window will now localize.
Dirus: Added more colors to search results to indicate downloading file and already downloaded file (had to rewrite code but thanks to Amdribant for the idea).
Ornis: Downloads running out of diskspace can now be resumed without restart

----------------------
- Oktober 29th, 2002-
----------------------
Dirus: Added hide/show columns to all lists except download.  Use by right clicking on column header.
Ornis: Fixed changing userhash
Ornis: Fixed adding Serverlink at startup (Cax2)

----------------------
- Oktober 28th, 2002-
----------------------
Dirus: Fixed a tooltip divide by 0 bug due to availability calculation in the transfer window

----------------------
- Oktober 26th, 2002-
----------------------
Dirus: Added new icon for unknown sources.
Dirus: All lists except download list now have draggable column headers.
Ornis: fixed using Translations to work on Win9x

----------------------
- Oktober 25th, 2002-
----------------------
Dirus: Changed appearance of all lists except download list, also added sort arrows for all of them.  Changed icons in all lists to be theme friendly, background color now matches.  Got rid of CIconList as it was no longer needed (it was a hack anyway).
Unk: Cleaned up some of the statistic code and added some stats.

----------------------
- Oktober 24th, 2002-
----------------------
Unk: Some internal changes.. Servers now only use listname(Removed realname). Removed availible column in the search(It was a duplicate of sources). That freaking staticserver was still overwriten by a server.met.. Fixed. The Ban count was redone so it will not mess up anymore.
Unk/Dirus: Now updates server name and description at connect.. (Cax2)(Merkur didn't like the code, so it may need cleaned up..)

----------------------
- Oktober 20th, 2002-
----------------------
Unk: Sorting the server list now supports dynamic ips. Sorting by description works better. All sorts are no longer case sensitive.
Unk: Added some network statistics.
Unk: If you add a server from a server.met url or manually and it's already in the list, the name and desctiption is updated.
Ornis: Added button to reset the log

----------------------
- Oktober 19th, 2002-
----------------------
Unk: Added a "upload time" column to the upload list..
Unk: The server list now has a few save points. Also, servers were deleted with fewer failures directly after connecting then while connected, fixed.
Unk: You can now do multiple searches.
Unk: You can now unban a person in the upload queue.. (Unless Merkur doesn't like it and deletes it.. :)
Unk: Small patch to the static servers. No longer over written with autoupdate and you can use a "," or a ":". (dongato)
Ornis: new average graph for the transfer-rates, calculated over time (5mins default)

----------------------
- Oktober 18th, 2002-
----------------------
Unk: Added a "Entered Queue" column for the queue list. Asked count now continues to count for banned users.
Unk: More server statistics.
Ornis: Show number of available parts of a download and keeps the last date when all parts has been available

----------------------
- Oktober 17th, 2002-
----------------------
Dirus: Downloadlist:improved drawing of the sources, general list-behaviour and sorting
Ornis: new statistic values and new columns for the shared-folder list (4phase sorting) which is now autoupdating
Ornis: Language support improved. Supporting sublanguages now and hopefully working on all systems.
----------------------
- Oktober 14th, 2002-
----------------------
Merkur: several bugfixes were added/merged

----------------------
- Oktober 12th, 2002-
----------------------
Unk: You can now sort the Queue and Upload list.
Unk: Very Low priority bug fixed.
Merkur: localized all dialogs
Merkur:        Upload spikes should be reduced
Merkur: dead clients are deleted form your uploadlist properly now
Merkur: Added a preview function which allows you to preview movies. Read the FAQ for more informations

----------------------
- Oktober 10th, 2002-
----------------------
Unk: Fixed a bug with when you cancel multiple downloads.. (CML)
Ornis: main-preferences are now stored in an .ini -file. -> more compatibility for coming versions
Ornis: localized emule-output of messages. Thanks to various translators for translating the text itself:)

----------------------
- Oktober 09th, 2002-
----------------------
Unk: The gui no longer lags as much when a lot of server are deleted.
Unk: You can now switch between the upload list and the queue list in the transfer window. (Based on Bouc7)
tecxx: updated tooltip info texts
tecxx: added upload priority, finally.
tecxx: added "staticservers.dat" file. file will be loaded at startup and includes your standard servers you always want to have in the list. format: "host:port,Servername"

----------------------
- Oktober 07th, 2002-
----------------------
Unk: Reworked a little with how servers are maintained internallly, hopefully no more crashes when deleting servers..
Unk: Tweaked how server stats are aquired.
Unk: Priority now works when connecting to servers and dead server are now removed while connected instead of only directly after connecting.

----------------------
- Oktober 03rd, 2002-
----------------------
pach2: fixed the ed2k link creation, copy to clipboard feature (added missing / at the end of links)
pach2: added traces for some socket operations (debug build only)
Ornis: fixed a crashbug at shutdown with selected searchresults
Ornis: Added multiselection to searchresults
Ornis: Added multiselection to serverlist (multi-server-removal & try connecting to selected servers)
Ornis: Added stop-connecting-function to the connectbutton
Ornis: Shared-files-list made sortable
tecxx: added a tooltip control to the download & upload windows currently displaying the filename of the client u r loading from, more info will be added.
Merkur: Adjusted the antiagressive clientsystem to be less aggressive. Also banned clients are unbanned after 5 hours
Merkur: fixed some (crash)bugs and memleaks 

----------------------
- Oktober 02nd, 2002-
----------------------
Ornis: Added Transferdialog-Splitbar to resize Download/Uploadwindow
Ornis: Fixed GDI Memleak
Ornis: new statistic values: "Time Since First Transfer","Reconnects","Connected To Server Since","Transfer Ratio","Clientversions"
Ornis: Changed: Up/Down Graphs show 4 additional kB/s than the specified capacities (to see peaks)
Ornis: Added: File-Detaildialog for downloads
Merkur: fixed a UDP bug which caused that some incoming packets were ignored
Merkur: adjusted the creditsystem formula

----------------------
- Oktober 01st, 2002-
----------------------
tecxx: hopefully solved the issues with the shared files selector on w9x. thanks LOVELACE from the board!
tecxx: added gui code in shared files window to set permission and priority levels
tecxx: emule now responds to "view shared files" command in edonkey friendslists, it shows only files based on permission settings

----------------------
- September 30th, 2002-
----------------------
Unk: Outgoing udp packets was sometimes sent to the wrong port.
Unk: Detecting dead servers was buggy.

----------------------
- September 28th, 2002-
----------------------
pach2: Fixed the following problem:
 Description: When i download this link ed2k://|file|HL_CS_english_retail.iso|462401536|78b84dd256bde2fe9f4cdccea2868208|
                      via the search menu, emule tells me "invalid link" and CRASHES. when i download the link via START - RUN all is fine.
Ornis: Added file category-selection to search
Ornis: added option: "filter invalid IPs" in preferences
Merkur: added Splashscreen (thanks to DRSirius for the image) and fixed some bugs
Unk: Servers Stats are now recieved when a server is added..
Unk: Fixed a memleak that was created when trying to search servers when not connected.. Also corrected a couple opcodes for the serverlist. 
----------------------
- September 27th, 2002-
----------------------
tecxx: added "create ed2k link" feature (incl. html version) to download, shared files and search lists.
Merkur: you can now use addresses like myserver.dyndns.net instead of IPs for server. Server admins please read the faq(http://....) to learn how to automatically assign an address to your server when an emule client connects.
Ornis: added separat statistic window
Ornis: filtering bad servers extended to filter more invalid IP-ranges
Ornis: more options in preferences: prompt on exit, number of failed retries to connect a server before removing it


----------------------
- September 26th, 2002-
----------------------
Merkur: The anti aggressive client system is working now. read the faq to learn more about it (http://...)
Merkur: rewrote some parts of the networkcode, this shouldn't have any effects for the enduser though


----------------------
- September 23th, 2002-
----------------------
Merkur: Added a webbased-search option via filedonkey.com
Ornis: various interface tweaks, restoring program-window & download listcolumns,more keyboard support, ESC minimizes...


----------------------
- September 21th, 2002-
----------------------
Merkur: the new antiaggressive-client system seems to have some serious bugs and is disabled for now. It will be back in 0.20 when it is fixed & tested
Unk: Server list changed from a tree to a list. ( Based on MrFry code)
Unk: Server list now updates users and files information from connected server.
Unk: Mark and Delete server preference now works. (Only during the connection process)
Unk: Tweaked the queue so that it now skips dead clients.
Unk: Added Max source per file option. eMule will also back off the servers while a file is close to this value.
Unk: Opera should no longer have the %20 problem.
Unk: 0.0.0.0 IPs no longer added to server list.
Unk: Timestamp to log entries. (Ornis+)
Unk: Download list now has Status and Time remaining (Ornis+)(CML)
Unk: Completed and shared files can now be opened.. (CML)
Unk: Server list is now saved.
pach2: ed2k://|server| pseudo-URL links are now handled and added to server list


----------------------
- September 20th, 2002-
----------------------
Merkur: my new coded socketclass didn't worked too well and needs to be rewritten again (which takes a lot time) but I made some changes to the current networkcode in order to avoid the crashbug and it seems to work. So hopefully emule should run more stable now
Merkur: Fixed a bug which caused all partfiles to be unshared when using the reload button
Merkur: emule should now pay more attention to the Max_Connections setting
Merkur: The creditsystem does not use a part of the IP as userkey anymore
Merkur: emule detects "aggressive" clients, which reask too often for a file and bans them (for the current session)
Merkur: some other bugs are fixed

----------------------
- September 19th, 2002-
----------------------
Unk: Servers with same IP but different Ports are now valid.
Unk: Small tweak to the add client's server to serverlist option.
Unk: Moved some messageboxes to the window log to avoid issues.

----------------------
- September 17th, 2002-
----------------------
tecxx: 2 fixes by TALAN(icq) - fixed problems when resizing downloadwindow

----------------------
- September 16th, 2002-
----------------------
tecxx: implemented new shared files selector
tecxx: new option: add server's serverlist. if active, emule asks the server for a list of know servers right after a successful connection
tecxx: new option: add client's server to serverlist. if active, emule adds the server ip and port of a connecting client to the serverlist
tecxx: fixed single server remove crash
tecxx: added multiselect code in download window (thanks to Mr.Fry from the board!)

----------------------
- September 14th, 2002-
----------------------

Merkur: implemented a new about dialog.. no it still doesn't show your id, but it looks way better ;)
Merkur: Finally the new credit system is in. Basically clients which uploaded to you will get a higher priority. Check the FAQ (emule-project.net) for a detailed description. A client with a yellow symbol in your uploadlist means that this client is prefered because of the credit system. You can check the detailed info screen to get more infos about his credits. However it's in the testing stage atm and probably some values will be adjusted later

Merkur: shared files now have a statistic, which will show you how often a files was requested, accepted and how much bytes you uploaded.
Merkur: partfiles are now "writeprotected" while emule runs, so you can't mess them (and cause errors) by  reading/writing them with another application.
Merkur: emule won't crash with a "out of memory" message anymore if it reads a corrupted .met file
Merkur: Fixed some bugs. Hopefully emule will run more stable now. Check for a "b" version in the next days, which will be released of any critical bug will be found in 0.19a (of course we test version before releasing them, but you knwo its impossible to find all bugs)

----------------------
- September 11th, 2002-
----------------------
tecxx: shared files: added a reload button
tecxx: serverwnd.cpp - fixed problem when adding server with 5-digit port number
tecxx: download control now displays "Complete" when download is completed.
tecxx: invalid characters like < " and ? are now removed from completed files
tecxx: added 3 options: remove server, remove all servers and add external server.met
tecxx: added a tracker mechanism to keep track of opened/closed server-connect sockets
tecxx: "add server" function now checks if server is already in list
tecxx: fixed 2 small memleaks

----------------------
- September 10th, 2002-
----------------------
(0.18b "Hotfix" ;) )
Merkur: Fixed a critical bug which caused the client to drop all compressed packets (with the message: Corrupted compressed packet for X received)
Merkur: Some other bugs are fixed too

----------------------
- September 7th, 2002-
----------------------
Merkur: Added a first part of the eMule-Protocol. This protocol will offer several features, but will only work for clients which are supporting this protocol (atm only emule v0.18 and higher). The download and uploadwindow will show an icon with a green "+" on clients which are supporting this protocol.

Merkur: (eprot only) Files are now send in compressed packets. Depending on the file you are downloading this will reduce the downloadsize by (estaminated):
0%        zip/ace/rar         and other archives. These files are sent unpacked (because they are already max. compressed)
2-15%        bin/avi/mp3         these files are already compressed very often, however a moderate-small size reduction is possible
15%-?        unpacked files        the size of unpacked files can be greatly reduced, however it doesn't happen that often that you download a unpacked file
Another advantage of compression is, that compressed packets are checked for transfer errors. That means emule will recognize a corrupted packet and you have to redownload 180KB instead of 10MB.
However everything has a downside: Compression needs some CPU time but you shouldn't notice it.
NOTE: This also means that it can happen that a file is finished before "transfered" has reached the filesize. this is no bug.

Merkur: (eprot only) you can now see which rank you have on the uploadqueue of of sources. It's shown in the downloadwindow/priority tab.
Merkur/mbobka : emule crashed/frezzed somtimes while completing files. This should hopefully be fixed. We are working on all bugs (especially on crashbugs). Please be patient :)
Merkur: Added a autoconnect on startup option


----------------------
- September 4th, 2002-
----------------------
Merkur:  If a servermessage contains a link (http, www, email etc) emule will make this link clickable. So if you click on this link you will browse to this site/open your mailprogramm etc. ED2K links are not clickable yet.
Merkur:  emule should pay more attention to the downloadlimit now
Merkur:  due to popular demand I changed the global search: the global search will not start untill your server gave a respond. This will slow down global searches a bit, but will avoid server-overhead.
Merkur:  some bugs are fixed. however there are still many bugs, which I wasn't able to dectect yet. So if eMule crashes on your PC please use the Debug version and send me a bugreport (read the debug.txt)
Merkur:  adresses.dat now doesn't contain any serverlist anymore. Maurices serverlist was for testing only, however quite a few ppl are using emule now which will cause lots of traffic. Of course you can still paste the serverlist of your choice into adresses.dat.
If you want to support eMule with a (good) serverlist-mirrow/generator which will be used as emules standart serverlist then mail me.

----------------------
- September 3th, 2002-
----------------------
Merkur:  Added clientdetails (right click on any client and select show details)
Merkur:  You can pause & stop files now. Pause means emule tells its sources source to stop downloading but keeps them. Stop will delete all sources. Other than that pause & stop are equal. NOTE: pausing a download and resume it WILL NOT SPEED UP ANYTHING. This is not edonkey
Merkur:  You can clear completed files from your downloadlist.

----------------------
- September 2th, 2002-
----------------------
Merkur:  optional emule will minimize to a systemtray icon
Merkur:  the statusbar shows you if you have a low or high ID: if the connected icon has yellow arrows you have a low id, if it has green arrows you have a high id.
  (BTW: keep in mind that low id's a VERY bad for emule at this point, because not all low id functions are implemented)
Merkur:  you can now connect to a certain server (right click on the serverlist)
Merkur:  there is a new emule Debug version. If emule crashes on your pc and you want to help to resolve this by sending a bugreport, then please download the debug version. Read the debug.txt for more informations.

----------------------
- September 1th, 2002-
----------------------
Merkur:  ED2k link were bugged and a wrong fileid was given to emule. this is fixed now
Merkur:  fixed a interface bug (http://sf.net/tracker/index.php?func=detail&aid=602996&group_id=53489&atid=470504)
Merkur:  added a small feature request (http://sf.net/tracker/index.php?func=detail&aid=603008&group_id=53489&atid=470507)
Merkur:  canceling files could cause a crash

--------------------
- August 31th, 2002-
--------------------
Merkur:  emule now supports ED2K filelinks :) You can click links in your browser (like edonkey) or enter them directly on the search page to add a new file.
Merkur:  if a client asks for a part file and is not known as a source for this partfile he will be asked & added
Merkur:  rewrote udp search
Merkur:  file priority works. Keep in mind that priorities are relativ. That means if you are downloading 10 files and set them all to high prio, it would have the same effect as if you would set them all to low priority. However if you set one of this ten files to high priority then this file will probably get more sources.

--------------------
- August 30th, 2002-
--------------------
Merkur:  the eMule window is now maximize- and resizeable (thanks to Paolo Messina, who coded a usesful resize-library)

--------------------
- August 28th, 2002-
--------------------
Merkur:  you are now able to send and receive messages
Merkur:  as alwasy some other bugs are fixed (and probably some new introduced) (tm)

--------------------
- August 25th, 2002-
--------------------
Merkur:  emule will download the first and last two parts from movies first (if possible) to make it easier to preview movies. (but don't touch part files while emule is running!) 

--------------------
- August 24th, 2002-
--------------------
Merkur:  fixed a problem with downloading files which are smaller than 10MB

--------------------
- August 22th, 2002-
--------------------
Merkur:  fixed some (crash) bugs. emule should be quite stable now. At least it didn't crashed in my longtime tests :)

--------------------
- August 21th, 2002-
--------------------
Merkur:  fixed a bug which caused problems with completing files (actually it was impossible)
Merkur:  New Feature: Intelligent Corruption Handling - ICH (first stage). This should reduce the average (re)download size of corrupted parts form 10 MB (one full part) to 5 MB. However it needs some CPU time, so if you have a very fast connection (LAN for exmample) you should disable this.
Merkur:  New Feature: Autoupdate serverlist. If you activate this (on your preferences screen) emule will download a new serverlist at startup. You can set the downloadadress in "adresses.dat". ATM it uses maurice's serverlist - please change this to your favorite serverlistadress :)
Merkur:  fixed some minor memory leaks. emule is leakfree atm ;)
Merkur:  as alwasy some minor bugs are fixed (and probably some new introduced ;) )

--------------------
- August 20th, 2002-
--------------------
Merkur:  fixed more bugs (more crashbugs, some protocol errors and misc bugs :) )
Merkur:  fixed a huge memoryleak which was introduced in version 0.1a or 0.1b. However there is still a small memoryleak, which I wasn't able to track down yet, it should be fixed in the next version though
Merkur:  you can now sort searchresults and downloads (/clients)


--------------------
- August 19th, 2002-
--------------------
Merkur:  fixed several bugs (most of them crashed emule)

--------------------
- August 17th, 2002-
--------------------
Merkur:  Download is working now
Merkur:  You can now cancel a downloading file
Merkur:  some bugs and many other small things fixed

--------------------
- August 15th, 2002-
--------------------
Merkur:  the downloadwindow should be flicker free now
Merkur:  serverstatus (users & files) is displayed

--------------------
- August 14th, 2002-
--------------------
Merkur:  After eMule found about 1000 sources for a file in my tests I deceided to implement the Max-Connections Setting.

--------------------
- August 13th, 2002-
--------------------
Merkur:  you can now connect to low ip clients (but you still need a high id)
Merkur:  looking for sources on your server works. UDP source-lookup is in too now
Merkur:  you can start downloading something from your searchlist (however download-transfer is not in yet)
Merkur:  source part status is in and displayed
Merkur:  fixed some bad crash bugs
Merkur:  fixed some memoryleaks

--------------------
- August 9th, 2002 -
--------------------
Merkur:  part files are now shared and other edonkey clients are able to download parts
Merkur:  uploading clients will be kicked after some time to allow other clients to download (depends on score of the uploading client und the clients in queue.. in general (without any factors) it should be ~ 15 min

--------------------
- August 8th, 2002 -
--------------------
Merkur:  finished the progressbar for downloading files
Merkur:  fixed a bug in uploadwindow which showed wrong informations sometimes
Merkur:  searchlist will now paint frequent files blue (like edonkey does)

--------------------
- August 5th, 2002 -
--------------------
Merkur:  emule can now read & check part.met files
Merkur:  some code cleanups & some minor bugs fixed

--------------------
- August 4th, 2002 -
--------------------
Merkur:  Implemented basic upload abilities. However it's not complete yet and only high-ID to high-ID transfer is possible in most cases.

--------------------
- July 31th, 2002  -
--------------------
Merkur:  fixed a bug with fileids (checksum was wrong sometimes)

--------------------
- July 7th, 2002   -
--------------------
Merkur:  first (source only) Release
